function  x = babylon2num(s)
% x = babylon2num(s)
% Wandlung des Strings mit der eindimensionalen babylonischen 
% Zahlendarstellung im Sexagesimalsystem in die Zahl x.
% Symbol fr den Einer ist 1;  Symbol fr den Zehner ist < .
% Die Null wird nicht notiert, muss aber durch ein zustzliches 
% blank angegeben sein, damit die Mehrdeutigkeit des Babylonischen 
% Systems hier nicht zu Fehlern fhrt.

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

n = length(s);
j = n;
while j>0 & s(j)==' '
   j = j - 1;
   s = s(1:j); 
end
if length(s)==0  z = 0; end
k = 1;
while length(s)>0
   zz = 0;
   s1 = s(1);
   s  = s(2:end);
   while s1~=' '
      if s1=='<' zz = zz + 10; end
      if s1=='1' zz = zz + 1;  end
      if length(s)>0
         s1 = s(1);
         s  = s(2:end);
      else
         s1 = ' ';
      end
   end
   if zz==0  s = s(2:end); end
   z(k) = zz;
   k = k + 1;
end

x = (sum(reverse(z).*60.^(0:length(z)-1)))*60^(n-j);

if x>2^53  warning('babylon2num: die babylonisch dargestellte Zahl kann Rechner-intern nicht genau reprsentiert werden'); end

if ~nargout  result2fig(num2str(x)); end

