function bcomplementfcn(k)
% bcomplementfcn(k)
% CallBack-Funktion fr bcomplement

cfg = gcf;
udf = get(cfg,'UserData');
cbo = gcbo;
q0  = udf.q;
n0  = udf.n;
m0  = udf.m;

% Prfung der Eingabe und Eintragung der nderungen in dat
% ========================================================
switch k
   case 1                          % Eingabe der Basis
      qstr = get(cbo,'String');
      chk  = checkchar(qstr,'0123456789');
      if chk==0
         eval(['q=' qstr ';']);
         chk = (q<2) | (q>64);
         if chk==0  
            udf.q = str2num(qstr); 
            udf.m = floor((q^n0 - 1)/2);
            strm  = num2str(udf.m);
            if length(strm)>2  strm = ''; end
            set(udf.uihandles(3),'String',strm)
         end
      end
      if chk
         sound(sin(2*pi*1000/8000*(0:1000)),8000); 
         set(cbo,'String',num2str(q0));
         return
      end
   case 2                          % Eingabe der Stellenzahl
      nstr = get(cbo,'String');
      chk  = checkchar(nstr,'0123456789');
      if chk==0
         eval(['n=' nstr ';']);
         chk = (n<1) | (n>5);
         if chk==0  
            udf.n = str2num(nstr); 
            udf.m = floor((q0^n - 1)/2);
            strm  = num2str(udf.m);
            if length(strm)>2  strm = ''; end
            set(udf.uihandles(3),'String',strm)
        end
      end
      if chk
         sound(sin(2*pi*1000/8000*(0:1000)),8000); 
         set(cbo,'String',num2str(n0));
         return
      end
   case 3                          % Eingabe der maximalen positiven Zahl
      mstr = get(cbo,'String');
      chk  = checkchar(mstr,'0123456789');
      if chk==0
         eval(['m=' mstr ';']);
         chk = m<0;
         if chk==0  udf.m = str2num(mstr); end
      end
      if chk
         sound(sin(2*pi*1000/8000*(0:1000)),8000); 
         set(cbo,'String',num2str(m0));
         return
      end
end
set(cfg,'UserData',udf)
q = udf.q;
n = udf.n;
m = udf.m;

% Zahlenfelder neu bestimmen
% ==========================
for k=0:length(udf.rephandles)-1
   str = num2basstr(k,q,n);
   set(udf.rephandles(k+1),'String',num2basstr(k,q,12))
   set(udf.infhandles(k+1),'String',num2str(bcomplstr2num(str(end-n+1:end),q,m)))        
end

% Helle Felder neu bestimmen
% ==========================
thr  = udf.rephandles;
ph   = udf.pathandles;
ext0 = get(thr(1),'Extent')
extk = get(thr(min(33,q^n)),'Extent');
expx = get(ph(1),'XData')
expy = get(ph(1),'YData')
expx([1,4]) = ext0(1) + ext0(3) - n*ext0(3)/12;
expx([2,3]) = ext0(1) + ext0(3);
expy([3,4]) = extk(2) + extk(4);
set(ph(1),'XData',expx,'YData',expy)
ppos = [0  0.54];                                % x-Position der grauen Patches
%dx   = 0.038;
dy   = 0.0596;
yu   = -1+0.02;
yo   = yu + (q^n)*dy;
%ppos2= [ppos(1)-0.05-n*dx  ppos(1)-0.02  yu  yo;
ppos2= [0 0 0 0;
        ppos(2)+0.02       ppos(2)+0.2   yu  yo];
set(udf.pathandles(2),'XData',[ppos2(2,1) ppos2(2,2) ppos2(2,2) ppos2(2,1)],...
                      'YData',[ppos2(2,3) ppos2(2,3) ppos2(2,4) ppos2(2,4)])
