function str = bincellout(x)
% bincellout(x)
% Wandlung der Binrmatrix x in einen Ausgabestring.
% Jede Zahl > 0 wird als 1 interpretiert und sonst als 0.
% x kann auch ein als Cell-Array realisierter Binrbaum
% von solchen Matrizen sein. Dann werden alle Bltter 
% ausgegeben.

% Autor:  K. v. d. Heide,  e-mail:  v.d.heide@on-line.de

if iscell(x)
   str = strcat(bincellout(x{1}),sprintf('\n'),...
                bincellout(x{2}),sprintf('\n'));
else
   xsize = size(x);
   str = [];
   for m=1:xsize(1)
      for n=1:xsize(2) 
         str = strcat(str,sprintf('%d',x(m,n)>0)); 
      end
      str = strcat(str,sprintf('\n'));
   end
end