function  y = bindecod(x)
% y = bindecod(x)
% Binrdecodierer
% x  :   Binrvektor von n Bit
%        oder String aus "0" und "1"
% y  :   Binrvektor von 2^n Bit im 1-aus-2^n-Code
%        String aus "0" und "1", wenn x diesen Typ hat.
% Ist x eine m*n-Matrix, so werden die Zeilen decodiert 
% zu einer m*2^n-Matrix fr beide Typen.

% Autor:  Klaus von der Heide, e-mail:  v.d.heide@on-line.de

b = '01';
if ischar(x)  xx = ~(x=='0'); else xx = x; end
[m,n] = size(x);
for k=1:m
   yy(k,:) = zeros(1,2^n);
   yy(k,1+binvec2num(xx(k,:))) = 1;
   if ischar(x)   
      y(k,:) = b(1+yy(k,:)); 
   else 
      y(k,:) = yy(k,:); 
   end
end
