function s = binexpr2prefix(binexpr)
% s = binexpr2prefix(binexpr)
% Wandlung eines schaltalgebraischen Ausdrucks in Prfix-Notation.
%
% binexpr : String des vollstndig geklammerten schaltalgebraischen Ausdrucks 
%           in MATLAB-Syntax (berzhlige Klammern sind verboten)
%
% s    :    String des schaltalgebraischen Ausdrucks in MATLAB-Syntax.
%           AND wird als all, NAND als ~all, OR als any und NOR als ~any
%           in Prfix-Notation geschrieben.
%
% Beispiel: binexpr2prefix('~(~a|b)&c')  =>  ' all([ ~any([ ~a b]) c])'

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

s = tree2binexpr(binexpr2tree(binexpr));

if ~nargout
   Resultat = s;
   result2fig(Resultat)
end
