function x = binfcn(t,binvec,t0,dt)
% x = binfcn(t,binvec,t0,dt)
% Binres Signal der kontinuierlichen Variablen t mit 
% der Schrittlnge dt, das definiert ist durch den 
% Binrvektor binvec beginnend bei t0.
% Es ist  x = binvec(1) fr t < t0  und 
% x = binvec(end) fr t > t0+dt*length(binvec)
% Defaults sind:  t0 = 0;  dt = 1

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

if nargin<4  dt = 1; end
if nargin<3  t0 = 0; end
x = binvec(min(length(binvec),max(1,floor((t-t0)/dt))));