function x = bingausselim(a,r)
% x = bingausselim(a,r)
% Lsung des linearen Gleichungssystems  a*x = r  im GF(2)
% r kann Spaltenvektor oder Matrix sein.
% Wird r als eye(length(a)) gewhlt, so ist x die inverse
% Matrix zu a.

% Autor:  K. v. d. Heide,  e-mail:  v.d.heide@on-line.de

ar = [a r];
[n,m] = size(ar);

for k=1:n
   for j=k:n  if ar(j,k)  break; end; end
   if j==n & ar(n,k)==0  error('bingausselim: die Matrix ist singulr'); end
   ar([k j],:) = ar([j k],:);
   for i=k+1:n
      if ar(i,k)
         ar(i,:) = xor(ar(i,:),ar(k,:));
      end
   end
end

for k=n:-1:2
   for i=k-1:-1:1
      if ar(i,k)
         ar(i,:) = xor(ar(i,:),ar(k,:));
      end
   end
end

x = ar(:,n+1:m);

if ~nargout
   Resultat = x;
   result2fig(x)
end