function x = binomialsum(n,k,p)
% x = binomialsum(n,k,p)
% Summe ber alle Werte der Binomialverteilung von k bis n.
% Fr n>52 wird die Verteilung approximiert, und zwar durch
% eine Gaussverteilung, wenn  n*p<3 und n*(1-p)<3, andernfalls 
% erfolgt eine Approximation durch die Poisson-Verteilung.

% K. v. d. Heide,  e-mail:  v.d.heide@on-line.de

kk = k:n;
x  = 0;

if n>52
   if n*p<3
      for j = kk  
         x = x + ((n*p)^j)/prod(1:j) * exp(-n*p); 
      end
   elseif n*(1-p)<3
      for j = kk  
         x = x + ((n*(1-p))^(n-j))/prod(1:(n-j)) * exp(-n*(1-p));
      end
   else
      np = n*p;
      h  = 2*np*(1-p); 
      h  = max(h,eps);
      for j = kk  
         x = x + 1/sqrt(pi*h) * exp(-((j-np).^2)/h); 
      end
   end
else
   for j = kk  
      x = x + binko(n,j) * p^j * (1-p)^(n-j); 
   end   
end
