function s = binsignal(bits,n,jit,r)
% s = binsignal(bits,n,jit,r)
% Der Binrvektor bits wird auf das n-fache verlngert.
% Die Bitbergnge werden zufllig im Bereich +-jit/2 
% zeitlich versetzt.  Das Signal erhlt ein Rauschen 
% der Standardabweichung r.
% Ein FIR-Filter vom Grad 6 rundet das Signal ab.

jitter = round(jit*rand(length(bits))) - jit;

s = [];
for k=1:length(bits)-1
   s = [s ones(1,n-jit+jitter(k))*bits(k) ones(1,jit-jitter(k))*bits(k+1)];
end
s = [s  s(end)*ones(1,jit)];

b = fir1(6,0.3);
s = filter(b,1,s+r*randn(size(s)));
