function x = bintab2rm(tab)
% x = bintab2rm(tab)
% Transformation einer binren Funktionstabelle in den 
% binren Koeffizientenvektor der Reed-Muller-Form.
% Die Transformation ist zu sich selbst invers.

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Transformationsmatrix aufstellen
% ================================
n = length(tab);
A = 1;
Z = 0;
while n>1
   A = [A Z; A A];
   Z = [Z Z; Z Z];
   n = n/2;
end

% Transformation
% ==============
x = rem(A*tab',2)';