function ca = bintree(binexpr,variable)
% ca = bintree(binexpr,variable)
% Umsetzung des binralgebraischen Ausdrucks binexpr 
% mit den Variablen variable in ein CellArray fr das OBDD.
% Anstelle des Ausdrucks kann auch ein binrer Vektor der 
% Lnge 2^n mit der Funktionstabelle angegeben werden.
% Wird die Ausgabe nicht zugewiesen, so gibt es eine Graphik.
%
% binexpr  :  String fr den schaltalgebraischen Ausdruck
%             Beispiel:  '(a1|b) & (~a2|c) & b|c'
%
% variable :  Cell array mit den Variablen als Strings
%             Folgende Variablennamen sind nicht erlaubt:
%             jjjjj,kkkkk,ftab,binexpr,eval,sprintf,variable
%             sowie alle Schlsselwrter von MATLAB wie for, end, ...
%             Beispiel:  {'a1'; 'a2'; 'b'; 'c'}

% Autor:  Klaus von der Heide, e-mail:  v.d.heide@on-line.de

% Defaults
% ========
if nargin<2  variable = {'a';'b';'c';'d'};   end
if nargin<1   binexpr = '(a&c) | (~b&d&~c)'; end

% Entscheidungsbaum
% =================
ca = reducebintree(bintab2bintree(binexp2bintab(binexpr,variable)));

% Graphik
% =======
if nargout<1  bintreegraph(ca,variable); end