function [s,c] = carryselectadd(a,b,ci,q)
% [s,c] = carryselectadd(a,b,ci,q)
% Carry-Select-Addierer
% a, b :  Vektoren der Ziffern der Summanden, 
% c0   :  bertrag in die niederwertigste Stelle
% q    :  Basis des Systems, Default: 2
% s    :  Vektor der Ziffern der Summe.
%         s hat die selbe Anzahl von Stellen wie a und b.
% c    :  bertrag von der hchstwertigen Stelle.
%         c kann als hchstwertige Stelle dem Vektor s nachgestellt werden.

n = max(1,floor(length(a)/2));

% Simulation der parallelen Berechnung mit drei Addierern
% =======================================================
[sn,cn] = add(a(1:n),b(1:n),ci,q);         % niedere n Bit
[s0,c0] = add(a(n+1:end),b(n+1:end),0,q);  % hhere Bit fr Carryin = 0
[s1,c1] = add(a(n+1:end),b(n+1:end),1,q);  % hhere Bit fr Carryin = 1

% Selektion des richtigen Ergebnisses
% ===================================
if cn==0
   s = [sn s0];
   c = c0;
else
   s = [sn s1];
   c = c1;
end
