function b = checkkvmin(binexp,ftab,variable,na,no)
% b = checkkvmin(binexp,ftab,variable,na,no)
% berprfung der Minimierung mit dem KV-Diagramm:
% binexp   :  String mit dem zu prfenden Ausdruck in MATLAB-Syntax
% ftab     :  Funktionstabelle der zu realisierenden Schaltfunktion
% variable :  Cell array mit den Variablen als Strings
% na       :  Anzahl der UND-Verknpfungen des minimierten Ausdrucks
% no       :  Anzahl der ODER-Verknpfungen des minimierten Ausdrucks

% Autor:  Klaus von der Heide, e-mail:  v.d.heide@on-line.de

ft   = binexp2bintab(binexp,variable);
fok  = all((ft==ftab)|(ftab<0));
nar  = sum(binexp=='&');
nor  = sum(binexp=='|');

s = [];

if fok & nar<=na & nor<=no  
   s = sprintf('korrekte Lsung!');
   if nar<na | nor<no  s = [s  sprintf('\ndie Lsung ist besser als die Vergleichslsung!')]; end
   Resultat = s;
   result2fig(Resultat)
   return
end

if ~fok
   if isdisjunctive(binexp)
      s = sprintf('Wenigstens ein Einspunkt liegt ausserhalb \noder ein Nullpunkt innerhalb der Schleifen!');
   elseif isconjunctive(binexp)
      s = sprintf('Wenigstens ein Nullpunkt liegt ausserhalb \noder ein Einspunkt innerhalb der Schleifen!');
   end
end

if nar>na | nor>no
   s = [s  sprintf('\nDer Ausdruck kann weiter minimiert werden!')];
end

Resultat = s;
result2fig(Resultat)

