function  a = checknum(result,correct,tol)
% a = checknum(result,correct,tol)
% Prfung eines numerischen Resultates result auf bereinstimmung mit 
% einem korrekten Ergebnis correct im Rahmen der Toleranz tol.
% result, correct und tol knnen einzelne Werte, Vektoren oder Matrizen sein.
% Ist tol ein Wert, so gilt er fr alle Werte von correct.
% a ist ein String mit einem entsprechenden Kommentar bzw. ein leerer String.

% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de

[mc,nc] = size(correct);
[mr,nr] = size(result);
[mt,nt] = size(tol);

if mt~=mc | nt~=nc  tol = ones(mc,nc)*tol(1,1); end

if mc~=mr | nc~=nr  a = sprintf('die Dimension des Resultates ist falsch'); return; end

[i,j] = find(abs(result-correct)>tol);

if mc==1 & nc==1
   if length(i)>0  
      a = sprintf('der Wert ist nicht korrekt');
   else
      a = '';
   end   
else
   if mc==1
      switch length(i)
         case 0, a = '';
         case 1, a = sprintf('der Wert mit dem Index %2d ist nicht korrekt',i);
         case {2,3,4}
            a = sprintf('die Werte mit folgenden Indices sind nicht korrekt:');
            for k=1:length(i)  a = sprintf('%s  %2d',a,i(k)); end 
         otherwise,  a = sprintf('mehr als 4 Werte sind nicht korrekt');
      end
   else
      switch length(i)
         case 0, a = '';
         case 1, a = sprintf('der Wert an der Position (%2d,%2d) ist nicht korrekt',i,j);
         case {2,3,4}
            a = sprintf('die Werte an folgenden Positionen sind nicht korrekt:');
            for k=1:length(i)  a = sprintf('%s  (%2d,%2d)',a,i(k),j(k)); end 
         otherwise,  a = sprintf('mehr als 4 Werte sind nicht korrekt');
      end
   end
end