function  a = checkstruct(result,correct)
% a = checkstruct(result,correct)
% Prfung eines Resultates result auf bereinstimmung mit 
% einem korrekten Ergebnis correct bezglich der Struktur
% und des Elementtyps, jedoch nicht der Werte.

% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de

a = '';
[rm,rn] = size(result);
[cm,cn] = size(correct);
if rm~=cm | rn~=cn  a = sprintf('die Dimension ist falsch'); return; end

if isreal(correct) & isreal(result)  return; end
if ischar(correct) & ischar(result)  return; end

if (isreal(correct) & ~isreal(result)) | (ischar(correct) & ~ischar(result))
   a = sprintf('die Typen sind unterschiedlich'); 
   return; 
end

if iscell(correct)
   for i=1:cm
      a = cat(a,'\n',checkstruct(result{i},correct{i}));   
   end
elseif isstruct(correct)
   rnames = fieldnames(result);
   cnames = fieldnames(correct);
   for i=1:length(cnames)
      if ~ismember(cnames{i},rnames)  
         a = cat(a,'\n',sprintf('Feldname %s nicht vorhanden',cnames{i}));
      else
         a = checkstruct(eval(['result.',cnames{i}]),eval(['correct.',cnames{i}]));
      end
      if ~ismember(rnames{i},cnames)  
         a = cat(a,'\n',sprintf('Feldname %s zu viel',rnames{i}));
      end
   end
end