function rgb = color(n,h,m)
% rgb = color(n,h,m)
% Jeweils  64  RGB-Farbvektoren mit dem Index  n=1:64  fr 
% die Helligkeit  0<=h<=1  und die Farbpalette  m (m=1,2,3).
% Der Aufruf ohne Parameter liefert eine Farbgraphik.
% Ist n ein Indexvektor, so ist rgb die entsprechende 
% length(n)*3-Matrix.

if nargin<3  m = 1; end
if nargin<2  h = 1; end
if nargin<1
   figure;
   axes('Position',[0 0 1 1])
   for j=1:3
      for n=0:10 
         for k=1:64 
            patch(11*(j-1)+n+[1 2 2 1],k+[1 1 2 2],color(k,n/10,j)); 
         end
      end
   end  
   axis([1 34 1 65]); axis off  
end
for k=1:length(n)
   switch m
   case 1
      p = 2*pi*n(k)/64;
      rgb(k,:) = [1 1 1] - h*(1+[cos(p)  cos(p+2*pi/3)  cos(p+4*pi/3)])/2;
   case 2
      p = pi*n(k)/21;
      switch 1
         case n(k)<22, rgb(k,:) = [1 1 1] - h*(1+[cos(p)  cos(p+pi)  0])/2;
         case n(k)<44, rgb(k,:) = [1 1 1] - h*(1+[cos(p)  0  cos(p+pi)])/2;
         otherwise,    rgb(k,:) = [1 1 1] - h*(1+[0  cos(p)  cos(p+pi)])/2;
      end
   case 3
      p  = pi*(n(k)+44)/64;
      p1 = 3*p;
      p2 = 5*p;
      p3 = 7*p;
      rgb(k,:) = [1 1 1] - h*(1+[cos(p1)  cos(p2+2*pi/3)  cos(p3+4*pi/3)])/2;
   end
end
