function  y = crc(x,poly);
% y = crc(x,poly);
% Berechnung des CRC des Binrvektors x mit dem Polynom poly.
% x    :   Binrvektor
% poly :   Vektor der relevanten Exponenten des Polynoms
%          z.B. [16 12 5 0] fr x^16 + x^12 + x^5 + 1
%          Die Reihenfolge spielt keine Rolle.

% Autor: Klaus von der Heide,  e-mail:  v.d.heide@on-line.de

mp = max(poly);                % Lnge des Statusregisters
sr = zeros(1,mp);              % Reset des Statusregisters
p  = sr; p(mp-poly+1) = 1;     % Polynom
p  = p(2:end-1);               % Polynom ohne hchsten Term

for k=1:length(x)
   z  = xor(x(k),sr(1));
   sr = [xor(sr(2:end),p*z),z];
end

y = sr;