function demoieee754fcn(k)
% demoieee754fcn(k)
% CallBack-Funktion fr demoieee754

% Daten importieren
% =================
cfg  = gcf;
fud  = get(cfg,'UserData');
uih  = fud.handles;
ustr = fud.uistr;
upos = fud.uipos;
txh  = fud.txh;
datk = get(gcbo,'String');
type = get(uih(6),'Value');
switch type
   case 1
      n = 32;                                 % Wortlnge
      m  = 24;                                % Index des LSB des Exponenten;
   case 2
      n = 64;                                 % Wortlnge
      m  = 53;                                % Index des LSB des Exponenten;
   case 3
      n = 80;                                 % Wortlnge
      m  = 65;                                % Index des LSB des Exponenten;
end

% Prfung der Eingabe und Bercksichtigung der nderungen
% =======================================================
switch k
   case 1                                     % Zahl wurde gendert
      eval(['x=' datk '; chk=0;'],'chk=1')
      if chk==0
         ustr{1} = datk;
         w = ieee754(x,type);
         y = ieee754interpret(w);
         ustr{2} = w(1);
         ustr{3} = w(2:n-m+1);
         if isnan(y) | isinf(y) | type==3 | y==0
            ustr{4} = '';
         elseif str2num(ustr{3})
            ustr{4} = '1.'; 
         else 
            ustr{4} = '0.'; 
         end
         ustr{5} = w(n-m+2:end);
      end   
   case 2                                     % Vorzeichen gendert
      chk = checkchar(datk,'01');
      if length(datk)~=1  chk = 1; end
      if chk==0
         ustr{1} = num2str(abs(str2num(ustr{1})));
         if datk=='1' ustr{1} = ['-' ustr{1}]; end
         ustr{2} = datk(1);
      end
   case 3                                     % Exponent gendert
      chk = checkchar(datk,'01');
      if length(datk)~= n-m  chk = 1; end
      if chk==0
         ustr{3} = datk;   
      end
      ustr{1} = num2str(ieee754interpret([ustr{2} ustr{3} ustr{5}]));
   case 4
      error('Das Implizit-Feld sollte eigentlich nicht editierbar sein.')   
   case 5                                     % Mantisse gendert
      chk = checkchar(datk,'01');
      if length(datk)~= m-1  chk = 1; end
      if chk==0
         ustr{5} = datk;   
      end
      ustr{1} = num2str(ieee754interpret([ustr{2} ustr{3} ustr{5}]));
   case 6                                     % IEEE754-Format gewhlt
      type = get(uih(6),'Value');
      switch type
         case 1
            n = 32;                           % Wortlnge
            m  = 24;                          % Index des LSB des Exponenten;
         case 2
            n = 64;                           % Wortlnge
            m  = 53;                          % Index des LSB des Exponenten;
         case 3
            n = 80;                           % Wortlnge
            m  = 65;                          % Index des LSB des Exponenten;
      end
      w = ieee754(eval(ustr{1}),type);
      ustr{2} = w(1);
      ustr{3} = w(2:n-m+1);
      y = ieee754interpret(w);
      if isnan(y) | isinf(y) | type==3
         ustr{4} = '';
      elseif str2num(ustr{3})
         ustr{4} = '1.'; 
      else 
         ustr{4} = '0.'; 
      end
      ustr{5} = w(n-m+2:end);
      xm   = 0.23;
      ym   = 0.3;
      dx   = 0.0135;
      dy   = 0.08;
      yt   = 0.45;
      upos = [0.103           0.65  0.34      dy;   % Position der UIs
              xm-dx*(n-m+1.5) ym    0.02      dy; 
              xm-dx*(n-m)     ym    dx*(n-m)  dy;
              xm              ym    dx*2.5    dy;
              xm+dx*2.5       ym    dx*(m-1)  dy; 
              0.7             0.55  0.2       0.2];
      tpos = [0.8 0.8;                              % Position der Texte
              xm-dx*(n-m+0.5) yt;
              xm-dx*(n-m)/2   yt;
              xm+dx*(m+1.5)/2 yt;
              xm+dx*1.25      yt;
              0.27            0.8];
      for k=2:4  set(fud.txh(k),'Position',tpos(k,:)); end  
      chk = 0;      
end

% Falscheingabe
% =============
if chk
   sound(sin(2*pi*1000/8000*(0:1000)),8000); 
   set(uih(k),'String',ustr{k})
   return
end

% Position der UIs
% ================
for j=1:length(uih)
   set(uih(j),'Position',upos(j,:),'String',ustr{j})
end

% Font anpassen
% =============
ext5 = get(uih(5),'extent');
k = get(uih(5),'FontSize');
while ext5(3)<upos(5,3)
   k = k + 0.01;
   set(uih(1:5),'FontSize',k)
   ext5 = get(uih(5),'extent');
end
while ext5(3)>upos(5,3)
   k = k - 0.01;
   set(uih(1:5),'FontSize',k)
   ext5 = get(uih(5),'extent');
end
set(uih(6),'FontSize',k/2)
set(uih(1),'FontUnits','pixels')
fszp = get(uih(1),'FontSize');
set(uih(1),'FontUnits','normalized')
set(txh(2:6),'FontUnits','pixels','FontSize',fszp)

% Neue Daten exportieren
% ======================
fud.uistr = ustr;
fud.uipos = upos;
set(cfg,'UserData',fud);
