function demosirpinski(n,m)
% demosirpinski(n,m)
% Graphische Darstellung des Sirpinski-Dreiecks
% n   :  Rekursionstiefe      (Default 7) 
% m=0 :  Sirpinski-Dreieck    (Default) 
% m=1 :  Matrix mit Quadraten

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

if nargin<1  n = 7; end
if nargin<2  m = 0; end

fh = fullscreen('Sirpinski');
ax(1) = axes('Position',[0 0 1 1]);
if m drawsquare(n,[0 0]); else drawtriangle(n,[2^(n-2) 0]); end
axis([0 1 -1 0]*2^(n-1)+2*[-1 +1 -1 +1]);  axis square;  axis off

%----------------------------------------------------------------

function drawtriangle(n,p)
if n==1  
   patch(p(1)+0.5*[0 -1 +1],p(2)-0.866*[0 1 1],'r');
else
   drawtriangle(n-1,p);
   drawtriangle(n-1,p+[-0.5 -0.866]*2^(n-2));
   drawtriangle(n-1,p+[+0.5 -0.866]*2^(n-2));
end

%----------------------------------------------------------------

function drawsquare(n,p)
if n==1  
   patch(p(1)+[0 1 1 0],p(2)-[0 0 1 1],'r');
else
   drawsquare(n-1,p);
   drawsquare(n-1,p+[0 -1]*2^(n-2));
   drawsquare(n-1,p+[1 -1]*2^(n-2));
end