function demosoftdecode(x,r)
% demosoftdecode(x,r)
% 3D-Bild des binren Wrfels mit Codewort der Lnge 3 
% und verrauschtem Wort mit sigma = 0.8

if nargin<1  x = [-1 -1 +1]; end
if nargin<2  r = 0.8*randn(size(x)); end

p = 2*num2binmat((0:7)',3) - 1;      % Eckpunkte des Wrfels
d = hammingdist(p',p');              % Hammingdistanz der Codewrter

y = x + r;

fh = fullscreen('(3,1)-Soft Decode','w',0,[1.7,1.7;1,1]);

for k=1:8  
   cw = line(p(k,1),p(k,2),p(k,3),'Marker','o','Color',0.7*[1 1 1],'LineWidth',5); 
end
for j=1:7
   for k=j+1:8
      if d(j,k)==1  
         line([p(j,1) p(k,1)],[p(j,2) p(k,2)],[p(j,3) p(k,3)],'Color',0.7*[1 1 1])
      end
   end
end

for k=1:8
   ab = line([y(1) p(k,1)],[y(2) p(k,2)],[y(3) p(k,3)],'Color','r','LineStyle',':');
end

for k=1:8  s(k) = norm(p(k,:)-y); end
[mn,k] = min(s);
ma = line([y(1) p(k,1)],[y(2) p(k,2)],[y(3) p(k,3)],'Color','r','LineWidth',2);
dw = line(p(k,1),p(k,2),p(k,3),'Marker','o','Color','r','MarkerSize',12,'LineWidth',2); 
aw = line(x(1),x(2),x(3),'Marker','o','Color','b','LineWidth',5);
ew = line(y(1),y(2),y(3),'Marker','o','Color','r','LineWidth',5);

axis(1.5*[-1 +1 -1 +1 -1 +1]); axis square; axis off
legend([cw aw ew ab ma dw],'Codewrter','aktuelles Codewort','gestrtes Wort',...
       'Abstnde zu Codewrtern','kleinster Abstand','decodiertes Wort')

title('Codewort der Lnge 3 Bit ungestrt und gestrt','FontSize',13)

rotate3d