function draw2etdff
% draw2etdff(mode)
% Schaltbild eines zweiflankengesteuerten-D-Flipflops:
% Vorderflankensteuerung des ersten FFs, Rckflankensteuerung des zweiten.

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Konstanten
% ==========
fsz = 18;               % FontSize
ms  = 18;               % MarkerSize
lw  = 1.2;              % LineWidth
col = 'k';              % Color
typ = 'NAND';
   
% Fenster
% =======
fh = fullscreen('Zweiflanken-FF','w',0,[2 1.5; 1 1]);
axes('Position',[0.05 0.05 0.9 0.9])
axis([-10 14 -2.5 11]); axis off

% Graphik
% =======
drawgate(-5,0.5,2,typ,'Color',col,'LineWidth',lw);
drawgate(-5,8,  2,typ,'Color',col,'LineWidth',lw);
drawgate(0,1.5,3, typ,'Color',col,'LineWidth',lw);
drawgate(0,7.5,2, typ,'Color',col,'LineWidth',lw);
drawgate(4,2,2,   typ,'Color',col,'LineWidth',lw);
drawgate(4,7,2,   typ,'Color',col,'LineWidth',lw);
drawgate(7,1.5,2, typ,'Color',col,'LineWidth',lw);
drawgate(7,7.5,2, typ,'Color',col,'LineWidth',lw);
drawgate(10,2,2,  typ,'Color',col,'LineWidth',lw);
drawgate(10,7,2,  typ,'Color',col,'LineWidth',lw);
line([-10 -6],[1 1],    'Color',col,'LineWidth',lw)
line([-6 -7 -7 1 1],[8.5 8.5 10 10 7.5],    'Color',col,'LineWidth',lw)
line([-6 -7 -7 -4 -4],[7.5 7.5 5.5 3.5 0.5],'Color',col,'LineWidth',lw)
line([-6 -7 -7 1 1],[0 0 -1.5 -1.5 1.5],    'Color',col,'LineWidth',lw)
line([1 1 -2 -2 -1],[7.5 5.5 3.5 2.5 2.5],  'Color',col,'LineWidth',lw)
line([-5 -1],8+[0 0],   'Color',col,'LineWidth',lw)
line([-5 -1],0.5+[0 0], 'Color',col,'LineWidth',lw)
line([-10 -3],4.5+[0 0],'Color',col,'LineWidth',lw)
line([-1 -3 -3 -1],[1.5 1.5 7 7],'Color',col,'LineWidth',lw)
line([0 3],1.5+[0 0],   'Color',col,'LineWidth',lw)
line([0 3],7.5+[0 0],   'Color',col,'LineWidth',lw)
line([4 6],2+[0 0],     'Color',col,'LineWidth',lw)
line([4 6],7+[0 0],     'Color',col,'LineWidth',lw)
line([5 5 2 2 3],[2 3.5 5.5 6.5 6.5],'Color',col,'LineWidth',lw)
line([5 5 2 2 3],[7 5.5 3.5 2.5 2.5],'Color',col,'LineWidth',lw)
line([1 5 5 6],[10 10 8 8],          'Color',col,'LineWidth',lw)
line([1 5 5 6],[-1.5 -1.5 1 1],      'Color',col,'LineWidth',lw)
line([7 9],[1.5 1.5],   'Color',col,'LineWidth',lw)
line([7 9],[7.5 7.5],   'Color',col,'LineWidth',lw)
line([10 13],[7 7],     'Color',col,'LineWidth',lw)
line([10 13],[2 2],     'Color',col,'LineWidth',lw)
line([11 11 8 8 9],[7 5.5 3.5 2.5 2.5],'Color',col,'LineWidth',lw)
line([11 11 8 8 9],[2 3.5 5.5 6.5 6.5],'Color',col,'LineWidth',lw)
line([-4 1 -3 1 5 5 1 1 11 11],[0.5 1.5 4.5 7.5 2 7 -1.5 10 7 2],'Marker','.','LineStyle','none','MarkerSize',ms,'Color',col)

% Beschriftung
% ============
text(-10,5,'Takt','FontSize',fsz,'Color',col,'HorizontalAlignment','left', 'VerticalAlignment','middle','FontUnits','normalized')
text(-10,1.5,'D', 'FontSize',fsz,'Color',col,'HorizontalAlignment','left', 'VerticalAlignment','middle','FontUnits','normalized')
text(13,2.5,'Q''','FontSize',fsz,'Color',col,'HorizontalAlignment','right','VerticalAlignment','middle','FontUnits','normalized')
text(13,7.5,'Q',  'FontSize',fsz,'Color',col,'HorizontalAlignment','right','VerticalAlignment','middle','FontUnits','normalized')
