function drawbinedge(sig)
% drawbinedge(sig)
% Darstellung der Flanken des Binrsignals sig.

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

% Konstanten und Defaults
% =======================
if nargin<1  sig = nfach(randb(32),100); end
lw = 2.5;
cl = [0 0 1; 0 1 0; 1 0 0];
nam = {'Signal', 'Vorderflanke', 'Rckflanke'};

% Signale
% =======
sigs = [sig(1:end-1); diff(sig)>0; diff(sig)<0];
   
% Graphik
% ======= 
fh = fullscreen('Signalflanken','w',0,[0 1 0.7 1]);
[m,n] = size(sigs);
for k=1:m
   axes('Position',[0 0.1+0.92*(1-k/m) 1 0.5/m])
   drawbinsig(sigs(k,:),0,1,'LineWidth',lw,'Color',cl(k,:));
   line([0 n],[0 0],'Color',0.7*[1 1 1])
   text(0.015*n,0.5,nam{k},'FontSize',18)
   set(gca,'XLim',[0 n]); axis off
end
set(fh,'WindowButtonDownFcn','set(gcf,''Pointer'',''fullcrosshair'')')
set(fh,'WindowButtonUpFcn','set(gcf,''Pointer'',''arrow'')')
