function drawbinsigs(sigs,tit,nam,cl,lw)
% h = drawbinsigs(binvec,tit,nam,cl,lw)
% Darstellung der Zeilenvektoren von sigs als Signale
% tit :  String mit der berschrift
% nam :  CellArray mit den Strings der Signal-Bezeichner
% cl  :  m*3-Matrix mit den Farben der m Signale (oder eine Farbe)
% lw  :  m-Vektor mit den LineWidth (oder ein Wert fr alle)
% Ausgegeben wird der Vektor der line handles.

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

% Konstanten und Defaults
% =======================
[m,n] = size(sigs);
if nargin<5  lw = 2.5;       end
if nargin<4  cl = [0 0 1];   end
if nargin<3  for k=1:m nam{k} = num2str(k); end; end
if nargin<2 tit = 'Signale'; end
if length(lw)==1  lw = ones(m,1)*lw; end
if length(cl(:,1))==1  cl = ones(m,1)*cl; end
if length(nam)==1 for k=2:m  nam{k} = nam{1}; end; end
   
% Fenster und Achsen
% ================== 
fh = fullscreen('Signale');
axes('Position',[0 0.9 1 0.1])
text(0.5,0.5,tit,'FontSize',20,'HorizontalAlignment','center','VerticalAlignment','middle')
axis off

% Signale
% =======
for k=1:m
   axes('Position',[0 0.01+0.92*(1-k/m) 1 0.5/m])
   drawbinsig(sigs(k,:),0,1,'LineWidth',lw(k),'Color',cl(k,:));
   line([0 n],[0 0],'Color',0.7*[1 1 1])
   text(0.015*n,0.5,nam{k},'FontSize',18)
   set(gca,'XLim',[0 n]); axis off
end
set(fh,'WindowButtonDownFcn','set(gcf,''Pointer'',''fullcrosshair'')')
set(fh,'WindowButtonUpFcn','set(gcf,''Pointer'',''arrow'')')
