function drawetdffm
% drawetdffm
% Modell und Schaltbild eines rckflankengesteuerten-D-Flipflops

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Konstanten
% ==========
fsz = 18;               % FontSize
ms  = 18;               % MarkerSize
msn = 30;               % MarkerSize fr Negation
lw  = 1.2;              % LineWidth
col = 'k';              % Color
   
% Fenster
% =======
fh = fullscreen('D-FF','w',0,[1 2; 1 1]);
axes('Position',[0.05 0.05 0.9 0.9])
axis([0 11 0 14]); axis off

% Graphik
% =======
drawcsq([5,1.5],1.5,0.7*[1 1 1],'\tau_2',fsz);
drawcsq([5,  4],1.5,0.7*[1 1 1],'\tau_1',fsz);
drawgate(4,6.5, 2,'AND',             'Color',col,'LineWidth',lw);
drawgate(4,9.5, 2,'AND',             'Color',col,'LineWidth',lw);
drawgate(4,12.5,2,'AND',             'Color',col,'LineWidth',lw);
drawgate(7,8,   2,'OR',              'Color',col,'LineWidth',lw);
drawgate(7,11,  2,'OR',              'Color',col,'LineWidth',lw);
line([0 3],[13 13],                  'Color',col,'LineWidth',lw)
line([0 3],[12 12],                  'Color',col,'LineWidth',lw)
line([2 3],[10 10],                  'Color',col,'LineWidth',lw)
line([2 2 3],[12 7 7],               'Color',col,'LineWidth',lw)
line([4.25 1 1 3],[1.5 1.5 9 9],     'Color',col,'LineWidth',lw)
line([4.25 2 2 3],[4 4 6 6],         'Color',col,'LineWidth',lw)
line([4 5 5 6],[12.5 12.5 11.5 11.5],'Color',col,'LineWidth',lw)
line([4 5 5 6],[9.5 9.5 10.5 10.5],  'Color',col,'LineWidth',lw)
line([5 5 6],[9.5 8.5 8.5],          'Color',col,'LineWidth',lw)
line([4 5 5 6],[6.5 6.5 7.5 7.5],    'Color',col,'LineWidth',lw)
line([7 9 9 5.75],[11 11 1.5 1.5],   'Color',col,'LineWidth',lw)
line([7 8 8 5.75],[8 8 4 4],         'Color',col,'LineWidth',lw)
line([8 11],[8 8],                   'Color',col,'LineWidth',lw)
line([2 2 5 8],[12 10 9.5 8],'Marker','.','LineStyle','none','MarkerSize',ms, 'Color',col)
line([3],[10],               'Marker','.','LineStyle','none','MarkerSize',msn,'Color',col)

% Beschriftung
% ============
text(3,4,'z_1',        'FontSize',fsz-4,'Color',col,'HorizontalAlignment','center', 'VerticalAlignment','bottom')
text(3,1.5,'z_2',      'FontSize',fsz-4,'Color',col,'HorizontalAlignment','center', 'VerticalAlignment','bottom')
text(7,4,'z_{1next}',  'FontSize',fsz-4,'Color',col,'HorizontalAlignment','center', 'VerticalAlignment','bottom')
text(7,1.5,'z_{2next}','FontSize',fsz-4,'Color',col,'HorizontalAlignment','center', 'VerticalAlignment','bottom')
text(0,12,'Takt','FontSize',fsz,'Color',col,'HorizontalAlignment','left', 'VerticalAlignment','bottom')
text(0,13,'D',   'FontSize',fsz,'Color',col,'HorizontalAlignment','left', 'VerticalAlignment','bottom')
text(11,8,'Q',   'FontSize',fsz,'Color',col,'HorizontalAlignment','right','VerticalAlignment','bottom')
