function drawlastedge(sig,mode)
% drawlastedge(sig,mode)
% Darstellung der Flanken des Binrsignals sig.

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

% Konstanten und Defaults
% =======================
if nargin<1   sig = nfach(randb(32),100); end
if nargin<2  mode = +1; end
lw = 2.5;
cl = [0 0 1; 0 1 0; 1 0 0];
nam = {'Signal', 'Zeitpunkt  \vartheta(t)  der letzten Flanke vor t'};
n  = length(sig);
fsiz = 15;

% Signale
% =======
edge  = [diff(sig)>0; diff(sig)<0];
for k=1:2
   th = 0;
   for j=1:n-1
      if edge(k,j) th = j; end
      theta(k,j) = th;
   end
end
   
% Graphik
% ======= 
fh = fullscreen('Letzte Flanke','w',0,[0 0.6 0 1]);
axes('Position',[0.05 0.9 0.9 0.05])
drawbinsig(sig,0,1,'LineWidth',lw,'Color',cl(1,:));
line([0 n],[0 0],'Color',0.7*[1 1 1])
text(0.015*n,0.5,nam{1},'FontSize',fsiz)
set(gca,'XLim',[0 n]); axis off
axes('Position',[0.05 0.05 0.9 0.8])
for k=1:2  lh(k) = line(2:n,theta(k,:),'LineWidth',lw,'Color',cl(k+1,:)); end
line([0 n],[0 0],'Color',0.7*[1 1 1])
text(0.05*n,0.9*n,nam{2},'FontSize',fsiz)
xlabel('t','FontSize',fsiz)
axis([0 n 0 n]); axis square
legend('Vorderflanke','Rckflanke',4)

% Interaktivitt
% ==============
set(fh,'WindowButtonDownFcn','set(gcf,''Pointer'',''fullcrosshair'')')
set(fh,'WindowButtonUpFcn','set(gcf,''Pointer'',''arrow'')')
