function drawmealymoore
% drawmealymoore
% Graphik fr das Mealy- und das Moore-Schaltwerksmodell.
% Mit Mausklick in freies Feld wird zwischen den Modellen 
% gewechselt.

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

% Konstanten
% ==========
fsiz  = 18;
pos   = [0 0 1 1];
pcol  = 0.9*[1 1 1];
lcol1 = 0.8*[0.7 1 1];
lcol2 = 0.8*[1 0.7 1];
lcol3 = 0.8*[1 1 0.7];
lcol4 = 0.8*[0.8 0.8 1];
tit{1} = 'Mealy-Modell';
tit{2} = 'Moore-Modell';

% Graphik
% =======
fh = fullscreen('Mealy/Moore');
axes('Position',pos)
patch([28 38 38 28],...
      [28 28 38 38],pcol);
patch([28 38 38 28],...
      [14 14 24 24],pcol);
patch([30 36 36 30],...
      [ 4  4 10 10],pcol);
patch([38 50 50 52 50 50 38],...
      [32 32 31 33 35 34 34],lcol1);
patch([38 42 42 38 38 36 38 38 44 44 38],...
      [18 18  8  8  9  7  5  6  6 20 20],lcol2);
patch([30 23 23 26 26 28 26 26 23 23 26 26 28 26 26 21 21 30],...
      [ 8  8 15 15 14 16 18 17 17 29 29 28 30 32 31 31  6  6],lcol3);
p(1) = patch([ 4 26 26 28 26 26  4],...
             [21 21 20 22 24 23 23],lcol4);
p(2) = patch([ 4 26 26 28 26 26 17 17 26 26 28 26 26 15 15  4],...
             [21 21 20 22 24 23 23 35 35 34 36 38 37 37 23 23],lcol4);
text(33,33,'\lambda',      'FontSize',  25,'HorizontalAlignment','center','VerticalAlignment','middle','FontUnits','normalized')
text(33,19,'\delta',       'FontSize',  25,'HorizontalAlignment','center','VerticalAlignment','middle','FontUnits','normalized')
text(42.3,5,'Folgezustand','FontSize',fsiz,'HorizontalAlignment','center','FontUnits','normalized')
text(42.3,7,'z_{next}',    'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle','FontUnits','normalized')
text(25,  5,'Zustand',     'FontSize',fsiz,'HorizontalAlignment','center','FontUnits','normalized')
text(25,  7,'z',           'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle','FontUnits','normalized')
text(10, 24,'Input',       'FontSize',fsiz,'HorizontalAlignment','center','FontUnits','normalized')
text(10, 22,'x',           'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle','FontUnits','normalized')
text(44, 35,'Output',      'FontSize',fsiz,'HorizontalAlignment','center','FontUnits','normalized')
text(44, 33,'y',           'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle','FontUnits','normalized')
text(33,7,'Zeitglied',     'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle','FontUnits','normalized')
th = text(12,12,tit{2},    'FontSize',28,'FontWeight','bold','HorizontalAlignment','center','VerticalAlignment','middle','FontUnits','normalized');
axis([0 56 0 42]);  axis off

% Interaktion
% ===========
bdf{1} = 'fud = get(gcf,''UserData''); '; 
bdf{2} = 'if fud.i  i = 1; j = 2; else i = 2; j = 1; end; ';
bdf{3} = 'fud.i = i - 1; '; 
bdf{4} = 'set(gcf,''UserData'',fud); '; 
bdf{5} = 'set(fud.p(i),''visible'',''on''); '; 
bdf{6} = 'set(fud.p(j),''visible'',''off''); '; 
bdf{7} = 'set(fud.t,''string'',fud.tit{j})';
bdfcn  = cat(2,bdf{:});
fud.i  = 0;
fud.p  = p;
fud.t  = th;
fud.tit= tit;
set(p(2),'visible','off')
set(fh,'UserData',fud,'WindowButtonDownFcn',bdfcn,'Position',[4 32 652 485])
