function drawmuxff
% drawmuxff
% Graphik des Multiplexer-Flipflops als Mealy-Modell

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Konstanten
% ==========
fsz = 15;               % FontSize
ms  = 18;               % MarkerSize
msn = 30;               % MarkerSize fr Negation
lw  = 1.2;              % LineWidth
col = 'k';              % Color
bdf = {'fud = get(gcf,''UserData''); ';...
       'if fud.d  cl = fud.c{1}; else cl = fud.c{2}; end; ';...
       'if ~fud.d  set(fud.t,''String'',''rote Markierung durch Mausklick toggeln''); end; ';...
       'fud.d = ~fud.d; ';...
       'set(fud.h,''Color'',cl); ';...
       'set(gcf,''UserData'',fud)'};

% Fenster
% =======
fh = fullscreen('MUX-FF','w',0,[2 3; 1 1]);
axes('Position',[0.05 0.05 0.9 0.9])
axis([0 10 -0.5 9.5]); axis square; axis off

% Graphik
% =======
drawcsq([5 2],2,0.7*[1 1 1],'\tau',fsz+5);
drawgate(7,6,2,'OR',             'Color',col,'LineWidth',lw);
h(1) = drawgate(4,7.5,2,'AND',          'Color',col,'LineWidth',lw);
h(2) = drawgate(4,4.5,2,'AND',          'Color',col,'LineWidth',lw);
h(3) = line([0 2],6+[0 0],              'Color',col,'LineWidth',lw);
h(4) = line([3 2 2 3],[5 5 7 7],        'Color',col,'LineWidth',lw);
h(5) = line([4 5 5 6],[7.5 7.5 6.5 6.5],'Color',col,'LineWidth',lw);
h(6) = line([4 5 5 6],[4.5 4.5 5.5 5.5],'Color',col,'LineWidth',lw);
h(7) = line([2],[6],'Marker','.','LineStyle','none','MarkerSize',ms,'Color',col);
h(8) = line([3],[5],    'Marker','.','LineStyle','none','MarkerSize',msn,'Color',col);
line([0 3],8+[0 0],              'Color',col,'LineWidth',lw)
line([4 2 2 3],[2 2 4 4],        'Color',col,'LineWidth',lw)
line([7 10],[6 6],               'Color',col,'LineWidth',lw)
line([8 8 6],[6 2 2],            'Color',col,'LineWidth',lw)
line([8],[6],'Marker','.','LineStyle','none','MarkerSize',ms,'Color',col)

% Beschriftung
% ============
text(0,8,'x_2 (D)',  'FontSize',fsz,'Color',col,'HorizontalAlignment','left',  'VerticalAlignment','bottom','FontUnits','normalized')
text(0,6,'x_1 (C)',  'FontSize',fsz,'Color',col,'HorizontalAlignment','left',  'VerticalAlignment','bottom','FontUnits','normalized')
text(10,6, 'y_1 (Q)','FontSize',fsz,'Color',col,'HorizontalAlignment','right', 'VerticalAlignment','bottom','FontUnits','normalized')
text(3,2,'z',        'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','bottom','FontUnits','normalized')
text(7,2,'z_{next}', 'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','bottom','FontUnits','normalized')
t = text(5,-0.5,'Strukturhasard auf Mausklick rot','FontSize',fsz-4,'Color','b','HorizontalAlignment','center','VerticalAlignment','bottom','FontUnits','normalized');

% Toggeln der Farbe fr Hasard durch Mausklick
% ============================================
fud.d = 0;
fud.h = h;
fud.t = t;
fud.c = {col;'r'};
set(gcf,'UserData',fud)
cat(2,bdf{:});
set(gcf,'WindowButtonDownFcn',cat(2,bdf{:})); 