function drawnorffmoore
% drawnorffmoore
% Graphik des NOR-Basis-Flipflops als Moore-Modell

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Konstanten
% ==========
fsz = 15;               % FontSize
ms  = 18;               % MarkerSize
lw  = 1.2;              % LineWidth
col = 'k';              % Color

% Fenster
% =======
fh = fullscreen('NOR-FF','w',0,[1 1.5; 1 1]);
axes('Position',[0.05 0.05 0.9 0.9])
axis([-2 11 0 12]); axis square; axis off

% Graphik
% =======
drawcsq([4.5 1],  1,0.7*[1 1 1],'\tau_2',fsz);
drawcsq([4.5 2.5],1,0.7*[1 1 1],'\tau_1',fsz);
drawgate(5,5,2,'NOR',          'Color',col,'LineWidth',lw);
drawgate(5,8,2,'NOR',          'Color',col,'LineWidth',lw);
line([0 4],4.5+[0 0],          'Color',col,'LineWidth',lw)
line([0 4],8.5+[0 0],          'Color',col,'LineWidth',lw)
line([5 6 6 5],[5 5 2.5 2.5],  'Color',col,'LineWidth',lw)
line([5 7 7 5],[8 8 1 1],      'Color',col,'LineWidth',lw)
line([4 3 3 9],[2.5 2.5 10 10],'Color',col,'LineWidth',lw)
line([4 2 2 9],[1 1 11 11],    'Color',col,'LineWidth',lw)
line([3 4],[7.5 7.5],          'Color',col,'LineWidth',lw)
line([2 4],[5.5 5.5],          'Color',col,'LineWidth',lw)
line([3 2],[7.5 5.5],'Marker','.','LineStyle','none','MarkerSize',ms,'Color',col)

% Beschriftung
% ============
text(1,4.5,'x_2 (R)', 'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','bottom','FontUnits','normalized')
text(1,8.5,'x_1 (S)', 'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','bottom','FontUnits','normalized')
text(8,10, 'y_1 (Q)', 'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','bottom','FontUnits','normalized')
text(8,11,'y_2 (Q'')','FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','bottom','FontUnits','normalized')
text(3.5,2.5,'z_1',   'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','bottom','FontUnits','normalized')
text(3.5,1,'z_2',     'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','bottom','FontUnits','normalized')
