function drawswmodell(pos)
% drawswmodell(pos)
% Graphik eines allgemeinen Schaltwerksmodells.
% pos :  Position-property der Achsen, die fr die Graphik in ein 
%        vorhandenes Bild eingefgt werden.
%        Ist pos nicht angegeben, so wird ein neues Bild erzeugt.

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

% Konstanten
% ==========
fsiz = 20;
pcol = 0.9*[1 1 1];
lcol = 0.8*[1 1 1];

% Bilderzeugung falls ntig
% =========================
if nargin <1  
   fh  = fullscreen('SW-Modell');
   pos = [0 0 1 1];
end
axes('Position',pos)

% Graphik
% =======
patch([16 32 32 16],[12 12 28 28],pcol);
patch([21 27 27 21],[ 4  4  8  8],pcol);
patch([ 2 14 14 16 14 14  2],[23 23 22 24 26 25 25],lcol);
patch([32 44 44 46 44 44 32],[23 23 22 24 26 25 25],lcol);
patch([32 37 37 29 29 27 29 29 39 39 32],[15 15  7  7  8  6  4  5  5 17 17],lcol);
patch([21  9  9 14 14 16 14 14 11 11 21],[ 5  5 17 17 18 16 14 15 15  7  7],lcol);
text(33, 8,'Zustand',     'FontSize',fsiz,'HorizontalAlignment','center','FontUnits','normalized')
text(16, 8,'Folgezustand','FontSize',fsiz,'HorizontalAlignment','center','FontUnits','normalized')
text( 8,26,'Input',       'FontSize',fsiz,'HorizontalAlignment','center','FontUnits','normalized')
text(38,26,'Output',      'FontSize',fsiz,'HorizontalAlignment','center','FontUnits','normalized')
text(24,20,'Schaltnetz',  'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle','FontUnits','normalized')
text(24, 6,'Zeitglied',   'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle','FontUnits','normalized')
axis([0 48 0 32]);  axis off

if nargin<1  set(fh,'Position',[ 3  30  585  471]); end
