function drawtpdff
% drawtpdff
% Schaltbild eines Taktpegelgesteuerten-D-Flipflops

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Konstanten
% ==========
fsz = 18;               % FontSize
ms  = 18;               % MarkerSize
lw  = 1.2;              % LineWidth
col = 'k';              % Color

% Fenster
% =======
fh = fullscreen('D-Latch','w',0,[2 2; 1 1]);
axes('Position',[0.05 0.05 0.9 0.9])
axis([-5 8 0 9]); axis off

% Graphik
% =======
drawgate(0,1.5,2,'NAND','Color',col,'LineWidth',lw);
drawgate(0,7.5,2,'NAND','Color',col,'LineWidth',lw);
drawgate(4,2,2,  'NAND','Color',col,'LineWidth',lw);
drawgate(4,7,2,  'NAND','Color',col,'LineWidth',lw);
line([1 1 -2 -2 -1],[7.5 5.5 3.5 2 2],'Color',col,'LineWidth',lw)
line([-5 -1],8+[0 0],'Color',col,'LineWidth',lw)
line([-5 -3],4.5+[0 0],'Color',col,'LineWidth',lw)
line([-1 -3 -3 -1],[1 1 7 7],'Color',col,'LineWidth',lw)
line([0 3],1.5+[0 0],'Color',col,'LineWidth',lw)
line([0 3],7.5+[0 0],'Color',col,'LineWidth',lw)
line([4 7],2+[0 0],  'Color',col,'LineWidth',lw)
line([4 7],7+[0 0],  'Color',col,'LineWidth',lw)
line([5 5 2 2 3],[2 3.5 5.5 6.5 6.5],'Color',col,'LineWidth',lw)
line([5 5 2 2 3],[7 5.5 3.5 2.5 2.5],'Color',col,'LineWidth',lw)
line([-3 1 5 5],[4.5 7.5 2 7],'Marker','.','LineStyle','none','MarkerSize',ms,'Color',col)

% Beschriftung
% ============
text(-5,5,'Takt','FontSize',fsz,'Color',col,'HorizontalAlignment','left', 'VerticalAlignment','middle','FontUnits','normalized')
text(-5,8.5,'D', 'FontSize',fsz,'Color',col,'HorizontalAlignment','left', 'VerticalAlignment','middle','FontUnits','normalized')
text(7,2.5,'Q''','FontSize',fsz,'Color',col,'HorizontalAlignment','right','VerticalAlignment','middle','FontUnits','normalized')
text(7,7.5,'Q',  'FontSize',fsz,'Color',col,'HorizontalAlignment','right','VerticalAlignment','middle','FontUnits','normalized')
