function drawtwolatch(mode)
% drawtwolatch(mode)
% Graphik zweier Earle-Latch mit getrennten Takten

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Default
% =======
if nargin<1  mode = 0; end

% Konstanten
% ==========
fsz = 15;               % FontSize
ms  = 18;               % MarkerSize
msn = 30;               % MarkerSize fr Negation
lw  = 1.2;              % LineWidth
col = 'k';              % Color
p   = 8;                % x-Verschiebung des zweiten Latch

% Fenster
% =======
fh = fullscreen('Doppel-Latch','w',0,[1 1; 1 1]);
axes('Position',[0.05 0.05 0.9 0.9])
axis([0 19 1 12]); axis off

% Graphik
% =======
% 1. Latch
drawgate(8, 7.5,3,'NAND',            'Color',col,'LineWidth',lw);
drawgate(5, 4.5,2,'NAND',            'Color',col,'LineWidth',lw);
drawgate(5, 7.5,2,'NAND',            'Color',col,'LineWidth',lw);
drawgate(5,10.5,2,'NAND',            'Color',col,'LineWidth',lw);
line([2 4],5+[0 0],                  'Color',col,'LineWidth',lw)
line([0 3],8+[0 0],                  'Color',col,'LineWidth',lw)
line([2 2 4],[0 11 11],              'Color',col,'LineWidth',lw)
line([4 3 3 4],[8 8 10 10],          'Color',col,'LineWidth',lw)
line([3 4],[4 4],                    'Color',col,'LineWidth',lw)
line([5 6 6 7],[10.5 10.5 8.5 8.5],  'Color',col,'LineWidth',lw)
line([5 7],[7.5 7.5],                'Color',col,'LineWidth',lw)
line([5 6 6 7],[4.5 4.5 6.5 6.5],    'Color',col,'LineWidth',lw)
line([8 9 9 3 3 4],[7.5 7.5 2.5 2.5 7 7],          'Color',col,'LineWidth',lw)
line([3 4],[4 4],                    'Color',col,'LineWidth',lw)
line([2 3 3 9],[5 8 4 7.5],'Marker','.','LineStyle','none','MarkerSize',ms, 'Color',col)
line([4],[5],              'Marker','.','LineStyle','none','MarkerSize',msn,'Color',col)
% 2. Latch
drawgate(p+8, 7.5,3,'NAND',          'Color',col,'LineWidth',lw);
drawgate(p+5, 4.5,2,'NAND',          'Color',col,'LineWidth',lw);
drawgate(p+5, 7.5,2,'NAND',          'Color',col,'LineWidth',lw);
drawgate(p+5,10.5,2,'NAND',          'Color',col,'LineWidth',lw);
line(p+[2 4],5+[0 0],                'Color',col,'LineWidth',lw)
line(p+[1 1 3],[7.5 8 8],            'Color',col,'LineWidth',lw)
line(p+[2 2 4],[0 11 11],            'Color',col,'LineWidth',lw)
line(p+[4 3 3 4],[8 8 10 10],        'Color',col,'LineWidth',lw)
line(p+[3 4],[4 4],                  'Color',col,'LineWidth',lw)
line(p+[5 6 6 7],[10.5 10.5 8.5 8.5],'Color',col,'LineWidth',lw)
line(p+[5 7],[7.5 7.5],              'Color',col,'LineWidth',lw)
line(p+[5 6 6 7],[4.5 4.5 6.5 6.5],  'Color',col,'LineWidth',lw)
line(p+[8 9 9 3 3 4],[7.5 7.5 2.5 2.5 7 7],          'Color',col,'LineWidth',lw)
line(p+[3 4],[4 4],                  'Color',col,'LineWidth',lw)
line(p+[9 11],[7.5 7.5],             'Color',col,'LineWidth',lw)
line(p+[2 3 3 9],[5 8 4 7.5],'Marker','.','LineStyle','none','MarkerSize',ms, 'Color',col)
line(p+[4],[5],              'Marker','.','LineStyle','none','MarkerSize',msn,'Color',col)

% Beschriftung
% ============
text(0,8,      'D',  'FontSize',fsz,'Color',col,'HorizontalAlignment','left', 'VerticalAlignment','bottom','FontUnits','normalized')
text(2.1,0.8,  'C_1','FontSize',fsz,'Color',col,'HorizontalAlignment','left', 'VerticalAlignment','bottom','FontUnits','normalized')
text(p+2.1,0.8,'C_2','FontSize',fsz,'Color',col,'HorizontalAlignment','left', 'VerticalAlignment','bottom','FontUnits','normalized')
text(p+11,7.5, 'Q',  'FontSize',fsz,'Color',col,'HorizontalAlignment','right','VerticalAlignment','bottom','FontUnits','normalized')
