function h = entropie(p)
% h = entropie(p)
% Entropie fr die im Vektor p gegebenen Wahrscheinlichkeiten
% Die Summe der Komponenten von p muss gleich 1 sein.

if abs(sum(p))<eps  error('entropie: Die Summe der Komponenten von p muss gleich 1 sein'); end

h = sum( p .* log2( 1./p ));

if ~nargout
   Entropie = h; 
   result2fig(Entropie); 
end
