function fsmtiming
% fsmtiming
% Graphik fr das Zeitverhalten eines Schaltwerks.

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

% Konstanten
% ==========
fsiz  = 16;
fst   = 1.3*fsiz;
pos1  = [0 0 1 1];
pos2  = [0 0.35 0.35 0.2];
pos3  = [0 0.20 0.35 0.2];
pos4  = [0 0.05 0.35 0.6];
pcol  = 0.9*[1 1 1];
lcol1 = 0.8*[0.7 1 1];
lcol2 = 0.8*[1 0.7 1];
lcol3 = 0.8*[1 1 0.7];
lcol4 = 0.8*[0.8 0.8 1];
lw    = 2.5;

% Graphik
% =======
fh = fullscreen('Timing');
axes('Position',pos1)

patch([28 38 38 28],...
      [28 28 38 38],pcol);
text(30,33,'\lambda',  'FontSize',  25,'HorizontalAlignment','center','VerticalAlignment','middle')

patch([28 38 38 28],...
      [14 14 24 24],pcol);
text(30,19,'\delta',   'FontSize',  25,'HorizontalAlignment','center','VerticalAlignment','middle')

patch([30 36 36 30],...
      [ 4  4 10 10],pcol);
   
patch([38 48 48 50 48 48 38],...
      [32 32 31 33 35 34 34],lcol1);
text(44, 35,'Output',  'FontSize',fsiz,'HorizontalAlignment','center')
text(44, 33,'y',       'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle')

patch([38 42 42 38 38 36 38 38 44 44 38],...
      [18 18  8  8  9  7  5  6  6 20 20],lcol2);
text(42.3,7,'z_{next}','FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle')
   
patch([30 23 23 26 26 28 26 26 23 23 26 26 28 26 26 21 21 30],...
      [ 8  8 15 15 14 16 18 17 17 32 32 31 33 35 34 34  6  6],lcol3);
text(25,  7,'z',       'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle')

patch([ 4 26 26 28 26 26  4],...
      [21 21 20 22 24 23 23],lcol4);
text(10, 24,'Input',   'FontSize',fsiz,'HorizontalAlignment','center')
text(10, 22,'x',       'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle')

axis([4 50 -6 40]);  axis square; axis off

drawarr([33 -5],[33 4],'k',2,1);
text(33.3,-2,'Takt',   'FontSize',fst,'HorizontalAlignment','left',  'VerticalAlignment','baseline')

drawarr([33 4],[30 7],'r',2.5,1);
text(32,6,'\tau_{ff}', 'FontSize',fst,'HorizontalAlignment','left',  'VerticalAlignment','baseline','Color','r')

drawarr([28 16],[38 19],'r',2.5,1);
text(33,16,'\tau_\delta','FontSize',fst,'HorizontalAlignment','left','VerticalAlignment','baseline','Color','r')


axes('Position',pos2)
axis([-3 +12 -0.5 +1.5]); axis off
line([-2 +12],[0 0],'LineWidth',lw,'Color','k')
text(5,0,'Zeit','FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','top','Color','k')

line([0 10; 0 10],[0 0; 1 1],'LineWidth',lw,'Color','b')
text(-0.2,0.7,'Takt','FontSize',fsiz,'HorizontalAlignment','right','VerticalAlignment','baseline','Color','b')
text(10.2,0.8,'nchster','FontSize',fsiz,'HorizontalAlignment','left','VerticalAlignment','baseline','Color','b')
text(10.2,0.5,'Takt','FontSize',fsiz,'HorizontalAlignment','left','VerticalAlignment','baseline','Color','b')

drawarr([0 0.5],[2 0.5],'r',lw,0.7,0.2,0.2);
text(1,0.8,'\tau_{ff}','FontSize',fst,'HorizontalAlignment','center','VerticalAlignment','baseline','Color','r')

drawarr([2 0.5],[6.5 0.5],'r',lw,0.7,0.2,0.2);
text(4.25,0.8,'\tau_{\deltamax}','FontSize',fst,'HorizontalAlignment','center','VerticalAlignment','baseline','Color','r')

drawarr([7 0.5],[10 0.5],'r',lw,0.7,0.2,0.2);
text(8.5,0.7,'S','FontSize',fst,'HorizontalAlignment','center','VerticalAlignment','baseline','Color','r')


axes('Position',pos3)
axis([-3 +12 -0.5 +1.5]); axis off
line([-2 +12],[0 0],'LineWidth',lw,'Color','k')

line([0 0],[0 1],'LineWidth',lw,'Color','b')
text(-0.2,0.7,'Takt','FontSize',fsiz,'HorizontalAlignment','right','VerticalAlignment','baseline','Color','b')

drawarr([0 0.7],[2 0.7],'r',lw,0.7,0.2,0.2);
text(1,1,'\tau_{ff}','FontSize',fst,'HorizontalAlignment','center','VerticalAlignment','baseline','Color','r')

drawarr([2 0.7],[4 0.7],'r',lw,0.7,0.2,0.2);
text(3,1,'\tau_{\deltamin}','FontSize',fst,'HorizontalAlignment','center','VerticalAlignment','baseline','Color','r')

drawarr([0 0.2],[3 0.2],'r',lw,0.7,0.2,0.2);
text(1.5,0.3,'H','FontSize',fst,'HorizontalAlignment','center','VerticalAlignment','baseline','Color','r')


axes('Position',pos4)
axis([-3 +12 -0.5 +5]); axis off
line([4 4],[0 2],'LineStyle',':','Color','m')
line([6.5 6.5],[0 3],'LineStyle',':','Color','m')
