function kv = ftab2kv(tab)
% kv = ftab2kv(tab)
% Umsetzung der als linarer Zeilenvektor vorliegenden 
% Funktionstabelle tab in die Matrixanordnung des 
% KV-Diagramms.
% Im Falle von weniger als 5 Variablen ist kv einfach 
% eine Matrix, andernfalls ein Cell-Array aus zwei 
% Matrizen oder Cell-Arrays.

% Autor:  K. v. d. Heide,  e-mail:  v.d.heide@on-line.de

if nargin<1  tab = randb(16); end

switch round(log2(length(tab)))
   case 1, kv = tab;
   case 2, kv = reshape(tab,2,2);
   case 3
      kv = reshape(tab,2,4);
      kv(:,[3 4]) = kv(:,[4 3]);
   case 4
      kv = reshape(tab,4,4);
      kv(:,[3 4]) = kv(:,[4 3]);
      kv([3 4],:) = kv([4 3],:);
   otherwise
      kv1 = ftab2kv(tab(1:length(tab)/2));
      kv2 = ftab2kv(tab(length(tab)/2+1:end));
      kv = {kv1;kv2};
end
 
