function x = isconjunctive(binexpr)
% x = isconjunctive(binexpr)
% x = 1, wenn der schaltalgebraische Ausdruck binexpr
% konjunktiv ist, d.h. mit |-Verknpfung in den Termen 
% und &-Verknpfung zwischen den Termen.  Die Terme 
% mssen geklammert sein.
% Beispiele:
% isconjunctive('(a|~c) & (~b)')   => 1
% isconjunctive('(a|~c&b) & (~b)') => 0
% isconjunctive('(a|~c|b)')        => 1

kla = findstr('(',binexpr);
klz = findstr(')',binexpr);
if length(kla)~=length(klz)  error('isconjunctive:  inkorrekte Klammerung der Terme!'); end

tia = 0;
tio = 0;
tip = 0;
tim = 0;
tv  = 0;
for k=1:length(kla)
   tia = tia | any(findstr('&',binexpr(kla(k):klz(k))));
   tio = tio | any(findstr('|',binexpr(kla(k):klz(k))));
   tip = tip | any(findstr('+',binexpr(kla(k):klz(k))));
   tim = tim | any(findstr('*',binexpr(kla(k):klz(k))));
end
for k=1:length(kla)-1
   for j=klz(k)+1:kla(k+1)-1
      if ~((binexpr(j)==' ') | (binexpr(j)=='&'))  tv = 1; break; end 
   end
end

if any([tv tia tip tim])
   x = 0;
else
   x = 1;
end
