function x = isdisjunctive(binexpr)
% x = isdisjunctive(binexpr)
% x = 1, wenn der schaltalgebraische Ausdruck binexpr
% disjunktiv ist, d.h. mit &-Verknpfung in den Termen 
% und |-Verknpfung zwischen den Termen.  Die Terme 
% mssen geklammert sein.
% Beispiele:
% isdisjunctive('(a&~c) | (~b)')   => 1
% isdisjunctive('(a&~c|b) | (~b)') => 0
% isdisjunctive('(a&~c&b)')        => 1

kla = findstr('(',binexpr);
klz = findstr(')',binexpr);
if length(kla)~=length(klz)  error('isdisjunctive:  inkorrekte Klammerung der Terme!'); end

tia = 0;
tio = 0;
tip = 0;
tim = 0;
tv  = 0;
for k=1:length(kla)
   tia = tia | any(findstr('&',binexpr(kla(k):klz(k))));
   tio = tio | any(findstr('|',binexpr(kla(k):klz(k))));
   tip = tip | any(findstr('+',binexpr(kla(k):klz(k))));
   tim = tim | any(findstr('*',binexpr(kla(k):klz(k))));
end
for k=1:length(kla)-1
   for j=klz(k)+1:kla(k+1)-1
      if ~((binexpr(j)==' ') | (binexpr(j)=='|'))  tv = 1; break; end 
   end
end

if any([tv tio tip tim])
   x = 0;
else
   x = 1;
end
