function [b,in,ie] = isgf(ta,tm)
% [b,in,ie] = isgf(ta,tm)
% Prfung, ob die quadratischen Matrizen ta und tb von Indices 
% in diese Tabellen als Operationstabellen fr Addition bzw.
% Multiplikation die Axiome eines endlichen Krpers erfllen.  
%
% b gibt an, ob ein Krper vorliegt (1 sonst 0)
% in :  Index des neutralen Elementes der Addition (die Null)
% ie :  Index des neutralen Elements der Multiplikation (die Eins)
%
% isgf beweist durch vollstndige Prfung aller Kombinationen.
% Die Komplexitt ist proportional  n^3 .

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% ta definiert kommutative Gruppe?
% ================================
[a,ga,in] = isgru(ta);

% tm ohne die Null definiert eine Gruppe?
% =======================================
[m,n] = size(tm);
ix = [1:in-1, in+1:n];
tp = tm(ix,ix);
tp = tp - (tp>in);
[c,gm,ie] = isgru(tp);
if ie>=in  ie = ie + 1; end

% Distributivgesetz
% =================
d = 1;
for k=1:n
   for j=1:n
      for i=1:n
         d = d & (tm(ta(k,j),i)==ta(tm(k,i),tm(j,i)));
         d = d & (tm(k,ta(j,i))==ta(tm(k,j),tm(k,i)));
      end
   end
end

% Krper?
% =======
b = a & c & d;
