function txt = morsebits2text(bits)
% txt = morsebits2text(bits)
% decodes the bitvector of Morse symbols "1", "0 1" and "0 0"
% for "dot", "dash", and "symbol delimiter" into a String.
% morsebits2text([0 1 1 0 1 1 0 0 0 1 0 1 1 0 1 0 0]) yields 'CQ'

% Autor:  K. v. d. Heide,  e-mail:  v.d.heide@on-line.de

if nargin<1  bits = [0 1 1 0 1 1 0 0 0 1 0 1 1 0 1 0 0 0 0]; end

% Dekodierbaum aufstellen
% =======================
alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789/?.';
z = '01';
for k=1:length(alphabet)
   bitcode = morse2bits(str2morse(alphabet(k)));
   s = z(bitcode+1);
   s = ['baum'  strrep(strrep(s,'1','{2}'),'0','{1}')  '='  'alphabet(k);'];
   eval(s);             % Ausfhrung der zusammengestellten Instruktion, z.B.
                        % baum{2}{1}{2}{1}{1} = 'A'; 
end

% Dekodierung
% ===========
bv  = bits;
txt = '';
while length(bv)>0      % Dekodieren solange noch Bits da sind
   k = 1;
   z = baum{bv(k)+1};   % erstes Bit an der Wurzel des Baumes
   while iscell(z)      % in den Baum steigen bis zum Blatt
      k = k + 1;
      try, z = z{bv(k)+1}; catch, z = '_'; end
   end
   txt = [txt  z];      % gefundenes Blatt dem Text anfgen
   bv  = bv(k+1:end);   % entsprechende Bits wegnehmen
end

if ~nargout  result2fig(txt); end
