function [tone,envel] = morsesound(string,bpm,frequenz,fs)
% [tone,envel] = morsesound(string,bpm,frequenz,fs)
% gibt den string als Morsezeichen mit bpm Zeichen pro Minute 
% in der Tonfrequenz frequenz und der Abtastrate fs auf der
% Variablen tone aus.  envel ist die Amplitude des Tones.
% Wird tone nicht einer Variablen zugewiesen, so erfolgt 
% die Ausgabe als Sound.

if nargin<4  fs = 4000; end
if nargin<3  frequenz = 800; end
if nargin<2  bpm = 160; end
if nargin<1  string = 'CQ DE DJ5HG'; end

% Autor:  K. v. d. Heide,  e-mail:  v.d.heide@on-line.de

morse = morsecode(string,round(fs/(10*bpm/60)*[1 3 1 3 4]));

if bpm/fs>0.7
   envel = morse;
else
   envel = filter(fir1(60,bpm/fs),1,morse);
end

tone  = envel.*sin(2*pi*frequenz*(1:length(envel))/fs);

if nargout==0 sound(tone,fs); end