function plotcapacity
% plotcapacity
% zeichnet die Kapaziott des binren Kanals 
% ber der Bitfehlerwahrscheinlichkeit.

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Berechnung
% ==========
P = eps:0.000999:1-eps;             % Abszisse mit 1001 Punkten
q = [P;  1-P];                      % Matrix der Wahrscheinlichkeiten
C = 1 - sum( q .* log2( 1./q ));    % Vektor der zugehrigen Kanalkapazitten

% Bildgrsse
% ==========
[fnam,fwgt,fsz,pres] = getfont;     % Font
if pres
   figp = [0 1 0 1];
else
   figp = [0 0.5 0.5 1];
end

% Graphik
% =======
fh = fullscreen('Kanalkapazitt','w',0,figp);  % Graphikfenster
plot(P,C)                           % Darstellung
title('Kapazitt des binren symmetrischen Kanals','FontSize',15)
xlabel('Bitfehlerwahrscheinlichkeit','FontSize',15)
ylabel('Bits pro Binrstelle','FontSize',15)
grid on
