function plotentropy
% plotentropy
% zeichnet die Entropie des binren Kanals 
% ber der Wahrscheinlichkeit der '0'.

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Berechnung
% ==========
q = eps:0.00999:1-eps;              % Abszisse mit 101 Punkten
p = [q;  1-q];                      % Matrix der Wahrscheinlichkeiten
H = sum( p .* log2( 1./p ));        % Vektor der zugehrigen Entropien

% Bildgrsse
% ==========
[fnam,fwgt,fsz,pres] = getfont;     % Font
if pres
   figp = [0 1 0 1];
else
   figp = [0 0.5 0.5 1];
end

% Graphik
% =======
fh = fullscreen('Entropie','w',0,figp); % Graphikfenster
plot(q,H)                           % Darstellung
title('Entropie des binren Kanals','FontSize',15)
xlabel('Wahrscheinlichkeit der "0"','FontSize',15)
