function g = poly_gcd(a, b, p)
% Ermitteln des ggT zweier Polynome a(x), b(x) aus Zp[x]
% Vorgabe fr p ist 2

% Autor: Peter Grotrian, grotrian@acm.org

if nargin < 3
   p = 2;
end

% fhrende 0-Koeffizienten entfernen
a(find(cumsum(a)==0)) = [];
b(find(cumsum(b)==0)) = [];

while length(b) > 0
   [quot, r] = deconv(a, b);
   r = mod(r, p);
   a = b;
   b = r;
   % fhrende 0-Koeffizienten entfernen
   b(find(cumsum(b)==0)) = [];
end
g = a;
% fhrende 0-Koeffizienten entfernen
g(find(cumsum(g)==0)) = [];

