function b = poly_is_irreducible(a, p)
% Prft, ob das Polynom a(x) irreduzibel in Zp[x] ist
% Vorgabe fr p ist 2

% Autor: Peter Grotrian, grotrian@acm.org

if nargin < 2
   p = 2;
end
a(find(cumsum(a) == 0)) = []; % fhrende Nullen entfernen

% Das Produkt aller normierten irreduziblen Polynome in Zp[x] mit
% einem Grad, der k teilt, ist x^(p^k)-x.

u = [1 0];
for i = 1:(length(a) - 1)/2
   u = poly_power_mod(u, p, a, p);
   uminusx = [zeros(1,2-length(u)) u];
   uminusx(end-1) = mod(uminusx(end-1)-1, p);
   d = poly_gcd(uminusx, a, p);
   if ~ isequal(d, [1])
      b = 0;
      return;
   end
end
b = 1;
   