function b = poly_is_primitive(a, p, primes)
% Prft, ob das irreduzible Polynom a(x) aus Zp[x] primitiv ist
% Vorgabe fr p ist 2
%
% In primes knnen als Vektor die Primteiler von q-1=p^Grad(a)-1 bergeben werden.
%
% Diese Funktion verlt sich darauf, da b irreduzibel ist!

% Autor: Peter Grotrian, grotrian@acm.org

if nargin < 2
   p = 2;
end
a(find(cumsum(a) == 0)) = []; % fhrende Nullen entfernen

q1 = p^(length(a)-1) - 1;
if nargin < 3
	% q1 Faktorisieren und jeden Primfaktor hchstens einmal in primes ablegen
	f = factor(q1);
	l = logical(diff([0,f]));
	primes = f(l);
end

b = 1;
for prime = primes
   c = poly_power_mod([1 0], q1/prime, a, p);
   if isequal(c, [1])
      b = 0;
      break;
   end      
end
return;
