function power = poly_power_mod(x, n, modul, p)
% Berechne power = x^n (mod modul)
%
% n >=0, ganzzahlig
% x, modul  Polynom aus Zp[x]
%
% Alle Polynome sind als Koeffizientenvektoren anzugeben

% Autor: Peter Grotrian, grotrian@acm.org

if n < 0
   'n mu >= 0 sein!'
   return;
end
if n ~= floor(n)
   'n mu ganzzahlig sein'
   return
end

if n == 0
   num_digits = 0
else
   num_digits = floor(log2(n))+1;
end

digits = num2binvec(n, num_digits);
a = [1];
for i = digits
   a = poly_mul_mod(a, a, modul, p);
   if i == 1
      a = poly_mul_mod(a, x, modul, p);
   end
end
power = a;
   
   
   