function s = powersbabylon(zahl,n,fnt)
% s = powersbabylon(zahl,n,fnt)
% berechnet die Potenzen 1...n der Zahl zahl 
% in babylonischer Darstellung.
% zahl :  String mit Zahl in babylonischer Darstellung
% n    :  hchste Potenz (numerischer Wert)
% fnt  :  FontName
% Wenn s nicht zugewiesen wird erfolgt die Ausgabe im Font fnt in ein Fenster.

if nargin<1  zahl = '1 <<<<'; end  % Zahl deren Potenzen zu berechnen sind
if nargin<2     n = 10;       end  % hchste Potenz
if nargin<3  fnt = 'FixedWidth'; end  

p{1} = zahl; 
for k=1:n-1  p{k+1} = multbabylon(p{k},zahl); end;
s = '';
for k=1:length(p)  s = sprintf('%s%2d    %s\n\n',s,k,p{k}); end;
s = s(1:end-2);

if ~nargout  result2fig(strrep(s,'1','I'),fnt); end
