function [s,c] = ripplecarryadd(a,b,c0,q)
% [s,c] = ripplecarryadd(a,b,ci,q)
% Ripple-Carry-Addierer
% a, b :  Vektoren der Ziffern der Summanden, 
%         Die Lnge der Vektoren mssen gleich sein.
% c0   :  bertrag in die niederwertigste Stelle
% q    :  Basis des Systems, Default: 2
% s    :  Vektor der Ziffern der Summe.
%         s hat die selbe Anzahl von Stellen wie a und b.
% c    :  bertrag von der hchstwertigen Stelle.
%         c kann als hchstwertige Stelle dem Vektor s 
%         nachgestellt werden.

if length(a)==1
   [s,c]   = fulladd(a,b,c0,q);
else
   [sx,cx] = ripplecarryadd(a(1:end-1),b(1:end-1),c0,q);
   [sy,c]  = fulladd(a(end),b(end),cx,q);
   s = [sx,sy];
end