function x = rm2bintab(r)
% x = rm2bintab(r)
% Transformation des binren Koeffizientenvektors der 
% Reed-Muller-Form in die binre Funktionstabelle. 
% Die Transformation ist zu sich selbst invers.

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Transformationsmatrix aufstellen
% ================================
n = length(r);
A = 1;
Z = 0;
while n>1
   A = [A Z; A A];
   Z = [Z Z; Z Z];
   n = n/2;
end

% Transformation
% ==============
x = rem(A*r',2)';