function schaltsymbole
% schaltsymbole
% Darstellung der klassischen Symbole fr UND, ODER etc.

% Konstanten
% ==========
nin1 = [  1      1      2      2      2      2      2      2  ];
gtp1 = {'BUF'; 'NOT';'XNOR'; 'XOR'; 'NOR'; 'OR'; 'NAND'; 'AND'};
nin2 = [  3      4      4      3  ];
gtp2 = {'NOR';'NAND'; 'NOR'; 'AND'};
x1   = 0;
x2   = 7;
iv   = [5 6 10.5] + 0.1;
col  = 'k';

% Bild und Achsen
% ===============
fh = fullscreen('Schaltsymbole','w',0,[1 2.5; 1 1]);
axis([-5 9 2 3*length(nin1)+2])
axis off
fs = 0.8/diff(get(gca,'YLim'));

% Basisgatter
% ===========
for k=1:length(nin1)  
   drawgate(x1,3*k,nin1(k),gtp1{k},'Color',col); 
   for j=1:nin1(k)
      line(x1+[-2 -1],3*k+(nin1(k)+1)/2-j*[1 1],'Color',col);
   end
   line(x1+[0 1],3*k*[1 1],'Color',col);
   text(x1-2.5,3*k,gtp1{k},'FontUnits','normalized','FontSize',fs,...
        'HorizontalAlignment','right','Color',col)
end

% Gatter mit mehreren und invertierten Eingngen
% ==============================================
for k=1:length(nin2)  
   drawgate(x2,5*k,nin2(k),gtp2{k},'Color',col); 
   for j=1:nin2(k)
      line(x2+[-2 -1],5*k+(nin2(k)+1)/2-j*[1 1],'Color',col);
   end
   line(x2+[0 1],5*k*[1 1],'Color',col);
   text(x2-2.5,5*k,gtp2{k},'FontUnits','normalized','FontSize',fs,...
        'HorizontalAlignment','right','Color',col)
end
text(x2-1.1,5*k+3.2,'Gatter mit mehr als 2 Eingngen','FontUnits','normalized',...
     'FontSize',0.8*fs,'HorizontalAlignment','center','Color',col)
text(x2-1.1,5*k+2.5,'Eingnge teilweise invertiert','FontUnits','normalized',...
     'FontSize',0.8*fs,'HorizontalAlignment','center','Color',col)
for k=1:length(iv)
   text(x2-1,iv(k),'\bullet','FontUnits','normalized','FontSize',1.6*fs,...
        'HorizontalAlignment','center','VerticalAlignment','middle','Color',col)
end

