function stellen2stellencb
% stellen2stellencb
% CallBack-Funktion fr stellen2stellen

cfg = gcf;
fud = get(cfg,'UserData');
q   = fud(1);
n   = fud(2);
z   = fud(3);
uh  = gcbo;
ud  = get(uh,'UserData');

switch ud{1}          % Selektion des uicontrol
   case 1             % Umschalten mathematisch / rechentechnisch
      if ud{2}
        ud{2} = 0;
        set(ud{3},'String',ud{4})
        set(uh,'String',ud{6})
        set(ud{8},'Color','w')
      else
        ud{2} = 1;
        set(ud{3},'String',ud{5})
        set(uh,'String',ud{7})
        set(ud{8},'Color','g')
      end
      set(uh,'UserData',ud)
   case 2             % Takteingabe
      th = ud{2};     % Objekthandle
      u1d = get(ud{8},'UserData'); % UserData von ui1
      if u1d{2}==0                 % auf "rechentechnisch" setzen ?
        u1d{2} = 1;
        set(u1d{3},'String',u1d{5})
        set(ud{8},'String',u1d{7})
        set(th(5),'Color','g');
      end
      i  = ud{3}(1);
      if i<0
         set(th(2),'Color',[0 0.5 0])   
         sound(sin(2*pi*1/8*(0:1000)),8000)
         return
      end
      a  = ud{3}(2);
      r  = ud{3}(3);
      z  = ud{3}(4);
      n  = ud{3}(5);
      set(th(6),'String',['n = ' num2str(n)]);
      set(th(1),'String',['a = ' num2str(a,16)]);
      if i==1  
         set(th(1),'Color','r')
      else
         set(th(1),'Color',[0 0.5 0])
      end
      switch 2+rem(i-2,3)
         case 2
            set(th(2),'String',['(a > 0) = ' num2str(a>0)],'Color','r');
            set(th(1),'Color','r')   
            set(ud{6}(1:3),'Color','w')   
            set(ud{6}(4),'FaceColor','w','EdgeColor','w')   
            set(th(3),'String',' ')
            set(th(4),'String',' ')
            if a==0
               set(th(4),'Color',[0 0.5 0])
               set(th(5),'Position',[ud{4} ud{5}(5)])
               ud{3} = [-1 a r z n];
               set(uh,'UserData',ud)
               r = r + z*q^(n-1);
               set(th(5+n),'Color','b')
               return
            end
         case 3
            set(th(3),'String',['a mod ' num2str(q) ' = ' num2basstr2(rem(a,q),q)],'Color','r');  
            set(th(1:2),'Color',[0 0.5 0])
            set(ud{7}(1:4),'Color','r')   
            set(ud{7}(5),'FaceColor','r','EdgeColor','r')   
            if n>1  set(th(5+n),'Color','b'); end
         case 4
            set(th(4),'String',['a div ' num2str(q) ' = ' num2str(floor(a/q),16)],'Color','r');  
            set(th(3),'Color',[0 0.5 0])   
            set(ud{6}(1:3),'Color','r')   
            set(ud{6}(4),'FaceColor','r','EdgeColor','r')   
            set(ud{7}(1:4),'Color','w')   
            set(ud{7}(5),'FaceColor','w','EdgeColor','w')   
            r = r + z*q^(n-1);
            z = rem(a,q);
            a = floor(a/q);
            dx = -0.027;
            if n>16
               sound(sin(2*pi*1.5/8*(0:1000)),8000)
               return
            end
            set(th(6+n),'String',num2basstr2(z,q,1),'Color','r')
            set(ud{7}(4),'XData',get(ud{7}(4),'XData')+dx)
            set(ud{7}(5),'XData',get(ud{7}(5),'XData')+dx)
            set(ud{7}(3),'XData',get(ud{7}(3),'XData')+[0  dx])
            n = n + 1;
      end   
      set(th(5),'Position',[ud{4} ud{5}(2+rem(i-2,3))]);
      i  = i + 1;
      ud{3} = [i a r z n];
      set(uh,'UserData',ud)
   case 3             % Eingabe z
      str = get(uh,'String');
      z = str2num(str);
      if ~strcmp(str,num2str(z,16))
         sound(sin(2*pi*1/8*(0:1000)),8000)
      elseif z<0
         sound(sin(2*pi*1/8*(0:1000)),8000)
      else
         delete(cfg)
         stellen2stellen(q,z)
      end
   case 4             % Eingabe q
      str = get(uh,'String');
      q = str2num(str);
      if ~strcmp(str,num2str(q,16))
         sound(sin(2*pi*1/8*(0:1000)),8000)
      elseif (q<2)|(q>64)
         sound(sin(2*pi*1/8*(0:1000)),8000)
      else
         delete(cfg)
         stellen2stellen(q,z)
      end
end      