function s = strpowers(z,n)
% s = strpowers(z,n)
% gibt die Liste der Potenzen 1...n von z aus
% z :  String der Basis in Dezimaldarstellung
% n :  maximaler Exponent (numerisch)

% Autor:  Klaus von der Heide, e-mail:  v.d.heide@on-line.de

% Defaults
% ========
if nargin<1  z = '2'; end
if nargin<2  n = 32;  end

% Alternativer Input
% ==================
if isnumeric(z)
   x = num2str(z);
else
   x = z;
end

% Rechnung
% ========
y = '1';
s = '';
for k=1:n  
   y = strmult(x,y,10);  
   s = [s sprintf('%3d   %s\n',k,y)]; 
end;

% Evtl. Ausgabe ins Fenster
% =========================
Potenzen = s;
if ~nargout
   result2fig(Potenzen)
end
