%
%
%10.2  Pegelgesteuertes D-Flipflop %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-2,'Color',MSVTITLCOLOR>
%
%
%
% Die Gleichung  {\fontname{Courier}z = z ;  z\inB = \{0,1\}}  hat die zwei Lsungen  {\fontname{Courier}z = 0}  und  {\fontname{Courier}z = 1} . 
% Eine physikalische Realisierung dieses Trivialschaltwerks mit  {\fontname{Courier}z_{next} = z}  wrde also 
% den beim Einschalten des Schaltwerks angenommenen Zustand bis zum Auschalten 
% beibehalten.  Eine physikalische Realisierung bedarf allerdings einer Energiezufuhr. 
% Deshalb reicht eine einfache Drahtschleife nicht zur Realisierung von  {\fontname{Courier}z = z} .  Die 
% aufwandrmste Form ist meistens die Hintereinanderschaltung zweier Inverter, also 
% {\fontname{Courier}z_{next} = (z')'} . 
%
% Das beschriebene Speicherelement kann zwar sowohl die  {\fontname{Courier}0}  wie auch die  {\fontname{Courier}1}  speichern,
% aber ndern kann man den Speicherinhalt nicht.  Um dies zu erreichen fhrt man zwei 
% Inputvariable ein:  den Dateninput  {\fontname{Courier}D}  und den Takt  {\fontname{Courier}C} .  Im Falle eines taktpegel-
% gesteuerten Zeitgliedes gilt dann:
%
% z_{next} = C'\capz \cup C\capD   %<'FontName',MSVFORMFONT>
%
% Dies ist ein 2-zu-1-Multiplexer, der mit dem Takt  {\fontname{Courier}C}  gesteuert wird und dessen einer 
% Eingang (im Falle  {\fontname{Courier}C = 0} ) mit dem Ausgang verbunden ist (Speicherfunktion) und dessen 
% anderer Eingang zum Einspeichern eines neuen Datenwerts dient.  Das Mealy-Modell des 
% Speichergliedes ist dann:
%
drawmuxff
%
% Der Folgezustand wird hier direkt auch als Ausgabe verwendet.  Im Sinne des Mealy-
% Modells wre es korrekter gewesen, das Multiplexer-Schaltnetz zweimal zu zeichnen. 
% Greift man den Ausgang  {\fontname{Courier}Q}  nicht bei  {\fontname{Courier}z_{next}}  ab sondern bei  {\fontname{Courier}z} , so liegt ein Moore-
% Modell vor.  Da das Zeitglied nur eine Verzgerung darstellt, gibt es bei der Realisierung 
% der beiden Modelle keinen Unterschied.
%
% Das KV-Diagramm ist
%
kvdiagram('(~C&z) | (C&D)',{'C';'D';'z'},{[2 4] [8 7]},1)
%
% In diesem KV-Diagramm ist ein Strukturhasard offensichtlich.  Dass dieser tatschlich 
% essentiell ist, kann man am Verhalten des Schaltwerks erkennen, wenn man probehalber 
% die Verzgerungen variiert.  Wir berechnen zunchst das Verhalten ohne Verzgerungen 
% ausser der notwendigen Verzgerung von 1 in der Rckkopplung:
%
drawsigsmuxff( [1 0 0] )
%
% Nun wird die Verzgerung der beiden UND-Glieder unterschiedlich gewhlt:
%
drawsigsmuxff( [1 1 0] )    % unterschiedliche Verzgerung der UND-Glieder
%
% Hier wird die Verzgerung der beiden UND-Glieder vertauscht:
%
drawsigsmuxff( [1 0 1] )    % unterschiedliche Verzgerung der UND-Glieder
%
% Offenbar funktioniert das Speichern einer  {\fontname{Courier}1}  nicht mehr oder es treten statische 
% {\fontname{Courier}0}-Hasards im Zustand und damit auch in der Ausgabe auf.
%
% Der Strukturhasard ist wie im Abschnitt 8.3.2 beschrieben leicht durch eine zustzliche 
% Schleife im KV-Diagramm zu beseitigen:
%
kvdiagram('(~C&z) | (C&D) | (D&z)',{'C';'D';'z'},{[2 4]  [8 7]  [4 8]},3)
%
% Dieses Hasard-freie pegelgesteuerte D-Flipflop heisst {\bfEarle-Latch}.  Das Mealy-Modell 
% bzw. das einfache Schaltbild ist:
%
drawearlelatch(1)   % Mealy-Modell des Earle-Latch
%
drawearlelatch(0)   % Schaltbild des Earle-Latch
%
% Jetzt arbeitet es auch bei beliebigen zuflligen Verzgerungen korrekt:
%
%% Mehrfach aufrufen wegen der zuflligen Verzgerungen!
drawsigsearle(ceil(4*rand(1,4)))
%
% Das Schaltnetz des Earle-Latch ist frei von Strukturhasards.  Wettlufe kann 
% es nicht geben, da es nur ein einziges Zustandsbit in der Rckkopplung gibt.
% Dieses nichtgetaktete Schaltwerk arbeitet deshalb sicher auch bei beliebigen 
% individuellen Verzgerungen der Verknpfungen, solange die generelle 
% Voraussetzung fr nichtgetaktete Schaltwerke eingehalten wird, dass nmlich 
% der Input sich nur einschrittig ndert, und auch nur dann, wenn sich das 
% Schaltwerk in einem stabilen Zustand befindet.  Wir kommen auf dieses 
% Thema zurck im Abschnitt 10.5 .
%
% Das Zustandsdiagramm des taktpegelgesteuerten Flipflops ist sehr einfach,
% weil es aufgrund des einzigen Zustandsbit nur zwei Zustnde gibt:
%
demofsm([1 1 2 1; 2 1 2 2],{'0';'1'},1,1,{'00';'01';'11';'10'},'D,C')
%