%
%
%10.5  Voreinstell- und Haltezeit %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Wir haben fr nichtgetaktete Schaltwerke generell gefordert:
%
% (1)  Der Eingang  {\fontname{Courier}x}  ndert sich nur, wenn das Schaltwerk  sich in einem stabilen 
%       Zustand befindet.
%
% (2)  Der Eingang  {\fontname{Courier}x}  ndert sich nur einschrittig.
%
% Wir wollen in diesem Abschnitt die Konsequenzen dieser Einschrnkung fr Flipflops 
% behandeln.  Die Einschrnkung bedeutet, dass sich Dateneingang und Takt nicht 
% gleichzeitig ndern drfen.  Mehr noch: wenn sich der Dateneingang gendert hat,
% darf die nchste Taktflanke erst auftreten, wenn das Flipflop einen stabilen Zustand 
% erreicht hat.  Entsprechend gilt: wenn eine Taktflanke aufgetreten ist, darf sich der 
% Dateneingang erst wieder ndern, wenn das Flipfop einen stabilen Zustand erreicht hat.  
% Demnach darf sich das Datensignal in einem Zeitintervall  {\fontname{Courier}[T - S , T + H]}  um den 
% Zeitpunkt  {\fontname{Courier}T}  der Taktflanke nicht ndern.  Wir nennen  {\fontname{Courier}S}  die Voreinstellzeit (setup time) 
% und  {\fontname{Courier}H}  die Haltezeit (hold time).  {\fontname{Courier}S}  und  {\fontname{Courier}H}  sind Worst-Case-Werte fr die entsprechenden 
% Zeiten zum Erreichen der stabilen Zustnde.  Im Gegensatz zu unserer Entwurfsforderung, 
% unabhngig von allen individuellen Verzgerungen zu sein, mssen wir uns hier darauf 
% verlassen, dass hergestellte Flipflops die fr den jeweiligen Typ angegebenen Zeiten  
% {\fontname{Courier}S}  und  {\fontname{Courier}H}  nicht berschreiten.
%
% Nachfolgend geben wir einige Beispiele fr das Verhalten von Flipflops bei Dateninput-
% nderung innerhalb des verbotenen Intervalls.  Man beachte aber, dass dies das Verhalten 
% eines Modells ist.  Das tatschliche Verhalten ist abhngig von der Technologie.
%
%
% \bfTaktpegel-gesteuertes Earle-Latch (Kap. 10.2)
%
drawsigsshearle
%
%
% \bfTaktpegel-gesteuertes D-Latch (Kap. 10.4)
%
drawsigsshdlatch
%
%
% \bfRckflankengesteuertes D-Flipflop (Kap. 10.4)
%
drawsigsshdffn
%
%
%% Entsprechende Beispiele fr die anderen Flipfloptypen kann der Leser durch eigene Versuche finden.
%
% Die Funktionen  {\fontname{Courier}drawsigsshearle} ,  {\fontname{Courier}drawsigsshdlatch}  und  {\fontname{Courier}drawsigsshdffn}  haben 
% alle als Parameter die Struktur zur Festlegung der Verzgerungen:
% dly  : CellArray der Vektoren der Verzgerungen der logischen Glieder    %<'FontName',MSVFORMFONT>
%        in der Reihenfolge ihres Auftretens beim Traversieren der zu den  %<'FontName',MSVFORMFONT>
%        schaltalgebraischen Ausdrcken der berfhrungsfunktion gehrigen %<'FontName',MSVFORMFONT>
%        Bume.  Diese Ausdrcke stehen im Titel der mit den Funktionen    %<'FontName',MSVFORMFONT>
%        generierten Bilder.  Die Verzgerungen der Gatter mssen          %<'FontName',MSVFORMFONT>
%        ganzzahlig und auf dem Rckkopplungsweg grsser als 0 sein.       %<'FontName',MSVFORMFONT>
%
% Im Fall von  {\fontname{Courier}drawsigsshdlatch}  sind die Ausdrcke z.B.
%
% ~(z2&~(C&D))  ;  ~(z1&~(C&~(C&D)))                                       %<'FontName',MSVFORMFONT>
%
% Der erste Ausdruck hat zwei Gatter, der zweite drei.  Die Verzgerungen sind also
%
% { [ v1\_1  v1\_2 ] ; [ v2\_1  v2\_2  v2\_3 ] }                           %<'FontName',MSVFORMFONT>
%
% mit ganzzahligen Werten fr die  {\fontname{Courier}vi\_j}  und  {\fontname{Courier}v1_1 > 0} ,  {\fontname{Courier}v2_1 > 0} .
%
% Ein Versuch ist damit z.B.
%
drawsigsshdlatch( { [2 1] ; [1 0 2] })
%