%
%
%12.2  Register  %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Ein Register ist ein Bndel von  {\fontname{Courier}n}  gleichen Flipflops, die alle mit dem selben Takt 
% arbeiten und bei denen sowohl der Dateneingang wie der Datenausgang als Bndel 
% von je  {\fontname{Courier}n}  Bits behandelt wird:
%
drawdreg
%
% Das Verhalten des Registers entspricht dem des benutzten Flipfloptyps.  Das Zeitverhalten 
% wird auf der R-T-Ebene fr alle Flipflops als gleich angenommen.  Das Register hat also 
% eine Voreinstell- und eine Haltezeit wie die seiner Komponenten.
%
% Neben den einfachen Datenregistern, die als Zwischenspeicher von n-Bit-Wrtern dienen 
% gibt es die {\bfSchieberegister}.  Ein n-Bit-Rechts-Schieberegister ist ein spezielles 
% getaktetes Schaltwerk, fr dessen Zustandsbits gilt:
%
% z_{1,next} = x                       %<'FontName',MSVFORMFONT>
% z_{i,next} = z_{i-1}   (i=2,...,n)   %<'FontName',MSVFORMFONT>
%
% Die Ausgabe kann sein:
%
% {\fontname{Courier}y_i = z_i  \forall i}    (paralleler Ausgang von n Bits)
%
% oder nur  {\fontname{Courier}y = z_n}  (serieller Ausgang, 1 Bit)
%
% Die Realisierung dieses Schieberegisters ist sehr einfach.  Es ist nur jeweils der 
% Dateneingang des i-ten Flipflops mit dem Ausgang des (i-1)-ten Flipflops zu verbinden.
% Das Zustandsdiagramm dieses fast trivialen Schaltwerks ist berraschend komplex, wie 
% das folgende Beispiel des 4-Bit-Schieberegisters zeigt:
%
fsmshiftregister(4)
%
% Deutlich aufwndiger ist ein Schieberegister, welches gesteuert durch ein Inputbit  {\fontname{Courier}S} 
% in beide Richtungen schieben kann.  blich ist in diesem Fall das parallele Laden 
% aller Flipflops ber einen entsprechend breiten Dateneingang {\fontname{Courier}D}.  Geladen wird, 
% wenn das Inputbit  {\fontname{Courier}L}  gesetzt ist.  Es muss vor jedem  {\fontname{Courier}D}-Eingang der Flipflops ein 
% 3-zu-1-Multiplexer sein, mit dem das aktuell zu speichende Bit gewhlt werden kann:
%
% z_{i,next} = L'\cap(s'\capz_{i-1} \cup s\capz_{i+1}) | L\capD_i   (i=1,...,n)   %<'FontName',MSVFORMFONT>
%
% Wir sehen uns solch ein Links-Rechts-Schieberegister mit parallelem Laden wieder 
% am einfachen Fall von  {\fontname{Courier}n = 4}  an.  Die Flusstafel wrde aber mit den 6 Inputbits 
% {\fontname{Courier}S, L, D_1, D_2, D_3, D_4}  sehr unbersichtlich werden.  Wir verzichten deshalb 
% in der Graphik auf die D-Bits und laden mit  {\fontname{Courier}L = 1}  zufllige Bitmuster:
%
fsmleftrightsr
%
% Man kann die vierte Codierung der Eingabe  {\fontname{Courier}L=1; S=1}  verwenden, um das Schieben 
% und das Laden gleichzeitig zu unterbinden.  Dadurch erhlt man an jedem Zustand eine 
% Schlinge (hier ist n=4 fest vorgegeben):
%
fsmlrsshiftregister
%
% Schieberegister sind wichtig bei der Realisierung der Multiplikation.  Ein Schritt 
% nach links entspricht der Multiplikation mit 2, ein Schritt nach rechts der Division 
% durch 2.
%
%
% Unter einer {\bfRegisterbank} versteht man eine meist kleine Zahl (4 ... 32) von 
% gleichen Datenregistern, die ber einen gemeinsamen Zugriffskanal verfgen.
%
