%
%
%12.4  Multiplexer  %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Multiplexer sind Datenselektoren:  Es gibt  {\fontname{Courier}k}  Bndel von je  {\fontname{Courier}n}  Bit als Dateneingnge, von 
% denen jeweils einer auf den  {\fontname{Courier}n}-Bit-breiten Ausgang durchgeschaltet wird.  Die Auswahl 
% erfolgt durch eine  {\fontname{Courier}m}-Bit-breite Steuergrsse  {\fontname{Courier}s} .  Zumeist ist  {\fontname{Courier}k}  eine Potenz von  {\fontname{Courier}2}  und  
% {\fontname{Courier}m = log_2(k)} .  Man spricht dann von einem  {\fontname{Courier}n}-fach-{\fontname{Courier}k}-zu-{\fontname{Courier}1}-Multiplexer.
%
% Das folgende Bild stellt eine Schema des Multiplexers dar:
%
drawmux(2)
%
% Der Multiplexer ist eines der wichtigsten Bausteine auf der R-T-Ebene.  
% Der  {\fontname{Courier}2}-zu-{\fontname{Courier}1}-Multiplexer ist funktional vollstndig.
%
% Das Verhalten des {\fontname{Courier}n}-fach-{\fontname{Courier}k}-zu-{\fontname{Courier}1}-Multiplexers ist in allen Programmiersprachen 
% mit speziellen Sprachkonstrukten beschreibbar, ein  4-zu-1-Multiplexer mit den Eingngen 
% {\fontname{Courier}a, b, c, d}  und der Steuergrsse  {\fontname{Courier}s (s\in\{0,1,2,3\}}  in MATLAB z.B. durch
%
% switch s           %<'FontName',MSVFORMFONT>
% case 0, y = a;     %<'FontName',MSVFORMFONT>
% case 1, y = b;     %<'FontName',MSVFORMFONT>
% case 2, y = c;     %<'FontName',MSVFORMFONT>
% case 3, y = d;     %<'FontName',MSVFORMFONT>
% end                %<'FontName',MSVFORMFONT>
%
% Multiplexer lassen sich mit relativ geringem Aufwand realisieren.  
% Der 2-zu-1-Multiplexer fr ein Bit wurde schon als Schaltfunktion besprochen:
%
% y = ~s\capa \cup s\capb  %<'FontName',MSVFORMFONT>
%
% Fr eine Breite von  {\fontname{Courier}n}  Bit der Eingnge wird dieses  {\fontname{Courier}n}  mal parallel realisiert. 
% Den 4-zu-1-Multiplexer realisiert man entweder direkt in der Form
%
% y = s1'\caps2'\capa \cup s1\caps2'\capb \cup s1'\caps2\capc \cup s1\caps2\capd  %<'FontName',MSVFORMFONT>
%
% oder unter rekursiver Verwendung von 2-zu-1-Multiplexern  {\fontname{Courier}mux(s,a,b)} :
%
% y = mux( s2, mux(s1,a,b), mux(s1,c,d) )   %<'FontName',MSVFORMFONT>
%
%% bung:  Geben Sie den Realisierungsaufwand  M1,  M2,  Z1,  Z2  fr beide Strukturen in 
%% Abhngigkeit der Bitbreite  k  und  der Anzahl der Eingnge  n = 2^m  an.
%
% Die rekursive Methode ist besonders aufwandsarm, aber langsamer.
%