%
%
%1.2  Geschichte der Informatik%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Wissenschaft hat man auf allen Gebieten betrieben, bevor die Gebiete sich im 
% einzelnen herauskristallisiert haben und einen eigenen Namen bekamen.
%
% Die Definition der  {\bfInformatik}  aus dem vorigen Kapitel setzt den programmierbaren 
% Rechner nicht voraus.  berall, wo gemessen und Gemessenes verwaltet wurde, war 
% Informatik.
%
% Die Lnge des Jahres von  {\fontname{Courier}365 ^1/_4}  Tagen war immerhin bekannt vor  {\fontname{Courier}6230}  Jahren.  
% Fr solch eine Messung muss es nicht nur Messverfahren geben, sondern auch 
% Mglichkeiten der sprachlichen Bezeichnung und der schriftlichen Fixierung von 
% Zahlen der Grenordnung  {\fontname{Courier}10000} .
%
% Beispiele fr alte Schriften von Zahlen geben die folgenden Bilder.  Lange vor 
% der Erfindung der Schrift wurden Zhlsymbole benutzt:  
%
openbyextension('susa-tonkugel.jpg')
%
% Die etwa  5000 Jahre alten versiegelten Tonkugeln enthielten stellvertretend 
% fr irgendetwas die Zhlsymbole.  Auf diese Weise konnte man vor der Einfhrung 
% der Schrift quantitativ festgelegte Vertrge abschlieen.
%
% Nippur in Mesopotamien, wo man ca.  {\fontname{Courier}50000}  Tontafeln fand, wurde im Jahre  {\fontname{Courier}-1955} von 
% den Elamiten zerstrt.  Die Tafeln sind also durchweg lter.  Dies ist etwa die Zeit, 
% als die Abstraktion zur Zahl an sich vollzogen wurde.  Sehr lange vorher hat man 
% schon genau Buch gefhrt, jedoch bei Zahlenangaben grundstzlich das Gezhlte mit 
% benannt.  Die meisten Zahlennotationen galten sogar jeweils nur fr Getreide bzw. 
% fr Grundstckgren, fr Stck Vieh usw..
%
% Bierzuteilungen an bestimmte Personen fr bestimmte Veranstaltungen:
%
openbyextension('bierzuteilungen.jpg')
%
% Wie heute wurden Dokumente auch damals kopiert und an mehreren Stellen verwahrt:
%
openbyextension('uebersetzung.jpg')
%
% Viel jnger, nmlich  {\fontname{Courier}3400}  Jahre alt Wandmalereien aus Abd-el-Qurna, die sehr
% schn das Messen und Registrieren zeigen.  
%
openbyextension('abd-el-qurna.jpg')
%
% Das Messen ist der Ursprung der Zahl.  Die Zahl ist die Abstraktion vom Gemessenen 
% und beruht auf dem Distributivgesetz fr Anzahlen von Dingen, die man abzhlen kann:
%
distributivzahl
%
% Es gilt also
%
%          a X   +   b X   =   (a + b) X      %<'FontName',MSVFORMFONT>
%
% wo  {\fontname{Courier}a}  und  {\fontname{Courier}b}  und  {\fontname{Courier}a + b}  Anzahlen der zu zhlenden Einheit  {\fontname{Courier}X}  sind.
% X steht z.B. fr pfel, Euro etc.
%
% Weitere Beispiele:
%
% Eine Schulbung zur Notation der Zahlen 1 bis 9 aus Mesopotamien:
%
openbyextension('schuluebung.jpg')
% 
% Diese folgende Tafel aus Schuruppak hat 104 Eintragungen ber die Grsse von 
% Feldern und die Namen und Berufe der Eigentmer.  Die Tafel stammt aus der 
% Zeit um 2600 v.Chr:
%
openbyextension('schuruppak.jpg')
%
% Eine Jahresabrechnung ber die Ttigkeit von 36 Arbeiterinnen zum Mahlen von 
% Mehl mit der Gesamtgenauigkeit von  1/6  Arbeitstag bzw. ca.  Liter Mehl:
%
openbyextension('jahresabrechnung.jpg')
%
% gyptische Hieroglyphen mit Zahlenangaben:
%
openbyextension('aegyptisch.jpg')
%
% Die alten Zahlenschriften sind nicht gut geeignet fr Algorithmen zur Addition und 
% Multiplikation.  Z.B. wre die Addition einer Mehrwertsteuer von  {\fontname{Courier}16%}  sehr 
% kompliziert.  Dieses Problem wurde damals durch Tabellen gelst, die ein erstes 
% Beispiel fr Datenstrukturen liefern.
%
% Auch kannte man das Problem von Diskrepanzen zwischen karteimig gefhrten 
% und tatschlich vorhandenen Bestnden und fand Lagermethoden, die einerseits das 
% Entwenden erschwerten und andererseits auch die Ermittlung von Diskrepanzen 
% ermglichten.  Das folgende Bild aus Kalkutta gibt ein Beispiel.
%
openbyextension('kalkutta.jpg')
%
%% Wieviele Kugeln mag der groe Haufen rechts im Vordergrund enthalten ?
%% ca.:      100      400      1600      6400    ??
%
% Auch in Nippur fand man Tontafeln mit Tabellen der Dreiecks und Pyramidenzahlen. 
% Sei die Breite (und damit auch die Giebelseite) der Pyramide  {\fontname{Courier}n}  und die Firstlnge  {\fontname{Courier}m} , 
% dann ist der Pyramideninhalt
%
%         n        n                                             %<'FontName',MSVFORMFONT>
% (m - 1)_{\fontsize{26}\Sigma} i  +  _{\fontsize{26}\Sigma} i^2 %<'FontName',MSVFORMFONT>
%        i=1      i=1                                            %<'FontName',MSVFORMFONT>
%
% Dies lsst sich umformen in
%
% n*(n+1)*((2*n+1)/3 + m - 1)/2                                  %<'FontName',MSVFORMFONT>
%
% Diese Funktion  {\fontname{Courier}pyramidenzahl(n,m)}  ergibt:
%
pyramidenzahl(23,8)
%
%
% Das Sexagesimalsystem der Sumerer  -  jedoch nicht seine Schreibweise  -  hat sich 
% bis heute ber die Griechen und Rmer in der Zeit- und Winkeleinteilung erhalten.
%
% Ein technisches Hilfsmittel fr die algorithmische Durchfhrung arithmetischer 
% Operationen ist der Abacus.  Im folgenden Bild ist die Addition mit einem 
% japanischen gezeigt.  Der Abacus ist ein Akkumulator.  Er ist Stellen-orientiert
% und kennt die Null.  Dies ist den ersten Benutzern wohl nicht bewusst gewesen.
%
openbyextension('abacus.jpg')
%
%% Einen Abacus auf dem OH-Projektor mit einer mehrstelligen Addition vorfhren.
%
% Die neuere Geschichte wird durch die nachfolgenden Bilder illustriert: 
%
% Der Universahlgelehrte Leibnitz hat nicht nur das Binr-System eingefhrt 
% sondern auch Rechenmaschinen erfunden:
%
openbyextension('leibnitz.jpg')
%
% Der Pfarrer Philip Matthus Hahn konstruierte erstmals Maschinen mit dem Ziel 
% der leichten Reparierbarkeit und betrieb eine Fabrik:
%
openbyextension('phmhahn.jpg')
%
% Charles Babbage konstruierte zunchst eine Maschine zur berechnung von 
% Tabellen:
%
openbyextension('babbagediffeng.jpg')
%
% Dabei entdeckte er die Mglichkeit der allgemeinen Programmierbarkeit eines 
% solchen Automaten.  Seine Konstruktion einer solchen programmierbaren Maschine 
% ist wegen technische Probleme nie lauffhig geworden:
%
openbyextension('babbageanalyteng.jpg')
%
% Konrad Zuse baute den ersten Rechenautomaten mit Binrsystem:
%
openbyextension('Z1-v3.jpg')
%
openbyextension('Z1-vb2.jpg')
%
openbyextension('Z1-ble.jpg')
%
% Die Z3 von Zuse:
%
openbyextension('Z3.jpg')
%
% Die Havard Mark 1:
%
openbyextension('mark1.jpg')
%
