%
%
%1.3  Grundbegriffe%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%\bfBegriffsdefinitionen
%
% Als  {\bfInformation}  bezeichnet man den abstrakten Gehalt einer Aussage.
%
% Die Aussage selbst, mit der die Information bertragen wird, ist eine  
% {\bfReprsentation} der Information.
%
% Das Ermitteln der Information aus einer Reprsentation heit  {\bfInterpretation}.
%
% Das Verbinden einer Information mit ihrer Bedeutung in der realen Welt 
% heit  {\bfVerstehen}.
%
%\bfBeispiele fr Reprsentationen der Information "25"
% 
% Mit Information "25" ist die abstrakte Zahl gemeint, 
% die sich aber nur durch eine Reprsentation angeben lt.
%
% Text deutsch:    fnfundzwanzig    Text dnisch:    femogtyve
%
% schwedisch:  tjugofem    englisch:   twentyfive    finnisch:  kaksikymntviisi
%
% Zahl rmisch:   XXV     Zahl dezimal, arabisch:   25
%
% Zahl dezimal, gyptisch:   UUIIIII  (das U muss auf dem Kopf stehen)   
%
% Zahl binr :   110012    Zahl Dreiersystem:   2213
%
% Zahl hexadezimal:   $0019      Morse-Schrift:   ..--- .....                    
%
%
% Wo auch immer Reprsentationen auftreten, meinen wir die Information, z.B.:
%
%            5 * ( 2 + 3 ) = 25      %<'FontName',MSVFORMFONT>
%
% Die Information selbst kann man berhaupt nicht notieren!
%
% Es muss immer Absprachen geben ber die jeweilige Reprsentation.
% Es hilft z.B. nicht, statt  {\fontname{Courier}25}  hier  {\fontname{Courier}25_{10}}  zu schreiben um anzudeuten, dass 
% es sich um eine Dezimalzahl handelt.  Dazu muss man schon die Dezimalziffern 
% kennen und berdies noch sagen, dass die tiefgestellte  {\fontname{Courier}10}  dezimal geschrieben 
% ist.  Um solche Absprachen zu machen, muss man sich absprechen, in welcher 
% Sprache man sich absprechen will...
%
% Bei Texten und gesprochener Sprache wird die Sprache nicht ausdrcklich abgemacht.  
% Die Reprsentation einer Information in Sprache  X  ist fast immer so, dass dies 
% in Sprache  Y  keine interpretierbare Reprsentation ist.  Die Interpretierbarkeit 
% wird dann als Information ber die benutzte Sprache verwendet.
%
% Ein natrlich-sprachlicher Satz ist meistens eine so komplizierte Reprsentation, 
% dass die Information sogar bei Fehlern in der Reprsentation noch verstanden wird. 
% Beispiel:
%
% Als das Teleklingel fonte, treppte ich die Rannte hinunter und trte gegen die Bumms.
%
% In akustisch stark gestrter Umgebung wird solch ein Satz allerdings viel 
% schwerer als ein korrekter verstanden.
%
% Viele natrlich-sprachliche Reprsentationen sind nur im  {\bfKontext}  zu verstehen. 
%
% Beispiel (gesprochen):    Obelix ist (isst) ein Schwein.
%
% Um solch einen Satz richtig zu bersetzen muss ein automatisches bersetzungssystem 
% den Kontext verstehen. 
%
% Knstliche Sprachen fr die Informationsverarbeitung drfen Ambiguitten dieser 
% Art nicht enthalten.
%
% 
%\bfReprsentation natrlicher Zahlen durch Stellensysteme:
%
inforepres
%
% Ergibt  \alpha  gefolgt von  \sigma  dasselbe wie  \nu  gefolgt von  \alpha' , 
% so heit  \nu  {\bfinformationstreu} ,
%
% formal:
%         
% \sigma ( \alpha ( r ))  =   \alpha'( \nu ( r )).
%
% Mit  \alpha'  ist hier die Interpretation des Resultats der Operation  \nu  gemeint.  
% Hufig sind  \alpha  und  \alpha'  gleich, aber nicht immer.
%
% Ist  \sigma  injektiv, so nennen wir  \nu  eine  {\bfUmschlsselung} .  In diesem 
% Fall geht durch die Verarbeitung  \sigma  keine Information verloren.
%
% Ist auch  \nu  injektiv, so nennen wir  \nu  eine  {\bfUmcodierung} .  
% Bei injektivem  \sigma  ist dies in den hheren Reprsentationsebenen 
% hufig der Fall, bei der physikalischen Reprsentation meistens nicht.
%
% Wenn  \sigma  eine innere Verknpfung der Menge  J  ist und  \nu   
% eine innere Verknpfung der Menge  R , dann ist  \alpha   ein  
% {\bfHomomorphismus}  der algebraischen Strukturen  (J,\sigma)  und  (R,\nu). 
% 
% Ist berdies  \sigma  bijektiv, so liegt ein  {\bfIsomorphismus}  vor.
% 
% Reprsentationen sind meistens  mehrstufig , genauer: 
%
% Die Reprsentation einer Information erfolgt hufig ber mehrere 
% Abstraktionsebenen.  Beispiel:
%
% \bfAbstraktionsebene
%
% Zahl                                                 Dezimalzahl \rightarrow abstrakte Zahl %<'FontName',MSVFORMFONT>
%                                                          347                                %<'FontName',MSVFORMFONT>
%
% Ziffer                        8-Bit-Byte \rightarrow Dezimalziffer                          %<'FontName',MSVFORMFONT>
%                                01100111         3                                           %<'FontName',MSVFORMFONT>
%                                01101000         4                                           %<'FontName',MSVFORMFONT>
%                                01101110         7                                           %<'FontName',MSVFORMFONT>
%
% Bit  elektrische Spannung \rightarrow Bit                                                   %<'FontName',MSVFORMFONT>
%            3.5 Volt          1                                                              %<'FontName',MSVFORMFONT>
%            0.1 Volt          0                                                              %<'FontName',MSVFORMFONT>
%
% In jeder Ebene gibt es beliebig viele Alternativen der Reprsentation. 
%
% In Rechensystemen werden hufig mehrere Reprsentationen nebeneinander benutzt.
% Die Reprsentationen der Zahl   {\fontname{Courier}3.1415926535}  sind z.B. verschieden 
% je nachdem, wo  sie gespeichert ist:
%
% im Prozessor-Register
% im Hauptspeicher
% auf Festplatte
% auf Diskette
% auf CD-ROM
%
% und  als was  sie gespeichert ist:
%
% als Datum
% als Text
%
%\bfReprsentation der Binrzeichen durch elektrische Spannung:
%
% Die Reprsentation von Bits erfolgt in der physikalischen Ebene durch zwei 
% Werte-Intervalle einer physikalischen Gre (meistens der elektrischen Spannung, 
% im Bild vertikal).  Ein zwischen den Intervallen liegender Wert (grauer Bereich 
% im Bild) kann nicht interpretiert werden, ist aber zulssig.  Ausserhalb liegende 
% Werte (dunkle Bereiche im Bild) knnen zu dauerhaften Schden fhren und sind 
% deshalb unzulssig.  Horizontal im Bild ist im Falle der Kommunikation die Zeit, 
% im Falle der Speicherung z.B. der Ort in einem Speichermedium.
% Typische TTL-Signale:
%
demobitrep(randb(24),[0.2 3.5],[-0.5 0.7; 2.0 5.5],[0.1 0.5])
%
% Signale bei 5V-CMOS:
%
demobitrep(randb(24),[0 5],[-0.5 1.2; 3.8 5.5],[0.1 0.1])
%
%
%\bfReprsentation eines zeitkontinuierlichen Signals durch 
%\bfendlich viele diskrete Zahlenwerte
% (der letzte Parameter gibt die Anzahl der Bits an):
%
fktabtast(5,10,'0.4*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',6);
%
%
% \bfAnaloge und digitale Systeme
%
% In analogen Systemen werden abstrakte Zahlen durch je einen
% aktuellen Wert einer physikalischen Grsse reprsentiert. 
% 
% In digitalen Systemen wird eine kleine Zahl von  b  Symbolen durch  b 
% nicht berlappende Intervalle einer physikalischen Gre reprsentiert. 
% Heute ist fast immer  b = 2.  Jede Information muss in den hheren Schichten 
% durch Wrter aus den Symbolen reprsentiert werden.
%
% Beispiele:
%
% Analogrechner zur Addition:  
% Hintereinanderlegen von Zollstcken.
% Z.B.    37 cm  +  41 cm  =  78 cm
%
% Digitalrechner in TTL-Technologie:
% Symbol  0  wird reprsentiert durch Spannung im Bereich [-0.5V, 0.8V]
% Symbol  1  wird reprsentiert durch Spannung im Bereich [2.0V, 5.5V]
%
% Vor- und Nachteile:
%
% Analogrechner sind sehr viel schneller als Digitalrechner, aber prinzipiell 
% nicht informationstreu.
% Analogrechner knnen nur mit Einschrnkungen frei programmiert werden.
%