%
%
%3.1  Gleitkommaformate%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Die im Kapitel 2 behandelte Zahlenreprsentation ist fr viele Zwecke nicht 
% geeignet, weil der Bereich der reprsentierbaren Werte zu klein ist.  In der Physik 
% vorkommende Zeiten (z.B. Halbwertszeiten von Teilchen) berstreichen 40 dezimale 
% Grenordnungen.  Dem entsprechend msste der Binrpunkt einer Festkomma-
% reprsentation um  {\fontname{Courier}log_2(10^{40}) \approx 133}  Binrstellen verschiebbar sein.  Fr eine 
% akzeptable Genauigkeit bei den absolut kleinsten Zahlen sollten noch ca. 50 Bits 
% rechts des Binrpunktes verbleiben.  Insgesamt wren  183 Bits die untere Grenze 
% fr eine Reprsentation wissenschaftlicher Daten durch eine Festkommadarstellung.  
% Die relative Genauigkeit ist dabei abhngig von der absoluten Grsse der Zahl.
%
% Konrad Zuse fhrte deshalb die in den Wissenschaften schon lange bliche halb-
% logarithmische Notation der Form  {\fontname{Courier}-3.7215*10^5}  auch bei der binren Reprsentation 
% ein.  Heute wird diese Reprsentation als Gleitkommaformat bezeichnet.  Jede Zahl  {\fontname{Courier}z}
% wird dabei zerlegt nach
%
% z = v * m * b^e                                                 %<'FontName',MSVFORMFONT>
%
% Die Komponenten  {\fontname{Courier}v, m, e}  werden getrennt binr reprsentiert.  Fr das Vorzeichen  {\fontname{Courier}v} 
% gengt ein einziges Bit.  Die Anzahl der Bit zur Reprsentation der Mantisse  {\fontname{Courier}m}  
% bestimmt die relative Genauigkeit der Reprsentation, und die Anzahl der Bits zur 
% Reprsentation des Exponenten  {\fontname{Courier}e}  legt den Bereich der darstellbaren Zahlen fest.  
% Da bei der Multiplikation zweier so reprsentierter Zahlen deren Exponenten addiert
% werden, liegt es nahe, fr die Reprsentation der Exponenten das  b-Komplement zu 
% verwenden.  Um Grenvergleiche von Zahlen in Festkomma- und Gleitkommadarstellung 
% mit der selben Hardware durchfhren zu knnen, wird anstelle des b-Komplements 
% durchweg eine Exzess-Darstellung verwendet.  Dabei wird immer anstelle von  {\fontname{Courier}e} 
% der Wert  {\fontname{Courier}r = e + a}  reprsentiert mit einem festgelegten  {\fontname{Courier}a} ,
% wobei  {\fontname{Courier}r > 0} .
%
% Der bersichtlichkeit halber betrachten wir zunchst eine solche Reprsentation 
% im Dezimalsystem.  Als Beispiel legen wir fest:  
%
% {\fontname{Courier}m}  habe  {\fontname{Courier}4}  Dezimalstellen
% Der Dezimalpunkt stehe zwischen der ersten und der zweiten Stelle
% {\fontname{Courier}e}  habe  {\fontname{Courier}2}  Dezimalstellen
% Die Basis sei   {\fontname{Courier}b = 10}
% Der Exzess sei  {\fontname{Courier}a = 50}
%
% Damit wird anstelle des Exponenten als natrliche Zahl reprsentiert:  {\fontname{Courier}r = e + a}
% 
% Die Zahl  {\fontname{Courier}\pi}  wird dann reprsentiert durch
%
% +1 * 3.142 * 10^0 ;   also  v = 1 ;  m = 3.142 ;  r = 50        %<'FontName',MSVFORMFONT>
%
% oder durch
%
% +1 * 0.314 * 10^1 ;   also  v = 1 ;  m = 0.314 ;  r = 51        %<'FontName',MSVFORMFONT>
%
% +1 * 0.031 * 10^2 ;   also  v = 1 ;  m = 0.031 ;  r = 52        %<'FontName',MSVFORMFONT>
%
% +1 * 0.003 * 10^3 ;   also  v = 1 ;  m = 0.003 ;  r = 53        %<'FontName',MSVFORMFONT>
%
% +1 * 0.000 * 10^4 ;   also  v = 1 ;  m = 0.000 ;  r = 54        %<'FontName',MSVFORMFONT>
%
% Offenbar ist die Darstellung nicht eindeutig.  Die Eindeutigkeit kann jedoch leicht 
% durch eine zustzliche Forderung hergestellt werden, nmlich: 
%
% Vor dem Punkt in der Darstellung der Mantisse soll genau eine Ziffer stehen und 
% diese soll nicht  {\fontname{Courier}0}  sein.  Eine Reprsentation in dieser Form nennt man normalisiert.  
% In der normalisierten Form wird die grte relative Genauigkeit erreicht.  Auch wenn 
% Gleitkommazahlen in Rechnersprachen hufig als "real" bezeichnet werden, so kann 
% man damit nur endlich viele verschiedene rationale Zahlen genau reprsentieren. 
%
% Auf Rechnern werden Gleitkommazahlen binr reprsentiert.  Man fgt dabei  {\fontname{Courier}v} ,  {\fontname{Courier}r}  und  {\fontname{Courier}m}
% lckenlos aneinander zu einem Binrwort.  Am weitesten verbreitet sind die in der Norm 
% IEEE-754  festgelegten Formate fr Binrwrter der Lngen  {\fontname{Courier}32} ,  {\fontname{Courier}64}  und  {\fontname{Courier}80}  Bit.
% Einige Festlegungen dieser Formate zeigt die folgende Tabelle:
%
%
% Gleitkomma-Formate nach IEEE-754                                               %<'FontName',MSVFORMFONT>
% ================================                                               %<'FontName',MSVFORMFONT>
%
% Bezeichnung:                          short real   long real  temporary real    %<'FontName',MSVFORMFONT>
% ----------------------------------------------------------------------------   %<'FontName',MSVFORMFONT>
% Wortlnge (Bits)                              32          64          80       %<'FontName',MSVFORMFONT>
% Lnge der Mantissenreprsentation (Bits)      23          52          64       %<'FontName',MSVFORMFONT>
% MSB der normalis. Mantisse reprsentiert:   nein        nein          ja       %<'FontName',MSVFORMFONT>
% Lnge der Exponentenreprsentation             8          11          15       %<'FontName',MSVFORMFONT>
% Exzess a                                     127        1023       16383       %<'FontName',MSVFORMFONT>
% absolut kleinste normalisierte Zahl         2^{-126}      2^{-1022}      2^{-16382} %<'FontName',MSVFORMFONT>
% absolut kleinste Zahl > 0                   2^{-149}      2^{-1074}      2^{-16446} %<'FontName',MSVFORMFONT>
% absolut grte Zahl < +inf              2^{128}-2^{104}  2^{1024}-2^{971}  2^{16384}-2^{16318} %<'FontName',MSVFORMFONT>
%
% Eine Besonderheit der normalisierten binren Darstellung ist, dass das hchstwertige 
% Bit der Mantisse immer  {\fontname{Courier}1}  ist.  Man speichert es deshalb nicht und beginnt in der 
% Reprsentation der Mantisse mit dem folgenden Bit.  Dies ist bei der Angabe der 
% Mantissenlnge in der obigen Tabelle schon bercksichtigt, die wahre Lnge ist um  {\fontname{Courier}1} 
% grer.  Das gilt jedoch nur fr short real und long real.  Temporary real wird 
% nur Prozessor-intern benutzt.
%
% Neben der normalisierten Form gibt es die denormalisierte Form.  Wenn nmlich der 
% Exponent den kleinsten mglichen Wert hat, also reprsentiert wird durch  {\fontname{Courier}r = 0}, 
% dann kann man kleinere Zahlen mit einer nicht normalisierten Mantisse schreiben. 
% In der Notation unseres oben benutzten dezimalen Beispiels ist  {\fontname{Courier}1.000 * 10^{-50}}  
% die absolut kleinste normalisiert darstellbare Zahl.  Dennoch kann man z.B. die 
% Zahl  {\fontname{Courier}+0.725613 * 10^{-52}}  notieren, nmlich in der nicht normalisierten Form
% {\fontname{Courier}+0.073 * 10^{-50}} , also reprsentieren durch  {\fontname{Courier}v = 1 ;  m = 0.073 ;  r = 0} .  
% Die nicht-normalisierte Form ist zu erkennen an  {\fontname{Courier}r = 0} .  Auch in diesem Fall 
% wird das hchstwertige Bit bei short real und long real nicht gespeichert, weil es 
% immer  {\fontname{Courier}0}  ist.
%
% Die absolut grte Darzustellende Zahl liegt vor, wenn sowohl Exponent wie 
% Mantisse ihre grten Werte haben, also alle Bits gleich  {\fontname{Courier}1}  sind.  Das ergibt z.B. 
% fr das short real Format  {\fontname{Courier}(2 - 2^{-23})*2^{128} = 2^{129} - 2^{105}} .  Dies ist doppelt 
% so gro wie die Angabe in der obigen Tabelle.  Tatschlich hat man auf die Darstellung der 
% letzten Zweierpotenz verzichtet.  Statt dessen codieren alle Bitmuster, deren Feld fr die 
% Reprsentation des Exponenten nur Einsen enthlt, fr "not a number" (NaN) , "+infinity" (inf) 
% oder "-infinity" (-inf).  In den Fllen inf und -inf ist die Mantisse gleich 0 , sonst liegt 
% NaN vor.  Mit den Bits der Mantisse kann man codieren, wie in diesem Fall weiter verfahren 
% werden soll.  Auf die Besprechung dieser Details wird hier verzichtet.
%
% Die folgende Funktion bietet eine interaktive Demo fr die drei Formate nach IEEE-754.  Die Demo 
% benutzt die normale Rechner-Arithmetik.  Deshalb ist die Darstellung im Falle temporary real
% unprzise.  In Grenzfllen gilt das auch fr long real:
% 
demoieee754
%
%
%
% Werden Operationen durchgefhrt mit der Reprsentation fr  {\fontname{Courier}NaN} , so ist das Resultat 
% immer  {\fontname{Courier}NaN}  bzw.  {\fontname{Courier}0}  bei Vergleichsoperationen.  Ist dagegen einer der Operanden  {\fontname{Courier}inf}  
% oder  {\fontname{Courier}-inf} ,  so ergibt dies mehr oder weniger sinnvolle Resultate.
%
%% Probieren Sie im Kommandofenster z.B.  {\fontname{Courier}3/inf ,  inf + inf ,  3*(-inf) , (-inf)^2}
%
% Man sollte aber auerordentlich vorsichtig sein im Umgang mit diesen "Werten".  
% Warnende Beispiele sind:
%
%% Die folgenden Programmzeilen sind nur mit Matlab-Lizenz aufrufbar:
inf/(-1+1)     % liefert das Resultat  +inf
inf/-(1-1)     % liefert das Resultat  -inf
%
x = 1.0e308,   y = 2*x-x-x   % lieferte bis Matlab 6  inf  anstelle von  0
%
% Auch die Vergleiche
%
inf==inf       % Resultat:  1
%
inf==27*inf    % Resultat:  1
%
% sind nicht plausibel - im Gegensatz zu
%
NaN==NaN       % Resultat:  0
%
%
% Operationstabellen fr Operanden der Art  {\fontname{Courier}0 , NaN , -inf , +inf}  liefert der 
% folgende Aufruf fr die Operationen  {\fontname{Courier}< , + , - , * , /} :
%
%% Dies ist ohne Matlab aufrufbar:
naninfoperation;
%