%
%
%3.3  Rundungsfehler%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Die Operationen mit Gleitkommazahlen sind im allgemeinen nicht informationstreu. 
% berdies gelten weder das Assoziativ- noch das Distributivgesetz.  Wir zeigen dies 
% der Anschaulichkeit halber wieder in dezimaler Schreibweise mit 4-stelliger 
% Mantisse und nehmen hier an, dass bei der Normalisierung und Denormalisierung 
% berzhlige Stellen einfach ohne Rundung fortfallen.
%
%\bfAssoziativ-Gesetz
%
% Mit den drei Zahlen
%
% {\fontname{Courier}a =  9.857*10^{-3}}
% {\fontname{Courier}b =  9.743*10^2}
% {\fontname{Courier}c = -9.742*10^2}
%
% ergibt sich
%
% {\fontname{Courier}a + b = b}   
%
% weil wegen des Exponenten die Mantisse von  {\fontname{Courier}a}  um  {\fontname{Courier}5}  Stellen geschoben wird
% und damit folgt weiter
%
% {\fontname{Courier}(a + b) + c = b + c = 0.001*10^2}
%
% und nach Normalisierung
%
% {\fontname{Courier}(a + b) + c = 1.000*10^{-1}}
%
% Andererseits ergibt sich:
%
% {\fontname{Courier}b + c = 1.000*10^{-1}}
%
% {\fontname{Courier}a + (b + c) = 9.857*10^{-3} + 1.000*10^{-1}}
%
% {\fontname{Courier}            = 0.098*10^{-1} + 1.000*10^{-1}}
%
% {\fontname{Courier}            = 1.098*10^{-1}}
%
% Fr  {\fontname{Courier}a + b + c}  ergeben sich also verschiedene Ergebnisse je nachdem, welche der 
% beiden Additionen zuerst durchgefhrt wird.  Das Assoziativgesetz gilt fr die Addition 
% von Gleitkommazahlen also nicht.
%
%% bungsaufgabe:  Fhren Sie die vorstehende Rechnung mit Rundung bei Normalisierung 
%% und Denormalisierung durch und zeigen Sie, dass das Assoziativgesetz auch dann nicht 
%% gilt.
%
%
%\bfDistributivgesetz
%
% Mit den selben Zahlen   {\fontname{Courier}a , b, c}   wie oben fhren wir folgende Rechnung durch:
%
% {\fontname{Courier}b + c = 1.000*10^{-1}}
%
% {\fontname{Courier}a * (b + c) = 9.857*10^{-4}}
%
% Andererseits hat man jeweils nach Beschneidung der Mantissen
%
% {\fontname{Courier}a*b =  9.603*10^0}
% {\fontname{Courier}a*c = -9.602*10^0}
%
% {\fontname{Courier}a*b + a*c = 0.001*10^0}
%
% und nach Normalisierung
%
% {\fontname{Courier}a*b + a*c = 1.000*10^{-3}}
%
% Das Distributivgesetz gilt fr Gleitkommazahlen also nicht.
%
%
% Ein schnes Beispiel fr Rundungsfehler ist in der Funktion  {\fontname{Courier}testarithmetik( x , y )}  
% realisiert.  Der Ausdruck 
%
% 9*x^4 - y^4 + 2*y^2     %<'FontName',MSVFORMFONT>
%
% wird sowohl mit der Rechner-internen Arithmetik ausgewertet wie auch mit der 
% im Kapitel 2 eingefhrten beliebig genauen Arithmetik.  Beide Ergebnisse werden 
% ausgegeben:
%
testarithmetik(10864,18817);
%
% Man sieht dem glatten numerischen Ergebnis von  2  nicht an, dass es um den 
% Faktor  2  falsch ist.  Bei genderten Parametern gibt es auch Differenzen. 
% Diese fallen dann aber nicht so auf.
%
% Die Ungltigkeit von Assoziativ- und Distributivgesetz hat zur Folge, dass sich 
% Algorithmen fr die selbe wissenschaftliche Aufgabe nicht nur durch ihre Effizienz 
% unterscheiden sondern auch in ihrer Genauigkeit.  Das wissenschaftliche Rechnen 
% mit diesen beiden Aspekten ist ein wichtiges wissenschaftliches Thema, welches 
% in der berschneidung von Numerischer Mathematik und Informatik liegt.
% 