%
%
%4.  Codierung%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
% {\bfDef.}   Unter  {\bfCodierung}  versteht man das Umsetzen einer vorliegenden Reprsentation  A  
% in eine andere Reprsentation  B .  Hufig liegen beide Reprsentationen  A  und  B  in 
% der selben Abstraktionsebene.  Die Interpretation von  B  nach  A  muss eindeutig sein.  
% Ist sie auch umkehrbar eindeutig, so spricht man von einer  {\bfUmcodierung} .
%
% Die folgende Tabelle zeigt eine Reihe mehr oder weniger gebruchlicher binrer 
% Codierungen fr Dezimalziffern.
%
% Ziffer |  BCD | Gray |Exzess3| Gray-| Aiken|biquinr| 1-aus-10 |2-aus-5|CCIT-2 %<'FontName',MSVFORMFONT>
% -------|------|------|-------|------|------|--------|----------|-------|------ %<'FontName',MSVFORMFONT>
%    0   | 0000 | 0000 |  0011 | 0010 | 0000 | 000001 |0000000001| 11000 | 01101 %<'FontName',MSVFORMFONT>
%    1   | 0001 | 0001 |  0100 | 0110 | 0001 | 000010 |0000000010| 00011 | 11101 %<'FontName',MSVFORMFONT>
%    2   | 0010 | 0011 |  0101 | 0111 | 0010 | 000100 |0000000100| 00101 | 11001 %<'FontName',MSVFORMFONT>
%    3   | 0011 | 0010 |  0110 | 0101 | 0011 | 001000 |0000001000| 00110 | 10000 %<'FontName',MSVFORMFONT>
%    4   | 0100 | 0110 |  0111 | 0100 | 0100 | 010000 |0000010000| 01001 | 01010 %<'FontName',MSVFORMFONT>
%    5   | 0101 | 0111 |  1000 | 1100 | 1011 | 100001 |0000100000| 01010 | 00001 %<'FontName',MSVFORMFONT>
%    6   | 0110 | 0101 |  1001 | 1101 | 1100 | 100010 |0001000000| 01100 | 10101 %<'FontName',MSVFORMFONT>
%    7   | 0111 | 0100 |  1010 | 1111 | 1101 | 100100 |0010000000| 10001 | 11100 %<'FontName',MSVFORMFONT>
%    8   | 1000 | 1100 |  1011 | 1110 | 1110 | 101000 |0100000000| 10010 | 01100 %<'FontName',MSVFORMFONT>
%    9   | 1001 | 1101 |  1100 | 1010 | 1111 | 110000 |1000000000| 10100 | 00011 %<'FontName',MSVFORMFONT>
%
% Jede Wandlung von einem Code dieser Tabelle in einen anderen der Tabelle ist eine
% Umcodierung.  Welcher Code vorliegt, geht nicht aus den Codewrtern hervor.
%
% {\bfDef.}   Werden zur Reprsentation  B  Wrter eines Zeichenvorrats  Z verwendet, 
% so bezeichnet man diese als  {\bfCodewrter} .
%
% {\bfDef.}   Die Menge aller Codewrter heit  {\bfCode} .
%
% {\bfDef.}   Ein Code, dessen Codewrter alle dieselbe Lnge haben, heit  {\bfBlockcode} .
%
% {\bfDef.}   Enthlt ein Zeichenvorrat nur genau zwei verschiedene Zeichen, so nennt 
% man diese Zeichen  {\bfBinrzeichen}  und Wrter aus diesen  {\bfBinrwrter} .
%
% {\bfDef.}   Sind die Codewrter Binrwrter, so liegt ein  {\bfBinrcode}  vor.
%
% Alle in der obigen Tabelle genannten Codes sind Binrcodes, jeweils eine Spalte listet alle 
% Codewrter des Codes.  Heute werden Zahlen, mit denen gerechnet werden soll, zumeist nicht 
% dezimal gespeichert.  Die genannten Codes sind daher nicht sehr gebruchlich.
%
% Auerordentlich wichtig ist dagegen die Codierung von geschriebenem Text.  Man trennt 
% dabei den reinen Text von seiner Formatierung.  Der reine Text besteht aus der Reihenfolge 
% der Zeichen.  Die Formatierung dagegen gibt die Wahl des Fonts, die Gre, Farbe etc. an. 
% Der reine Text wird blicherweise codiert mit  8-Bit-Wrtern  pro Zeichen.  Das ermglicht 
% die Benutzung von  256  verschiedenen Symbolen einschlielich einiger Steuerzeichen fr 
% den Drucker.  Leider sind das zu wenig Zeichen, um alle nationalen Zeichenstze enthalten 
% zu knnen.  Der reine Text bentigt daher immer die Information, welcher nationale 
% Zeichensatz verwendet werden soll.  
%
% Die folgende Tabelle liefert den ASCII-Code in Matrixform.  Das zu einem Zeichen 
% gehrige Codewort wird nach Klick auf das Zeichen in der Titelleiste in rot dargestellt,
% und zwar als 8-Bit-Binrwort,  2-stellig Hexa  und als Zahlenwert der Ganzzahlinterpretation. 
%
asciimat
%
% Die Schwierigkeiten im Umgang mit verschiedenen nationalen und speziellen Zeichenstzen 
% einerseits und die Verfgbarkeit groer und billiger Speicher haben zur Entwicklung 
% des 16-Bit-Uni-Codes gefhrt, der in 65536 Codewrtern die nationalen Zeichenstze 
% praktisch aller lebenden Schriften einschlielich der chinesischen und japanischen 
% und der Blindenschrift ermglicht sowie auch die der meisten historischen Schriften 
% wie Ogham und Runen.  Auch eine sehr groe Zahl von Symbolen ist vorhanden inklusive 
% aller ntigen Zeichen fr einen klassischen Notensatz.
%
%
%\bfEinschrittige Codes
%
% Eine Menge, in der eine Ordnungsrelation gilt, kann durch einen einschrittigen 
% Binrcode reprsentiert werden.  Benachbarte Elemente der Menge werden dabei 
% reprsentiert durch Binrwrter, die sich in genau einer Stelle unterscheiden.
% Solche Codes mssen immer dann benutzt werden, wenn das Ablesen der Bits nicht 
% verhindert werden kann, wenn gerade ein Wechsel zwischen zwei Codewrtern 
% stattfindet.  Die folgende Graphik demonstriert das Ablesen mit unvermeidlichen 
% zuflligen Verschiebungen bei den einzelnen Bits: 
%
demoeinschritt(0:59);            % nicht-einschrittiger Code
%
demoeinschritt(einschritt(60));  % einschrittiger Code
%
% Einschrittige Codes der Lnge  {\fontname{Courier}n}  werden entweder durch Finden eines nicht 
% unterbrochenen Weges der Lnge  {\fontname{Courier}n}  in einem KV-Diagramm entworfen
%
%% (z.Zt. demonstriert mit OH-Folien oder an der Tafel)
%
% oder rekursiv:  
% Hat der Code nur  {\fontname{Courier}2}  Codewrter, so sind dies die Bits  {\fontname{Courier}0}  und  {\fontname{Courier}1} .  Andernfalls 
% generiert man einen einschrittigen Code  {\fontname{Courier}C}  der Lnge  {\fontname{Courier}ceil(n/2)} .  Den ersten 
% Teil des gesuchten Codes erhlt man durch Verlngerung der Codewrter von  {\fontname{Courier}C}  
% durch eine  {\fontname{Courier}0} , den zweiten durch Anfgung einer  {\fontname{Courier}1}  an den in umgekehrter 
% Reihenfolge notierten Code  {\fontname{Courier}C} .
%
openbyextension('einschritt.m')
%
% Ein einschrittiger Code mit 12 Wrtern ist z.B. der folgende
%
binmatout(num2binmat(einschritt( 12 )',ceil(log2( 12 ))))
%
% Die beiden Gray-Codes in der Tabelle zur Codierung der Dezimalziffern sind einschrittig.
%
% Unterscheiden sich auch das erste und das letzte Codewort eines einschrittigen Codes 
% nur in einem Bit, so liegt ein zyklisch einschrittiger Code vor.  Die mit der Funktion 
% {\fontname{Courier}einschritt(n)}  rekursiv generierten einschrittigen Codes sind zyklisch einschrittig, 
% wenn  {\fontname{Courier}n}  gerade ist.  Zyklisch einschrittige Codes werden z.B. bei binrer 
% Winkelcodierung bentigt.
%
%
%\bfCodes variabler Lnge
%
% Bei der seriellen bertragung knnen die Codewrter eines Blockcodes einfach aneinander-
% gehngt (concateniert) werden.  Wegen der festen Lnge der Codewrter sind diese spter 
% wieder zu rekonstruieren, sofern kein Bit verlorengeht.
%
% Die Zerlegung einer unstrukturierten Bitsequenz in Codewrter ist auch mglich, wenn 
% die Codewrter unterschiedliche Lnge haben.  Eine hinreichende Bedingung dafr ist die
% {\bfFano-Bedingung} :  Kein Codewort ist identisch mit dem Anfang eines anderen Codewortes.
%
% Als Beispiel nehmen wir den einfachsten Fall eines binren Fano-Codes, bei dem drei 
% Symbole codiert werden in die Codewrter  {\fontname{Courier}1 ;  01 ;  00} .  Als Symbole nehmen 
% wir der Reihe nach die Symbole "Punkt" ;  "Strich"  und  "Zeichentrennung"  des 
% Morsecodes.  Damit kann nun jeder Text aus dem Alphabet 
% "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.-?/"
% zunchst nach Morse codiert und anschlieend mit obigem Fano-Code binr umcodiert 
% werden.
%
% Zur Umcodierung von ASCII nach Morse nehmen wir die Funktion  {\fontname{Courier}str2morse} :
%
str2morse('HALLO')
%
% Und zur Umcodierung dieses Strings in den oben genannten speziellen Fano-Code die Funktion
%
morse2bits( str2morse( 'HALLO' ));
%
% Die Umkehrung erfolgt mit
%
morsebits2text( morse2bits( str2morse( 'HALLO' ) ) )
%
% Im Gegensatz zum Blockcode gelingt das Zerlegen der Bitsequenz in Codewrter in diesem 
% Fall auch dann sicher, wenn Bits verloren gehen oder eingefgt werden.  Bei der 
% folgenden Demonstration wird der korrekten Bitsequenz eine zufllige Anzahl von  {\fontname{Courier}0...n-1} 
% zuflliger Bits vorangestellt.  Dann wird dieser Bitvektor dekodiert um zu zeigen, dass 
% der Code auch nach beliebigen Fehlern sofort wieder dekodiert werden kann.  Zum Vergleich 
% wird das selbe mit der ASCII-Codierung durchgefhrt.  In diesem Fall gelingt das Lesen nur, 
% wenn die Anzahl der eingefgten Bits ein Vielfaches von  {\fontname{Courier}8}  ist.  
%
demomorserobust
%
% Das automatische Decodieren realer tnender Morsesignale ist ein Problem der 
% Nachrichtentechnik, das hier nicht behandelt wird.
%
morsesound('INFORMATIK',120,660,2000);
%
