%
%
%5.1  Informationstheorie%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%\bfInformation
%
% {\fontname{Courier}A_i}  seien sich gegenseitig ausschlieende Ereignisse, die zufllig eintreffen.
% Als stochastisches Modell, welches die Zuflligkeit nher beschreibt, gelte 
%
% {\fontname{Courier}W\{A_i\} = p_i}
%
% Dies sei die Schreibweise fr "das Ereignis  {\fontname{Courier}A_i}  tritt mit der Wahrscheinlichkeit  {\fontname{Courier}p_i} 
% ein.  Bei der bertragung von Informationen sagen wir anstelle von "das Ergebnis  {\fontname{Courier}A_i}  
% tritt ein" "wir empfangen das Symbol  {\fontname{Courier}A_i}".  Inhaltlich ist das natrlich dasselbe.
%
% Angenommen es ist  {\fontname{Courier}p_i = 1}  und  {\fontname{Courier}p_j = 0  \forall  j \neq i} , und dem Empfnger sei dies 
% bekannt.  Dann empfangen wir mit Sicherheit  {\fontname{Courier}(p_i = 1)}  das Symbol  {\fontname{Courier}A_i} .  Es gibt also 
% keine berraschung.  Dass  {\fontname{Courier}A_i}  ankommt, ist fr den Empfnger "nichts Neues".  Der 
% Empfang bringt also keinen Informationsgewinn.  Der Informationsgehalt der Sendung 
% eines Symbols, dessen Wahrscheinlichkeit  {\fontname{Courier}1}  ist, ist  {\fontname{Courier}0} .
%
% Sind die  {\fontname{Courier}p_i}  dagegen sehr verschieden und  {\fontname{Courier}p_i \neq 1  \forall i} , so ist die 
% berraschung grer bei Empfang von  {\fontname{Courier}A_i}  mit kleinem  {\fontname{Courier}p_i} .  Setzt man das Ma 
% fr den Informationsgehalt mit "berraschung" gleich, so wre dafr eine mgliche 
% Quantifizierung  {\fontname{Courier}1/p_i} .  Ein einfaches Beispiel zeigt jedoch, dass dieses nicht 
% geeignet ist:
%
% Man erhalte die Information  {\fontname{Courier}A} , deren Wahrscheinlichkeit  {\fontname{Courier}p_A}  ist, und danach 
% noch die davon unabhngige Information  {\fontname{Courier}B} , deren Wahrscheinlichkeit  {\fontname{Courier}p_B}  ist. 
% Wegen der Unabhngigkeit ist die Wahrscheinlichkeit beider Ergeignisse gegeben 
% durch das Produkt  {\fontname{Courier}p_A*p_B} .  Also wrde mit  {\fontname{Courier}1/p}  als Ma fr den Informations-
% gehalt gelten:  Der Informationsgehalt zweier Ereignisse ist das Produkt der 
% Informationsgehalte beider Ereignisse.  Das widerspricht aber der Vorstellung 
% einer Gre, die einen Gehalt messen soll und damit additiv sein muss.  Diese 
% Additivitt ist leicht herzustellen, nmlich durch Logarithmierung:
%
% Wir definieren als Informationsgehalt eines Ereignisses  {\fontname{Courier}A_i}  der Wahrscheinlichkeit  {\fontname{Courier}p_i}
%
% {\fontname{Courier}I(A_i) = log_2(1/p_i) = -log_2(p_i)}
%
% Neben den Bezeichnungen "Information" und "Informationsgehalt" ist fr diese Gre 
% auch "Entscheidungsgehalt" gelufig.
%
% Fr den oben durchgespielten Fall von zwei Ereignissen  {\fontname{Courier}A}  und  {\fontname{Courier}B}  hat man dann
%
% {\fontname{Courier}I(A) + I(B) = log_2(1/(p_A*p_B)) = log_2(1/p_A) + log_2(1/p_B) = I(A) + I(B)}
%
% in bereinstimmung mit der Forderung nach einer additiven Gre.
%
% {\fontname{Courier}log_2}  bedeutet der Logarithmus zur Basis  {\fontname{Courier}2} .  Die Einheit der so definierten 
% Information ist  {\fontname{Courier}1} Bit.  Dies sollte nicht verwechselt werden mit Binrstellen 
% oder den Symbolen 0 und 1.  Als Logarithmus ist der Informationsgehalt eine 
% reelle Gre.  Dass diese Begriffsbestimmung dennoch sehr sinnvoll ist, zeigt 
% der Empang einer Binrstelle:  Mglich seien nur die beiden Empfangssymbole 
% "0"  und  "1" , und zwar beide mit gleicher Wahrscheinlichkeit  {\fontname{Courier}p_0 = p_1 = 1/2} .
% Der Informationsgehalt des Empfangs einer "0" oder einer "1" ist dann 
%
% {\fontname{Courier}I("0") = I("1") = log_2(1/(1/2)) = 1 Bit}
%
% Die Begriffe "Ungewissheit", "berraschung" und "Information" hngen auf folgende 
% Weise zusammen:
%
% Vor dem Empfang gibt es die Ungewissheit ber das Kommende.
% Beim Empfang gibt es die berraschung. 
% Und danach hat man den Gewinn an Information.
%
% Alle drei Begriffe wollen wir mit demselben oben definierten Betrag messen.
% Diese Quantifizierung des Begriffes "Information" ist zugeschnitten auf die 
% speziellen Belange der Nachrichtentechnik.  Sie kann nicht allen Aspekten des 
% umgangssprachlichen Globalbegriffes gerecht werden. 
% 
% Beispiel 1 : 
% Die Wahrscheinlichkeit, an einem bestimmten Tag von einem Meteor erschlagen zu 
% werden, sei  
%
p = 10^-16          % p = 0.0000000000000001
%% Dieses doppelklicken, damit p den gewnschten Wert bekommt.
%
% Man sieht diesem Tag zuversichtlich entgegen, weil die Ungewissheit von
%
log2(1/(1 - p))     % 0.00000000000000033307
%
% auerordentlich klein ist.  Ebenso klein ist die berraschung, wenn das Unglck 
% nicht passiert.  Und der Informationswert der Nachricht "Ich wurde nicht vom Meteor 
% erschlagen" ist ebenso gering.  Umgekehrt wre die berraschung gro, nmlich 
%
log2(1/p)           % 53.1508
%
% wenn das Unglck tatschlich geschhe.  Und wegen des hohen Informationsmaes 
% von 53 wrden alle Medien die Nachricht auch dann bringen, wenn es nicht eine 
% bekannte Persnlichkeit getroffen hat.
%
% Beispiel 2 :
% Die "6" beim Wrfeln hat bei vielen Spielern eine besondere Bedeutung.  Bedeutung 
% oder gar Konsequenz von Symbolen wird hier nicht betrachtet, sondern nur ihre 
% Wahrscheinlichkeit, und die ist fr die "6" die selbe wie fr alle anderen Seiten 
% des Wrfels.
%
% Beispiel 3 :
% Gegeben seien zwei Bcher von je 200 Seiten zu je 40 Zeilen von je 72 Zeichen.
% (a) deutscher Text
% (b) alle Typen mit Zufallsgenerator mit Gleichverteilung eines Alphabets von 
%      80 Zeichen erzeugt
% Welches enthlt die meiste Information?
% Empfangen wir im deutschen Text "Der Begrif", so ist f als nchstes Symbol kaum 
% eine berraschung, whrend der Zufallstext mit jedem Symbol die zustzliche 
% Information  {\fontname{Courier}log_2(1/(1/80))}  liefert.  Der Zufallstext 
% enthlt also die grtmgliche Information.
%
% Das Beispiel offenbart noch einen wichtigen Punkt:
% Kennt der Empfnger den Algorithmus des Zufallsgenerators, so gibt es gar keine 
% berraschung mehr.  In diesem Fall wird jedes Symbol mit der Gewiheit  {\fontname{Courier}p = 1}  
% empfangen, und der Informationsgehalt ist  {\fontname{Courier}0} . 
%
% Beispiel 4 :
% Die Wahrscheinlichkeit, in einem Text an einer gegebenen Stelle das Zeichen "A" 
% anzutreffen, sei  {\fontname{Courier}W\{A\} = p = 0.01} .  Dann ist der Informationsgehalt des Zeichens
%
log2(1/0.01)     % 6.6439
%
% Wenn der Text als ASCII-Text vorliegt, werden  8 Binrstellen zur Reprsentation
% des "A" benutzt.  Der Informationsgehalt ist jedoch geringer.
%
%
%
%
%\bfEntropie
%
% Die Definition der Information lt sich nur jeweils auf den Empfang eines speziellen 
% Zeichens anwenden.  Wir fragen deshalb jetzt global nach der durchschnittlichen 
% Information, die der Empfang eines Symbols liefert.  Diesen Erwartungswert bezeichnet 
% man als Entropie des Systems.
%
% Die Wahrscheinlichkeiten aller mglichen Ereignisse  {\fontname{Courier}A_i}  seien  {\fontname{Courier}W\{A_i\} = p_i}  .
% Da jeweils ein Symbol aus der Menge aller mglichen eintritt, ist die Summe aller 
% {\fontname{Courier}p_i}  gleich  {\fontname{Courier}1} .
%
% Dann ist die Entropie ( {\fontname{Courier}E}  steht fr Erwartungswert)
%                n               n                      n                   %<'FontName',MSVFORMFONT>
% H = E\{I(A_i)\} = _{\fontsize{26}\Sigma} p_i I(A_i)  =  _{\fontsize{26}\Sigma} p_i log_2(1/p_i)  =  - _{\fontsize{26}\Sigma} p_i log_2(p_i)  %<'FontName',MSVFORMFONT>
%               i=1             i=1                    i=1                  %<'FontName',MSVFORMFONT>
%
% Die Entropie ist nur eine Funktion der Wahrscheinlichkeiten  {\fontname{Courier}p_i} , also nur abhngig 
% vom stochastischen Modell. 
%
% Beispiel 1
% Es gebe 3 mgliche Ereignisse mit den Wahrscheinlichketen  {\fontname{Courier}1/2 , 1/3 , 1/6} :
%
% Die Entropie ergibt sich zu
%
p = [ 1/2  1/3  1/6 ]
H = sum( p .* log2( 1./p ))   %  H = 1.4591
%% Die Punkte vor den Operationssymbolen * und / bedeuten in der MATLAB-Syntax, dass 
%% diese Operationen bei Vektoren und Matrizen elementweise auszufhren sind.
%
% Der einfache Ausdruck fr  {\fontname{Courier}H}  ist in der Funktion  {\fontname{Courier}entropie(p)}  realisiert:
%
entropie( [ 1/2  1/3  1/6 ] )
%
% Beispiel 2
% Empfang einer Binrstelle mit den Wahrscheinlickeiten   {\fontname{Courier}p_0 = q ;  p_1 = 1 - q}
% Im Fall  {\fontname{Courier}q = 1/2}  erhlt man:
%
entropie( [ 1/2  1-1/2 ] )
%
% Der mittlere Informationsgehalt beim Empfang einer Binrstelle mit gleicher 
% Wahrscheinlichkeit fr beide Symbole ist also genau 1 Bit.
%
% Die Abhngigkeit von  {\fontname{Courier}q}  wird in folgendem Bild dargestellt:
%
plotentropy
%
% Der mittlere Informationsgehalt einer Binrstelle ist offenbar nur dann 1 Bit, wenn beide 
% mglichen Symbole gleich wahrscheinlich sind.  Entsprechendes gilt auch fr grere
% Symbolmengen.  Sind z.B. alle  256  8-Bit-Bytes gleich wahrscheinlich, so ist die 
% Entropie wie erwartet  8 Bit :
%
% H = 256 * 1/256 * log2( 1/(1/256) )      %<'FontName',MSVFORMFONT>
%
% Berechnet: ( {\fontname{Courier}ones(m,n)} liefert eine  {\fontname{Courier}m\timesn}-Matrix von Einsen )
%
entropie( ones(1,256)/256 )
%
%
%\bfRedundanz
%
% Als Redundanz wird die Differenz zwischen dem aufgrund der Wortlngen mglichen 
% und dem tatschlich genutzten mittleren Informationsgehalt bezeichnet.
%
%
%\bfKanalkapazitt
%
% Die Informationstheorie wurde entwickelt als Theorie zur formalen Behandlung der
% bertragung von Information ber reale nicht fehlerfreie Kanle, deren Fehlerverhalten 
% sich aber in einem stochastischen Modell formulieren lsst.  Fr den wichtigen 
% binren symmetrischen Kanal geben wir hier ohne lngliche Herleitung die sog. 
% Kanalkapazitt  {\fontname{Courier}C}  an, d.h. den maximal pro Binrstelle bertragbaren Informations-
% gehalt:
%
% {\fontname{Courier}C = 1 - H(F)}
%
% Hierin ist  {\fontname{Courier}H(F)} die Entropie des Fehlerverhaltens.  
%
% Der binre symmetrische Kanal sei festgelegt durch folgende Eigenschaften:
%
% (1)  Die Wahrscheinlichkeit der beiden Symbole  {\fontname{Courier}0}  und  {\fontname{Courier}1}  ist gleich.
% (2)  Die Wahrscheinlichkeit  {\fontname{Courier}P} , dass aus einer  {\fontname{Courier}0}  eine  {\fontname{Courier}1}  wird, ist gleich 
%       der Wahrscheinlichkeit, dass aus einer  {\fontname{Courier}1}  eine  {\fontname{Courier}0}  wird.
% (3)  Die Wahrscheinlichkeit eines Fehlers an der Binrstelle  {\fontname{Courier}i}  ist 
%       unabhngig vom Auftreten der Fehler an anderen Stellen.
%
% Damit ist  {\fontname{Courier}H(F) = P*log_2(1/P) + (1 - P)*log_2(1/(1-P))} .
%
% Die Kanalkapazitt des binren symmetrischen Kanals in Abhngigkeit der 
% Fehlerwahrscheinlichkeit  {\fontname{Courier}P}  zeigt das folgende Bild:
%
plotcapacity
%
% Offenbar ist die Kanalkapazitt  {\fontname{Courier}0}  bei  {\fontname{Courier}P = 0.5} .  Der Empfnger kann
% in diesem Fall die empfangene Bitsequenz nicht von einer zuflligen Bitsequenz 
% unterscheiden.  Dass die Kanalkapazitt bei  {\fontname{Courier}P > 0.5}  wieder ansteigt, liegt 
% daran, dass man in diesem akademischen Fall durch Inversion aller Bits eine 
% Sequenz erzeugt, fr die die Bitfehlerwahrscheinlichkeit  {\fontname{Courier}1 - P}   ist.
%
% Die Kanalkapazitt ist eine obere Schranke, die in der Praxis nicht erreicht wird.
% Die formale Herleitung gibt auch keinerlei Hinweise, wie berhaupt eine praktisch 
% fehlerfreie bertragung mglich werden knnte.  Wir versuchen dies im folgenden 
% Abschnitt.
%