%
%
%5.2.1  Begriffe%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Als  {\bfHamming-Abstand}  zweier Codewrter gleicher Lnge bezeichnet man die Anzahl der
% Stellen, an denen sich die Wrter unterscheiden.  Der Hammingabstand eines Codewortes vom 
% Null-Wort heit  {\bfHamming-Gewicht}.
%
% Zur  {\bfFehlererkennung}  und zur  {\bfFehlerkorrektur}  ist eine  {\bfKodierung}  der Information 
% erforderlich, die  {\bfRedundanz}  enthlt, also mehr Bits zur Reprsentation verwendet 
% als zur reinen Speicherung erforderlich.  Dadurch gelingt es, die zulssigen Codewrter 
% so zu definieren, dass sie paarweise wenigstens den Hamming-Abstand  {\fontname{Courier}D}  haben.  
% {\fontname{Courier}D}  heit  {\bfMinimalabstand}  des Codes.  Bei Benutzung eines Codes mit dem 
% Minimalabstand  {\fontname{Courier}D}  kann man ein empfangenes Wort mit bis zu  {\fontname{Courier}D-1}  fehlerhaften 
% Stellen als unbrauchbar erkennen oder ein Wort mit bis zu  {\fontname{Courier}floor((D-1)/2)}  fehlerhaften 
% Stellen korrigieren.  Entscheidet man sich zur Korrektur, so ist die Fehlererkennung 
% eingeschrnkt oder ganz verloren.
%
% Die Benutzung einer Kanalkodierung, um fehlerhafte Zeichen am Empfangsort korrigieren 
% zu knnen, bezeichnet man als  {\bfVorwrts-Korrektur}  (Forward Error Correction, {\bfFEC}). 
% Wird dagegen der Code zur Fehlererkennung benutzt, um eine Wiederholung der bertragung 
% anzufordern, so bezeichnet man dies als {\bfARQ} (Automated Repeat Request).  Hufig werden 
% beide Verfahren kombiniert.  ARQ ist jedoch nicht einsetzbar bei groen Entfernungen 
% (inteplanetare Raumsonden) und problematisch bei Datenbertragung in Realzeit (z.B.Video).
%
% Es gibt eine Reihe von Verfahren zur Konstruktion von Codes zur Fehlererkennung und 
% -Korrektur, jedoch keine einheitliche Theorie, aus der sich alle guten Codes ergeben. 
% Gute Codes muss man finden.  Zur Suche benutzt man heute den Computer.
%
% Zunchst wollen wir eine Klassifikation von Codes vornehmen:
%
% (1)  {\bfBlock-Code}  {\fontname{Courier}vs}.  {\bfFaltungscode}
% Man unterscheidet Block-Codes gegenber Faltungscodes.  Bei Block-Codes werden jeweils  
% {\fontname{Courier}k}  Informationsbits in ein Codewort von  {\fontname{Courier}n}  Bits kodiert.  Im Falle von FaltungsCodes wird 
% dagegen ein kontinuierlicher Bitstrom in einen Codebitstrom hherer Bitrate kodiert.
%
% (2)  {\bfLineare} , {\bfmodifizierte}  und  {\bfnichtlineare} Codes
% Ein linearer  {\fontname{Courier}(n,k)}-Block-Code ber  {\fontname{Courier}GF(q)}  ist ein  {\fontname{Courier}k}-dimensionaler Unterraum des  {\fontname{Courier}GF(q)^n} .  
% {\fontname{Courier}GF(q)}  ist der endliche Krper mit  {\fontname{Courier}q} Elementen.   {\fontname{Courier}q}  ist  {\fontname{Courier}p^m} , wo  {\fontname{Courier}p}  Primzahl ist und  {\fontname{Courier}m}  eine 
% natrliche Zahl.
% Beispiel:   {\fontname{Courier}p = 2 ;   m = 1 ;   n = 3 ;   k = 1 .}   
% Der Code ist ein eindimensionaler Unterraum des  {\fontname{Courier}GF(2)^3} .  Er enthlt die Codewrter  
% {\fontname{Courier}[0 0 0]}  und {\fontname{Courier}[1 1 1]} .  Alle anderen Elemente von {\fontname{Courier}GF(2)^3}  sind Nicht-Codewrter.  
% Wenn man eine oder mehrere Stellen des Codewortes systematisch verndert, im Falle des  
% {\fontname{Courier}GF(2)}  also invertiert, so ist der Code kein linearer Raum mehr, obwohl er alle seine 
% Eigenschaften hat.  Man nennt dies einen modifizierten Code.  Er hat den Vorteil, 
% dass Nullvektor und Einsvektor nicht mehr zum Code gehren und damit die relativ 
% hufigen Fehler, dass nur Nullen oder nur Einsen gesendet werden, sofort als Fehler 
% erkennbar sind. 
% Ist der Code weder linear noch ein modifizierter linearer, so ist er nichtlinear.
% Faltungscodes sind im Prinzip linear, passen jedoch wegen der unendlichen Dimensionen 
% nicht in die obige Beschreibung.
%
% (3)  \bfSystematischer Code
% Ein Code heit systematisch, wenn sich die zu kodierende Information direkt im Codewort 
% wiederfindet.
%
% (4)  \bfZyklischer Code
% Ein Block-Code heit zyklisch, wenn mit jedem Codewort auch smtliche zyklischen 
% Verschiebungen (Rotationen) des Codewortes zum Code gehren.  Lineare zyklische Codes 
% sind bei serieller bertragung von Vorteil, weil sie Fehlerbndel besser erkennen bzw. 
% korrigieren knnen.
%
% (5)  Codes zur Erkennung und Korrektur von {\bfFehlerbndeln}
% Ein Fehlerbndel ({\bfBurst}) ist eine Sequenz von  {\fontname{Courier}b}  Bits, in der gehuft Fehler auftreten 
% (erstes und letztes sowie mglicherweise dazwischen liegende Bits sind fehlerhaft). 
% Es gibt Codes, die speziell auf diesen Fall zugeschnitten sind.
%
%% bung:   Ein Hadamard-Code ist gegeben durch die 24 Codewrter
%%
hadamardcode
%
%% (a)  Ist dies ein zyklischer Code?
%%
%% (b)  Bestimmen Sie den Minimalabstand
%%
%% (c)  Wieviele Bitfehler kann man mit diesem Code korrigieren?
%