%
%
%5.3.1  Gleiche Symbolhufigkeit%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Ein Wort aus  {\fontname{Courier}m}  Zeichen eines Alphabets mit  {\fontname{Courier}n}  Zeichen gleicher Wahrscheinlichkeit 
% hat den Informationsgehalt  {\fontname{Courier}m*log2(n)} .  Man bentigt also wenigstens  {\fontname{Courier}ceil(m*log2(n))}
% Binrstellen zur Reprsentation.  Die Wandlung in das Binrwort kann einfach dadurch 
% erfolgen, dass man das ursprngliche Wort als Stellen-orientierte Zahl zur Basis  {\fontname{Courier}n}
% auffasst mit dem gegebenen Alphabet als Ziffern.  Diese Zahl wird in eine Binrzahl 
% gewandelt.  Als Beispiel dient hier ein beliebiges Wort aus  {\fontname{Courier}6}  Zeichen des 
% speziellen Fernschreib-Alphabets  PUA-43  aus folgenden  {\fontname{Courier}43}  Zeichen:
%
% ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,?/# $
%
str2binrep('TEST.','ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,?/# $');
%
binrep2str([ 0 1 1 1 0 1 1 0 1 1 0 1 1 0 0 1 0 0 0 0 1 0 0 0 1 1 1 0 ],...
           'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,?/# $')
%
% Wie in jedem Stellen-orientierten System ist die Ordnung im Alphabet der Ziffern wichtig.
%
%
% Hufig liegt der Fall vor, dass an verschiedenen Stellen verschiedene Alphabete 
% verwendet werden.  Fr eine optimal komprimierte Reprsentation von  7-stelligen 
% ganzen Dezimalzahlen oder 6-stelligen Dezimahlzahlen, deren Dezimalpunkt zwischen 
% der ersten und letzten Stelle liegen darf, kann man fr die erste und die letzte 
% Stelle die  10  Dezimalziffern nehmen und fr die brigen Stellen die Dezimalziffern 
% plus Punkt.  Der Informationsgehalt ist dann   
%
%     log2(10*11*11*11*11*11*10) = 23.94    %<'FontName',MSVFORMFONT>
%
% Die Reprsentation kann also in einem  24 Bit-Wort erfolgen.  Bei der Wandlung in 
% eine Binrzahl ist zu beachten, dass sich die Basis mit der Stelle ndert. Bei der 
% Funktion  str2binrep kann man entsprechend der Reihe nach fr jede Stelle ein 
% eigenes Alphabet angeben:
%
str2binrep('7214.25',{'0123456789' ;'0123456789.';'0123456789.';'0123456789.';...
                      '0123456789.';'0123456789.';'0123456789' ;})
%
% Mit Matlab ist das natrlich bersichtlicher:
%
zahl = '7214.25'                      % zu reprsentierende Dezimalzahl
z  = '0123456789';                    % Alphabet 1
zp = '0123456789.';                   % Alphabet 2
alphabete = {z; zp; zp; zp; zp; zp; z};
cw = str2binrep(zahl,alphabete);      % Binr-Codewort
zd = binrep2str(cw,alphabete)         % Decodierte Zahl
result2fig(zahl)                      % Ausgabe der zu codierenden Zahl
Codewort = binmatout(cw); result2fig(Codewort) % Ausgabe des Codewortes
result2fig(zd);                       % Ausgabe der decodierten Zahl
%
%% Prfen Sie, ob die Zahlen  9999999,  99999.9 ,  0.00000  und  0000000  tatschlich 
%% auch  24 Bits ergeben.
%% Warum ist der Binrcode fr  0.00000  nicht das Wort aus 24 Nullen?
%% Warum scheint die Binrzahl fr  99999.9  grer zu sein als die fr  9999999 ?
%% Ohne Matlab mssen die Alphabete direkt eingegeben werden, z.B.:
%