%
%
%5.3.3  Delta-Modulation%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Die Delta-Modulation ist ein Verfahren fr die Speicherung und bertragung von 
% Daten, die quidistante Sttzstellen eines stetigen Verlaufs sind wie z.B Audio-Daten.
% Anstatt alle Werte als unabhngige Zahlen zu speichern oder zu bertragen wird 
% jeweils durch die letzten  n  Werte ein Polynom (n-1)ten Grades gelegt und dessen 
% Wert am nchsten Punkt berechnet.  bertragen wird die Differenz zwischen dem 
% tatschlichen Wert und dem vorausberechneten (der sog. Prdiktion).  Diese 
% Differenzen sollten klein sein, so dass nur wenige Bits dafr bentigt werden.
%
% Es kann vorkommen, dass die zu bertragende Differenz nicht mehr durch die 
% festgelegte Anzahl von Bits darstellbar ist.  Man limitiert dann den Wert und 
% spricht von "Overloading".  In diesem Fall kann die ursprngliche Datensequenz 
% nicht ganz korrekt bertragen werden. 
%
% Zur Demonstration des Verfahrens dient die Funktion  {\fontname{Courier}demoprediction(n,m,g)}  
% mit den Parametern  
% {\fontname{Courier}n = Anzahl der Bits fr die Reprsentation der Originaldaten,}
% {\fontname{Courier}m = Anzahl der Bits pro zu bertragende Differenz,}
% {\fontname{Courier}g = Polynomgrad} .
% Die Funktion benutzt einen in der Frequenz ansteigenden Ton als Originalsignal (Chirp). 
% Die Tendenz zum Overloading steigt damit von links nach rechts.
% 
% Bei der eigentlichen Deltamodulation ist der Polynomgrad  {\fontname{Courier}g = 0} :
%
%% Diese Funktion ist sehr rechenintensiv.  Die Ausfhrung kann Minuten dauern!
demoprediction(6,3,0);
%
%% Whlen Sie mit der Maus unter dem Men "Zoom" im oberen Bild ("Audio") jeweils einen 
%% Ausschnitt am Anfang, in der Mitte und am Ende der Datensequenz.  Das Overloading 
%% beginnt etwa in der Mitte.
%
% Zur bertragung ohne Overload bei einer Genauigkeit von  10  bzw.  20 Bit  sind 
% bei dem gegebenen Signal  4  bzw.  7  Bit pro Datum erforderlich:
%
demoprediction(10,4,3); 
%
demoprediction(20,7,6);
%
% Im Fall des Polynomgrades  {\fontname{Courier}g = 0}  kann es zwar Overload-Fehler geben, 
% das rekonstruierte Signal ist danach aber immer korrekt an den Stellen ohne 
% Overloading.  Bei  {\fontname{Courier}g > 0}  (mit steigender Tendenz bei greren g)  nimmt 
% die Wahrscheinlichkeit zu, dass die Rekonstruktion nach einem Overloading 
% nicht mehr gelingt.  Dies liegt daran, dass Polynome hheren Grades im 
% mittleren Bereich der Sttzstellen zwar gut interpolieren, aber generell 
% schlecht extrapolieren.  Ein Beispiel ist das folgende:
%
demoprediction(10,3,2);
%
%
% Die Deltamodulation ist nur eines von vielen Verfahren zur Codierung von Daten 
% mit Korrelation von Nachbarn.  Andere Verfahren erfordern zum Verstndnis jedoch 
% tiefergehende mathematische Kenntnisse, die an dieser Stelle noch nicht vorausge-
% setzt werden sollen.
%