%
%
%6.3  Krper %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% {\itDefinition}:  Eine nichtleere Menge  K  mit zwei inneren Verknpfungen  +  
% und  *  heit  Krper  (engl. field), wenn gilt :
%
% K1   (K,+)  ist eine abelsche Gruppe mit dem neutralen Element  0  (Null)
%
% K2   (K \\ 0,*)  ist eine Gruppe
%
% K3   Es gilt das Distributivgesetz
%
% (a + b) * c  =  a * c  +  b * c   \forall  a,b,c \in K    %<'FontName',MSVFORMFONT> 
%
% a * (b + c)  =  a * b  +  a * c   \forall  a,b,c \in K    %<'FontName',MSVFORMFONT>
%
% Falls die Gruppe  (K \\ 0,*)  abelsch ist, so liegt ein  {\bfkommutativer Krper}  vor.
%
% Ein Beispiel fr einen kommutativen Krper ist die Menge der reellen Zahlen 
% mit den inneren Verknpfungen Addition und Multiplikation.  Endliche Krper 
% wurden erstmals von  Galois  behandelt und werden deshalb mit  GF(n)  bezeichnet,
% wo  n  die Anzahl der Elemente der Menge ist.  Die Elemente werden blicherweise 
% mit  0 , 1, ... , n-1  bezeichnet.  Alle Krper mit  n  Elementen sind isomorph.
% Nur fr  n = p^k , wo  p  eine Primzahl und k eine natrliche Zahl ist, ist 
% die Erfllung von  K1, K2, K3  mglich.
%
% Fr die Technische Informatik besonders wichtig ist der endliche Krper GF(2)
% mit den Elementen  \{0,1\}  und den inneren Verknpfungen
%
%               x                x          %<'FontName',MSVFORMFONT>
%           + | 0 1          * | 0 1        %<'FontName',MSVFORMFONT>
%          ---|-----        ---|-----       %<'FontName',MSVFORMFONT>
%       y   0 | 0 1      y   0 | 0 0        %<'FontName',MSVFORMFONT>
%           1 | 1 0          1 | 0 1        %<'FontName',MSVFORMFONT>
%
% In der Codierungstheorie werden auch andere endliche Krper bentigt, 
% insbesondere  GF(2^k).  Ohne auf ihre Konstruktion durch Polynome
% einzugehen, geben wir hier smtliche endlichen Krper  GF(p^k)  an durch 
%
gftabellen(2)   % Primzahl 2
%
gftabellen(3)   % Primzahl 3
%
gftabellen(4)   % Primzahlpotenz 4 = 2^2
%
% usw.
%
% Auch hier kann man die Gltigkeit der Krperaxiome automatisch berprfen. 
% Wir beschrnken uns auf die Prfung von K1 und K2:
%
n = 9; 
[a,m]=gftabellen(n); 
isgru(a)
isgru(m(2:end,2:end)-1)
%