%
%
%6.5  Innere Verknpfungen  %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%       der Menge \{0,1\}   %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
% Verknpfungen in endlichen Mengen lassen sich durch Tabellen definieren.  Im Falle 
% der Menge  \{0,1\}  hat die Tabelle die Form
%
%               x          %<'FontName',MSVFORMFONT>
%           + | 0 1        %<'FontName',MSVFORMFONT>
%          ---|-----       %<'FontName',MSVFORMFONT>
%       y   0 | a b        %<'FontName',MSVFORMFONT>
%           1 | c d        %<'FontName',MSVFORMFONT>
%
% Hierin kommen die vier Konstanten  a, b, c, d \in \{0,1\}  vor.  Lsst man 
% smtliche Kombinationen der  a, b, c, d  zu, so ergeben sich  16  verschiedene 
% innere Verknpfungen, von denen sich allerdings einige als trivial oder unecht 
% erweisen.  Wir listen zunchst alle auf:
%
msvShowImage('boolean-functions.gif')
%
% Trivial sind die NULLfunktion und die EINSfunktion, die gar nicht von den zu verknpfenden 
% Elementen abhngen, und unecht sind alle Funktionen, die nur von einem der beiden 
% Elemente abhngen.  Das sind  NICHTx, NICHTy, Identitt x und Identitt y.  Es 
% verbleiben folgende echte Verknpfungen, fr die wir die Gltigkeit der Gruppenaxiome 
% mit auflisten:
%
msvShowImage('boolean-functions-properties.gif')
%
% Eine Algebra, in der Gleichungssysteme lsbar sein sollen, bentigt eine innere 
% Verknpfung mit inversen Elementen.  Nur das XOR und die quivalenz bieten dies. 
% Die Codierungstheorie arbeitet deshalb mit der GF(2)-Algebra.
%
% Fr die Realisierung von beliebigen Funktionen ist es wichtig zu wissen, 
% welche dieser Verknpfungen unverzichtbar sind oder mit welchen Untermengen 
% man smtliche Funktionen realisieren kann.
%
% {\itDefinition}:   Eine Menge  {\fontname{Courier}M}  von inneren Verknpfungen von  {\fontname{Courier}A}  und 
% einstelligen Operationen heit  {\bffunktional vollstndig} , wenn mit ihnen alle 
% Funktionen  {\fontname{Courier}f : A^n \rightarrow A}  geschrieben werden knnen.
%
% Beispiele von funktional vollstndigen Mengen fr  {\fontname{Courier}B = \{0,1\}}
% ----------------------------------------------------------------------------------
%
% M = \{NAND\}                         bliche Computer-Logik
%
% M = \{NOR\}                           frher zum Teil bei ECL-Logik verwendet
%
% M = \{UND, NICHT\}
%
% M = \{ODER, NICHT\}
%
% M = \{XOR, UND, EINS\}        endlicher Krper GF(2)
%
% M = \{UND, ODER, NICHT\}   Boolesche Algebra
%
% Die bliche Computerlogik arbeitet also mit einer schwer handhabbaren Algebra, in 
% der nur  G4  gilt.  Zur Entscheidungsfindung innerhalb von Rechenprogrammen und 
% auch beim Entwurf von Hardware wird dagegen die Boolesche Algebra verwendet, 
% in der es keine einheitlichen Inversen Elemente gibt, so dass keine eleganten Verfahren 
% zur Lsung von Gleichungssystemen mglich sind.  Der folgende Abschnitt beschftigt 
% sich mit der Booleschen Algebra. Die Funktionale Vollstndigkeit der Booleschen 
% Algebra wird im Kapitel 7 gezeigt.  Die Funktionale Vollstndigkeit der brigen 
% Mengen lsst sich daraus ableiten durch Realisierung von UND, ODER und NICHT 
% durch die jeweilige Verknpfungsmenge.
%