%
%
%
%7.3.1  Textuelle Beschreibung%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%
% Zur textuellen Beschreibung einer Schaltfunktion kann man benutzen:
%
% (a)  die Umgangssprache
% (b)  die bliche formale Notation
% (c)  eine spezielle Beschreibungssprache
% (d)  einen algebraischen Ausdruck
% (e)  eine Tabellenform
%
% Als Beispiel wird der sog. 2-zu-1-Multiplexer mit den binren Variablen  {\fontname{Courier}a, b, c} 
% in diesen fnf Mglichkeiten beschrieben:
%
% (a)  Eine mgliche Beschreibung des Multiplexers ist:
%
%       "{\fontname{Courier}f}  entspricht der Zusammenfhrung zweier Einbahnstraen  {\fontname{Courier}a}  und  {\fontname{Courier}b}  in eine dritte  {\fontname{Courier}x} . 
%       Die Zusammenfhrung wird mit einer Ampel geregelt, die mit der Variablen  {\fontname{Courier}c}  von der 
%       einen zur anderen Strae umgeschaltet wird:   {\fontname{Courier}c = 0}  liefert  {\fontname{Courier}x = a ,  c = 1}  liefert 
%       {\fontname{Courier}x = b} "
%
%       Der umgangssprachlichen Beschreibung ist nicht unmittelbar anzusehen, ob sie 
%       auch so verstanden wird, wie der Schreibende es gemeint hat.  Hufig ist 
%       solch eine Beschreibung auch unvollstndig.
%
% (b)  Eine formale Notation ist die folgende
%
%       {\fontname{Courier}f(a,b,c) = a}    fr    {\fontname{Courier}c = 0 ;  f(a,b,c) = b}    fr   {\fontname{Courier}c = 1}
%
% (c)  Programmiersprachen dienen der Realisierung von Anwendungen auf dem Rechner.
%       Hardwareentwurfssprachen sind dagegen so konzipiert, dass das Verhalten 
%       von Systemen beschrieben werden kann, ohne dass einer Realsierung vorgegriffen 
%       wird.  Der Multiplexer ist aber ein sehr einfaches Beispiel, dass wir hier 
%       als Definition einer ablauffhigen MATLAB-Funktion schreiben wollen:
%
mux = inline('(a&~c)|(b&c)', 'a','b','c')   % Definition der Schaltfunktion  mux(a,b,c) in MATLAB
%
%       Nach diesem Aufruf ist die Schaltfunktion  {\fontname{Courier}mux}  dem System bekannt und kann benutzt werden:
%
z = 0;
for i=0:1
   for j=0:1  
      for k=0:1 
         z = z + 1;
         tabelle(z,:) = [i  j  k  mux(i,j,k)];
      end
   end
end
result2fig(tabelle)
%
%
%
%
%       Eine sehr verbreitete Hardware-Beschreibungssprache ist VHDL.  Der Multiplexer
%       wird hierin wie folgt beschrieben:
%
%
%
%
% library ieee; use ieee.std\_logic\_1164.all        %<'FontName',MSVFORMFONT>
% -------------------------------------------------  %<'FontName',MSVFORMFONT>
% entity mux2 is                                     %<'FontName',MSVFORMFONT>
%    port(sel, d0, d1: in std\_ulogic;               %<'FontName',MSVFORMFONT>
%         z: out std\_ulogic);                       %<'FontName',MSVFORMFONT>
% end entity mux2;                                   %<'FontName',MSVFORMFONT>
% -------------------------------------------------  %<'FontName',MSVFORMFONT>
% architecture demo of mux2 is                       %<'FontName',MSVFORMFONT>
% begin                                              %<'FontName',MSVFORMFONT>
%    out\_select: process(sel, d0, d1) is            %<'FontName',MSVFORMFONT>
%    begin                                           %<'FontName',MSVFORMFONT>
%       case sel is                                  %<'FontName',MSVFORMFONT>
%          when 0 =>                                 %<'FontName',MSVFORMFONT>
%             z <= d0;                               %<'FontName',MSVFORMFONT>
%          when 1 =>                                 %<'FontName',MSVFORMFONT>
%             z <= d1;                               %<'FontName',MSVFORMFONT>
%       end case;                                    %<'FontName',MSVFORMFONT>
%    end process out\_select;                        %<'FontName',MSVFORMFONT>
% end architecture demo;                             %<'FontName',MSVFORMFONT>
%
%
%
%
% (d)  Der Multiplexer kann als schaltalgebraischer Ausdruck z.B. in folgender Form
%       geschrieben werden:
%
%       {\fontname{Courier}a\capc' \cup b\capc}
%
%       Ein solcher Ausdruck kann bei entsprechender Syntax auch als Berechnungsvorschrift 
%       dienen.
%
% (e)  Die Funktionstabelle fr den Multiplexer ist
%
binexp2bintab('(a&~c)|(b&c)',{'a';'b';'c'},2)
%
%       Mit der Reihenfolge der Variablen ndert sich die uere Form der Tabelle:
%
binexp2bintab('(a&~c)|(b&c)',{'c';'a';'b'},2)
%
%