%
%
%7.3.2  Graphische Beschreibung%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Bei den graphischen Beschreibungen von Schaltfunktionen unterscheiden wir
%
% (a)  Baumartige Beschreibungen
% (b)  Tabellenartige Beschreibungen
% (c)  Kontaktnetze
% (d)  Schaltbilder
%
% Wir wollen sie der Reihe nach besprechen:
%
% (a)  Entscheidungsbume werden meist mit dem Stamm oben und den Blttern unten 
%       gezeichnet.  Um den Funktionswert fr einen vorgegebenen Satz von Variablen 
%       zu finden, beginnt man beim Stamm und steigt (abwrts!) in die Verzeigungen.
%       Welcher Weg bei einer Verzweigung weiter verfolgt wird, bestimmt jeweils 
%       der Wert einer der Variablen.  Bei den folgenden Entscheidungsbumen ist 
%       an allen Knoten der linke (rote) Zweig im Falle einer  {\fontname{Courier}0}  und der rechte (grne) 
%       im Falle einer  {\fontname{Courier}1}  zu whlen.  Sehr einfache Beispiele sind folgende:
%
% Identitt:
bintreegraph(bintab2bintree(binexp2bintab('a',{'a'})),{'a'})
%
% Inversion:
bintreegraph(bintab2bintree(binexp2bintab('~a',{'a'})),{'a'})
%
% UND:
bintreegraph(bintab2bintree(binexp2bintab('a&b',{'a';'b'})),{'a';'b'})
%
%       Wenn die Entscheidungsknoten der einzelnen Variablen in allen sten auf 
%       der selben Ebene geordnet sind, sprechen wir von einem geordneten binren 
%       Entscheidungsbaum.  Ein vollstndiger Entscheidungsbaum fr eine 
%       Schaltfunktion von  {\fontname{Courier}n}  Variablen hat  {\fontname{Courier}2^n}  Bltter.  Fr den Multiplexer 
%       ergibt sich:
%
bintreegraph(bintab2bintree(binexp2bintab('(a&~c)|(b&c)',{'a';'b';'c'})),{'a';'b';'c'})
%
%       Sind an einem Entscheidungsknoten beide Zweige gleich, so kann man den Knoten 
%       und einen der Zweige weglassen und erhlt den reduzierten binren Entscheidungsbaum:
%
bintree('(a&~c)|(b&c)',{'a';'b';'c'})
%
%       Die Anzahl der erforderlichen Knoten in einem reduzierten binren Entscheidungsbaum 
%       hngt von der Reihenfolge der Variablen ab.  Dies ist im folgenden Beispiel mit 5 
%       Variablen gut zu sehen:
%
bintree('((a&~c)|(b&c))&d|e',{'a';'b';'c';'d';'e'})
%
bintree('((a&~c)|(b&c))&d|e',{'e';'a';'b';'c';'d'})
%
bintree('((a&~c)|(b&c))&d|e',{'e';'d';'a';'b';'c'})
%
%       Unter Verzicht auf die organisatorisch und graphisch einfache Baumstruktur lassen 
%       sich gleiche Zweige auch dann vereinigen, wenn sie nicht an dem selben Knoten 
%       hngen.  Diese sog.  Reduced Ordered Binary Decision Diagrams (OBDDs) haben 
%       Bedeutung erlangt beim Entwurf digitaler Systeme.  Ein entscheidender Vorteil der 
%       reduzierten graphischen Beschreibungen ist ihre wesentlich geringere Komplexitt 
%       gegenber der exponentiell mit der Zahl der Variablen ansteigenden Komplexitt der 
%       Funktionstabelle und damit auch der Vektor-Beschreibung.  Wir gehen hier jedoch 
%       nicht tiefer darauf ein.
%
%       Es gibt weitere graphische Darstellungen von Schaltfunktionen, z.B. den Kantorovic-
%       Baum und das Datenfluss-Diagramm.  Sie sind aber nicht verbreitet.  Zwei weitere 
%       graphische Darstellungsformen werden wir spter betrachten, nmlich Schaltbilder 
%       und Kontaktnetze.
%