%
%
%7.3.4  Kanonische Normalformen%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-2,'Color',MSVTITLCOLOR>
%
%
%
% Eine  {\bfkanonische Normalform}  ist eine Form, in die jede Funktion eindeutig gebracht werden kann. 
%
% Wichtig sind folgende Normalformen:
%
% \bfDisjunktive Normalform (DNF)
%
% \bfKonjunktive Normalform (KNF)
%
% \bfReed-Muller-Form (RMF)
%
% Es ist blich die DNF bzw. die KNF aus sog. Mintermen bzw. Maxtermen aufzubauen.  
% Minterme wurden schon unter der Bezeichnung Einspunktfunktion definiert:
%
% {\bfDef.}  {\fontname{Courier}m\inT_n}  heit  {\bfMinterm} , wenn es genau ein  {\fontname{Courier}x\inB^n}  gibt,  so dass  
% {\fontname{Courier}m(x) = 1}   und   {\fontname{Courier}m(y) = 0   \forally\inB^n,  y\neqx} .
%
% {\fontname{Courier}M\inT_n}  heit  {\bfMaxterm} , wenn es genau ein  {\fontname{Courier}x\inB^n}  gibt,  so dass  
% {\fontname{Courier}M(x) = 0}   und   {\fontname{Courier}M(y) = 1   \forally\inB^n,  y\neqx} .
%
% In  {\fontname{Courier}T_n}  gibt es genau  {\fontname{Courier}2^n}  Minterme und  {\fontname{Courier}2^n}  Maxterme.
%
% Beispiel :  {\fontname{Courier}T_3}    Tabellen fr alle Minterme und Maxterme {\fontname{Courier}m_1 ... m_8 ; M_1 ... M_8}
%
% a b c  |  m_1 m_2 m_3 m_4 m_5 m_6 m_7 m_8     M_1 M_2 M_3 M_4 M_5 M_6 M_7 M_8 %<'FontName',MSVFORMFONT>
% \_\_\_\_\_\_\_|\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_\_ %<'FontName',MSVFORMFONT>
% 0 0 0  |  1  0  0  0  0  0  0  0     0  1  1  1  1  1  1  1  %<'FontName',MSVFORMFONT>
% 0 0 1  |  0  1  0  0  0  0  0  0     1  0  1  1  1  1  1  1  %<'FontName',MSVFORMFONT>
% 0 1 0  |  0  0  1  0  0  0  0  0     1  1  0  1  1  1  1  1  %<'FontName',MSVFORMFONT>
% 0 1 1  |  0  0  0  1  0  0  0  0     1  1  1  0  1  1  1  1  %<'FontName',MSVFORMFONT>
% 1 0 0  |  0  0  0  0  1  0  0  0     1  1  1  1  0  1  1  1  %<'FontName',MSVFORMFONT>
% 1 0 1  |  0  0  0  0  0  1  0  0     1  1  1  1  1  0  1  1  %<'FontName',MSVFORMFONT>
% 1 1 0  |  0  0  0  0  0  0  1  0     1  1  1  1  1  1  0  1  %<'FontName',MSVFORMFONT>
% 1 1 1  |  0  0  0  0  0  0  0  1     1  1  1  1  1  1  1  0  %<'FontName',MSVFORMFONT>
%
% {\bfDef.}  Sei  {\fontname{Courier}f\inT_n}  und  {\fontname{Courier}f_i} seien die Elemente der Funktionstabelle 
% von  {\fontname{Courier}f  (i = 1,...,2^n)} .  Dann ist
%      2^n                               %<'FontName',MSVFORMFONT>
% f = _{\fontsize{26}\cup} f_i\capm_i   =  f_1\capm_1 \cup f_2\capm_2 \cup f_3\capm_3 \cup ...   %<'FontName',MSVFORMFONT>
%     i=1                                %<'FontName',MSVFORMFONT>
%
% die  {\bfdisjunktive Normalform (DNF)}  und 
%      2^n                               %<'FontName',MSVFORMFONT>
% f = _{\fontsize{26}\cap} f_i\cupM_i   =  (f_1\cupM_1) \cap (f_2\cupM_2) \cap (f_3\cupM_3) \cap ...     %<'FontName',MSVFORMFONT>
%     i=1                                %<'FontName',MSVFORMFONT>
%
% die  {\bfkonjunktive Normalform (KNF)}  von  {\fontname{Courier}f} .
%
% Bei der Konjunktiven Normalform beachte man, dass aus  {\fontname{Courier}f_i = 1}  folgt:  
% {\fontname{Courier}f_i\cupm_i = 1\cupM_i = 1} .   Diese Terme knnen also weggelassen werden. 
% Nur die Terme mit  {\fontname{Courier}f_i = 0}  verbleiben in der konjunktiven Normalform.
%
%
% Die  {\bfReed-Muller-Form (RMF)}  von  {\fontname{Courier}f}  ist
%
%     2^n                               %<'FontName',MSVFORMFONT>
% f = _{\fontsize{26}\Sigma} r_i*p_i    %<'FontName',MSVFORMFONT>
%     i=1                               %<'FontName',MSVFORMFONT>
%
% wo das Symbol  {\fontname{Courier}\Sigma}  die wiederholte Addition im  GF(2) bedeutet.
% {\fontname{Courier}r_i\inB}  sind Koeffizienten und  {\fontname{Courier}p_i}  die rekursiv definierten Basisfunktionen
%
% p_1 = 1;                      %<'FontName',MSVFORMFONT>
% ----------------------------  %<'FontName',MSVFORMFONT>
% p_2 = p_1*x_1 = x_1           %<'FontName',MSVFORMFONT>
% ----------------------------  %<'FontName',MSVFORMFONT>
% p_3 = p_1*x_2 = x_2           %<'FontName',MSVFORMFONT>
% p_4 = p_2*x_2 = x_1*x_2       %<'FontName',MSVFORMFONT>
% ----------------------------  %<'FontName',MSVFORMFONT>
% p_5 = p_1*x_3 = x_3           %<'FontName',MSVFORMFONT>
% p_6 = p_2*x_3 = x_1*x_3       %<'FontName',MSVFORMFONT>
% p_7 = p_3*x_3 = x_2*x_3       %<'FontName',MSVFORMFONT>
% p_8 = p_4*x_3 = x_1*x_2*x_3   %<'FontName',MSVFORMFONT>
% ----------------------------  %<'FontName',MSVFORMFONT>
% p_9 = p_1*x_4 = x_4           %<'FontName',MSVFORMFONT>
% usw.                          %<'FontName',MSVFORMFONT>
%
% Die  {\fontname{Courier}x_i}  sind die Variablen der Funktionen.  Mit dem Infixsymbol  {\fontname{Courier}*}  ist die 
% Multiplikation im  GF(2) also das  UND  gemeint.
%
% Diese Basisfunktionen lassen sich automatisch erzeugen (hier mit den Variablen 
% a, b, c, ...):
%
rmbasis(1)
%
rmbasis(3)
%
rmbasis(5)
%