%
%
%8.3.1  Modelle %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Bei der Betrachtung von Schaltfunktionen kommt der Begriff der Zeit nicht vor. 
% Die technische Reprsentation einer Schaltfunktion soll jedoch im zeitlichen 
% Nacheinander fr verschiedene Argumente den Funktionswert liefern.  Anstelle 
% einer Schaltfunktion  
%
%        f : B^n  \rightarrow  B     %<'FontName',MSVFORMFONT>
%
% mssen wir also betrachten:
%
%        f : S^n  \rightarrow  S  , wo    S = \{ s | s : T  \rightarrow  B\}    %<'FontName',MSVFORMFONT>
%
% Hier steht  {\fontname{Courier}T}  fr die reelle Zeit.
%
% Das Zeitverhalten ist stark von der physikalischen Realisierung abhngig und 
% berdies selbst bei festgelegter Realisierung nicht genau vorhersagbar. 
% Dennoch wollen wir das Zeitverhalten von logischen Verknpfungen und 
% Schaltnetzen so weit wie mglich schon auf der in diesem Kapitel relevanten 
% Abstraktionsebene modellieren.  Dazu definieren wir zunchst die zeitliche 
% Verzgerung:
% 
% Def.   Sei  {\fontname{Courier} S = \{ s | s : T  \rightarrow  B\} } ,  wo  {\fontname{Courier}T}  fr die reelle Zeit steht.  
% Dann heit  {\fontname{Courier} g : S  \rightarrow  S }  {\bfVerzgerung}  (delay)  um die Zeit  {\fontname{Courier}\tau} , 
% wenn  fr alle  {\fontname{Courier} x\inS }  und  {\fontname{Courier} y = g(x) }  gilt:   {\fontname{Courier} y(t + \tau) = x(t)} .
%
% Das folgende Bild stellt als Beispiel ein Signal und eine Verzgerung des 
% Signals dar:
%
delaygraph
%% Bei gedrckter Maus wird der Mauszeiger zu einem Fadenkreuz.
%
%
% Ein Modell soll sein:
%
% (1)   so einfach wie mglich
% (2)   so detailliert wie ntig
%
% Wir betrachten zwei Modelle des Zeitverhaltens von Schaltfunktionen:
%
% {\bf1. Das fundamentale Modell}
%
% In diesem Modell wird nur eine Verzgerung am Ausgang der Schaltfunktion  {\fontname{Courier}f}
% angenommen:   {\fontname{Courier}y(t+\tau) = f(x(t))} .
% Dieses Modell ist dann ausreichend, wenn das Ausgabesignal des Schaltnetzes 
% im Zeitintervall von der letzten nderung der Eingabe bis zum Ablauf der 
% nachfolgenden Verzgerung irrelevant ist.
%
% {\bf2. Das Gattermodell}
%
% Fr jede Verknpfung innerhalb der Realisierung der Schaltfunktion wird
% eine individuelle Verzgerung angenommen.  
%
% Auch im Fall des Gattermodells kann man das logische Verhalten vom 
% Zeitverhalten trennen.  Dazu muss man das Verzgerungsverhalten aller 
% logischen Verknpfungen in ein verzgertes Ablesen der Inputvariablen 
% transformieren: 
%
% y(t+\tau) = g(x_1(t),x_2(t))  =>  y(t) = g(x_1(t-\tau),x_2(t-\tau))  %<'FontName',MSVFORMFONT>
% 
% Auf diese Weise gelingt es, Schaltnetze weiterhin als verzgerungsfreie 
% Bndel mathematischer Funktionen zu modellieren, deren Inputvariable jedoch 
% individuell zeitversetzte Signale sind.  Dabei hat jedes Vorkommen der selben 
% Variablen im schaltalgebraischen Ausdruck eine individuelle Verzgerung.
% Sei z.B. in der Schaltfunktion
% 
% a' \cup (a\capb') \cup b  %<'FontName',MSVFORMFONT>
%
% die Verzgerung der UND-Verknpfung  {\fontname{Courier}\tau_1}  und die der ODER-Verknpfung  {\fontname{Courier}\tau_2} ,
% so ergibt sich
%
% y(t) = a(t-\tau_2)' \cup (a(t-\tau_1-\tau_2)\capb(t-\tau_1-\tau_2)') \cup b(t-\tau_2)  %<'FontName',MSVFORMFONT>
%
% Tatschlich ist die hier gewhlte Schaltfunktion identisch mit der konstanten 
% Eins, also vllig unabhngig von den Argumenten  {\fontname{Courier}a}  und  {\fontname{Courier}b} .  Dennoch kann man 
% natrlich diese nicht minimale Form des Ausdrucks realisieren.  Wir werden weiter 
% unten und speziell im folgenden Abschnitt sehen, dass das Zeitverhalten verschiedener 
% Realisierungen der selben zugrundeliegenden Schaltfunktion verschieden ist.  Deshalb
% kann auch die Ausgabe einer Realisierung der konstanten Funktion durchaus von der 
% Konstanten abweichen. 
% 
% Die Ausdrcke sind deutlich bersichtlicher und vor allem leichter automatisch zu
% behandeln bei systematischer Klammerung ohne Przedenzregeln und ausschlielicher 
% Benutzung der Prfix-Notation.  Anstelle der Infixsymbole  {\fontname{Courier}\cap  &  *}  wird nachfolgend 
% hufig die Funktion  {\fontname{Courier}all}  benutzt, die als Parameter einen Vektor hat (mit eckigen Klammern), 
% in dem smtliche Eingabevariablen verzeichnet sind.  Die entsprechende Funktion fr das 
% ODER ( {\fontname{Courier}\cup  |} ) ist  {\fontname{Courier}any} .  Diese Schreibweise mit einem Vektor als Variable ist auch 
% mathematisch prziser, denn die Schaltfunktionen sind ja definiert als  {\fontname{Courier}f : B^n \rightarrow B} ,
% Argument der Funktion ist also ein Vektor  {\fontname{Courier}\inB^n} .  Die im vorigen Beispiel benutzte 
% Funktion notiert sich damit wie folgt:
%
binexpr2prefix('~a&(b|c)')
%
% Die Funktionstabelle ist
%
binexp2bintab( '~a&(b|c)' , {'a';'b';'c'} , 2 )
%
% Wir weisen nun den Verknpfungen in der Reihenfolge ihres Auftretens in dem 
% Baum-artigen Ausdruck Verzgerungen zu.  Diese sind als Vektor von natrlichen 
% Zahlen als zweite Parameter der Funktion  {\fontname{Courier}drawdelay}  anzugeben.  Wir betrachten 
% das Zeitverhalten fr das spezielle Inputsignal, das die Bitmuster der Funktionstabelle 
% der Reihe nach von oben nach unten fr jeweils 10 Zeiteinheiten anlegt:
%
drawdelay('~a&(b|c)' , [1 1] )
%
% Offenbar entspricht das Ausgabesignal nicht genau der Funktionstabelle.  Wir 
% werden dieses Problem im folgenden Abschnitt ber Hasards behandeln.
%
% Im Falle des fundamentalen Modells wird nur eine pauschale Verzgerung angenommen.
% Wir modellieren diese als Verzgerung der Wurzel des Ausdrucks und setzen alle 
% anderen Verzgerungen auf Null:
%
drawdelay( '~a&(b|c)' , [2 0] );  % Zeitdiagramm
%
% Bei Benutzung des fundamentalen Modells tritt der Hasard nicht in Erscheinung. 
% Auerdem ist hier die fallende Flanke des Ausgabesignals strker verzgert 
% als im Falle des Gattermodells.
%
% Das Gattermodell ist zwar deutlich komplizierter, lst dafr aber Feinheiten 
% des zeitlichen Verhaltens auf.
%
% Wir kommen noch einmal auf die oben besprochene umstndliche Realisierung einer 
% konstanten Eins im Gattermodell zurck:
%
drawdelay( '~a|(a&a)' , [1 1] );  % Zeitdiagramm
%
% Diese Realisierung wandelt jede steigende Flanke des Inputsignals in einen 
% inversen Impuls.