%
%
%8.3.2  Hasards %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Wir betrachten das Zeitverhalten folgender Funktion:
%
% {\fontname{Courier}'(a|b)&(~b|c )'}
%
% Zunchst wandeln wir den Ausdruck in Prfix-Notation:
%
binexpr2prefix( '(a|b)&(~b|c )' )
%
% Fr das Gattermodell weisen wir in der Reihenfolge des Auftretens der Verknpfungen
% im schaltalgebraischen Ausdruck der Funktion diesen Verknpfungen je eine Verzgerung 
% zu, z.B.
%
% {\fontname{Courier}dly = [1 1 2]}
%
% Dann ergibt sich fr ein zuflliges Inputmuster die rot dargestellte Ausgabe 
% der Funktion:
%
drawdelay( ...                          % Aufruf der Darstellungsfunktion
           '(a|b)&(~b|c )' , ...        % schaltalgebraischer Ausdruck
           [1 1 2] , ...                % Verzgerungen
           [ nfach(randb(50),10) ;...   % Inputsignal fr a
             nfach(randb(50),10) ;...   % Inputsignal fr b
             nfach(randb(50),10) ]);    % Inputsignal fr c                           
%
%% Wiederholen Sie dies mehrfach!
%% Die Ausgabe zeigt an einigen Stellen ein besonderes Verhalten.  Welches ?
%% Geben Sie die Bedingung an, unter der dies auftritt.
%
% Wir tauschen die Werte der Verzgerungen der beiden ODER-Glieder und erhalten:
%
drawdelay( ...                          % Aufruf der Darstellungsfunktion
           '(a|b)&(~b|c )' , ...        % schaltalgebraischer Ausdruck
           [1 2 1] , ...                % Verzgerungen
           [ nfach(randb(50),10) ;...   % Inputsignal fr a
             nfach(randb(50),10) ;...   % Inputsignal fr b
             nfach(randb(50),10) ]);    % Inputsignal fr c                           
%
% Das merkwrdige Verhalten tritt nun an anderer Stelle auf.  Wann ?
%
% Wir benutzen jetzt das einfachste Signal, bei dem der Effekt auftritt:
%
drawdelay( ...                          % Aufruf der Darstellungsfunktion
           '(a|b)&(~b|c )' , ...        % schaltalgebraischer Ausdruck
           [1 1 2] , ...                % Verzgerungen
           [ zeros(1,20) ;...           % Inputsignal fr a identisch 0
             zeros(1,8) ones(1,12) ;... % Inputsignal fr b
             zeros(1,20) ]);            % Inputsignal fr c identisch 0                          
%
%
% Wir definieren:
%
% Ein  {\bfHasard}  ist die Eigenschaft einer Schaltfunktion bei bestimmten
% Kombinationen der individuellen Verzgerungen ihrer Verknpfungsglieder ein 
% Fehlverhalten zu zeigen.
%
% Ein  {\bfHasardfehler}  ist das aktuelle Fehlverhalten einer realisierten 
% Schaltfunktion aufgrund eines Hasards.
%
% \bfKlassifikation von Hasards
%
% (1)    nach der Erscheinungsform am Ausgang:
%
%         (1a)  statisch:   eigentlich soll sich gar nichts ndern
%
%         (1b)  dynamisch:  es soll eigentlich genau eine Flanke geben
%
% (2)    nach den Bedingungen am Eingang, unter denen sie auftreten:
%
%         (2a)  Ein  Strukturhasard  ist ein Hasard, der durch die Flanke 
%                 einer einzigen Eingangsvariablen auftritt. 
%
%         (2b)  Ein  Funktionshasard  ist ein Hasard, der erst bei zwei 
%                 gleichzeitigen Flanken von wenigstens zwei Eingangsvariablen 
%                 auftritt. 
%
% Nachfolgend sind die Erscheinungsformen abgebildet 
% (auch hier sind die Signale als Funktionen vordefiniert):
%
drawbinsigs(static1hasard,'statischer 1-Hasard',{'korrektes Signal';'Hasard'})
%
drawbinsigs(static0hasard,'statischer 0-Hasard',{'korrektes Signal';'Hasard'})
%
drawbinsigs(dynamic0hasard,'dynamischer 0-Hasard',{'korrektes Signal';'Hasard'})
%
drawbinsigs(dynamic1hasard,'dynamischer 1-Hasard',{'korrektes Signal';'Hasard'})
%
% Strukturhasards treten schon bei einschrittigen nderungen des Inputsignals auf.
% Diese einschrittigen nderungen entsprechen den Nachbarschafts-Schritten im
% KV-Diagramm.  Schleifen sind als je ein Gatter realisiert.  Ein Schritt innerhalb 
% einer Schleife ndert also an keinem Gatterausgang etwas.  Fr einen Schritt 
% auerhalb von Schleifen gilt das selbe.  Ein Schritt von einer Schleife zu 
% einer benachbarten Schleife ist kritisch.  Wenn nmlich das Gatter, welches 
% zunchst die 1 liefert, bei der Inputnderung schneller auf 0 schaltet als 
% das fr den neuen Input zustndige Gatter auf 1, dann geht die Ausgabe fr 
% die kurze bergangszeit auf Null.  Dadurch entsteht also ein statischer Hasard.
%
% Die Situation ist fr ein Beispiel nachfolgend dargestellt:
%
kvdiagram('(a&~b)|(b&c)',{'a';'b';'c'},[0 0],{[6 5] [4 8]},1)
%
% Zwischen den Inputwerten  {\fontname{Courier}[a b c] = [1 0 1] \leftrightarrow [1 1 1]}  liegt ein Hasard vor.
% Wir prfen dies, indem wir die Ausgabe bei diesem kritischen bergang fr 30 
% zufllige Kombinationen der Verzgerungen berechnen und die Bilder dann im 
% schnellen Wechsel anschauen:
%
hasarddemo2( '(a&~b)|(b&c)' );
%
% Da es sich bei dem kritischen bergang um den bergang zwischen benachbarten 
% Einsen im KV-Diagramm handelt, kann man den Hasard beseitigen durch eine 
% zustzliche Schleife:
%
kvdiagram('(a&~b)|(b&c)|(a&c)',{'a';'b';'c'},[0 0],{[6 5] [4 8] [6 8]},3)
%
% Tatschlich tritt kein Hasardfehler mehr auf:
%
hasarddemo2( '(a&~b)|(b&c)|(a&c)' );
%
% Dieser Typ von Hasard heit Struktur-Hasard, weil er durch strukturelle 
% Manahmen bei der Realisierung beseitigt werden kann.  Die Funktionshasards,
% die bei nicht-einschrittigen bergngen auftreten, sind dagegen unvermeidlich.
%
