%
%
%9.1  Schaltwerkmodelle %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Def.  {\bfSchaltwerke} sind Realisierungen von schaltalgebraischen Ausdrcken, in 
% denen Rckkopplungen vorkommen.  Dadurch sind diese Ausdrcke nicht mehr so 
% umformbar, dass die Ausgabevariablen durchweg als Funktionen der Inputvariablen 
% erscheinen.  Wenigstens an einer Stelle hngt die Ausgabe einer logischen Verknpfung 
% ausser von den momentanen Werten der Inputvariablen auch von seiner Ausgabe ab.  
% Mathematisch kann dies zum Widerspruch fhren oder zu mehrdeutigen Lsungen. 
% Die einfachsten Flle ohne Inputvariablen sind:
%
% Widerspruch:{\fontname{Courier}     x = x'}
%
% Mehrdeutigkeit:{\fontname{Courier}   x = (x')'}
%
% Ein Beispiel mit zwei Inputvariablen ist:
%
% {\fontname{Courier}x = (a\capy)' ;  y = (b\capx)'}
%
% Wegen der Rckkopplungen kann das Verhalten von Schaltwerken nur unter 
% Bercksichtigung des Zeitverhaltens der Verknpfungen beschrieben werden. 
% Schon bei Schaltwerken aus wenigen Verknpfungen wird das unberschaubar.
%
% Man modelliert Schaltwerke durch ein zeitloses Schaltnetz und Rckkopplungen, 
% die ber Zeitglieder laufen:
%
drawswmodell
%
% Zwei prinzipiell verschiedene Zeitglieder werden dabei betrachtet, die zu 
% grundstzlich verschiedenen Schaltwerken fhren: 
%
% (1)  Verzgerungen     \rightarrow     {\bfNichtgetaktete Schaltwerke}
%
% (2)  Getaktete Zeitglieder   \rightarrow   {\bfGetaktete Schaltwerke}
%
% Man benutzt nur wenige Typen der nicht-getakteten Schaltwerke (sog. Flipflops) 
% aus meistens 4 bis 6 logischen Verknpfungen, deren Verhalten wir im nchsten 
% Kapitel 10 behandeln.  Getaktete Schaltwerke sind auch bei hoher Komplexitt 
% prinzipiell beherrschbar.  Sie werden aus Schaltnetzen und getakteten Zeitgliedern 
% aufgebaut.  Die getakteten Zeitglieder selbst bestehen aus nicht-getakteten 
% Schaltwerken (Flipflops).
%
% Das Schaltnetz innerhalb des Schaltwerks berechnet einerseits die Ausgabe und 
% andererseits jene logischen Werte, die ber die Zeitglieder wieder auf den 
% Eingang des Schaltnetzes zurckgefhrt werden.  Letztere bezeichnen wir als 
% den Zustand bzw. den Folgezustand.  Es ist sinnvoll, die beiden Teile des 
% Schaltnetzes im Modell zu trennen in zwei Schaltnetze.  Dies soll nur die 
% bersichtlichkeit frdern.  Bei einer Realisierung wrde man selbstverstndlich 
% eine Bndelminimierung beider Schaltnetze zusammen vornehmen.
%
% Bei der Auftrennung ist zu unterscheiden, ob die Ausgabe direkt vom Input 
% abhngt oder nur vom Zustand.  Dem entsprechend gibt es zwei Modelle:
%
% {\bfMoore-Modell} :  die Ausgabe hngt nur vom Zustand ab
%
% {\bfMealy-Modell} :  die Ausgabe hngt vom Zustand und vom momentanen Input ab
%
% Die Modelle werden in folgendem Bild graphisch dargestellt.  Zwischen den 
% Modellen kann mit Mausklick gewechselt werden.
%
drawmealymoore
%
% Folgende Bezeichnungen sind blich:
%
% (a)  Ausgabefunktion   {\fontname{Courier}y = \lambda(z)}  (Moore)   bzw.  {\fontname{Courier}y = \lambda(z,x)}  (Mealy)
%
% (b)  berfhrungsfunktion  {\fontname{Courier}z_{next} = \delta(z,x)}  (Moore und Mealy)
%
% Zum Schaltwerkmodell gehrt natrlich wesentlich die Angabe der Art der Zeitglieder.
%